       PROGRAM adelgazar
c Thinning the data of a given dispersion curve
c
C driver for routine splint, which calls spline
       parameter(ndata0=2000,np0=5000,nf0=100)
       REAL fr(ndata0),xa(ndata0),x2(ndata0),
     *      f(nf0),ya(nf0),yb(nf0)
       character filen*80
c
       filen='./cca_wkf/data/results/dispersion.dat'
       write(6,'(a28,a37)')'Input dispersion curve from ',filen
       open(3,file=filen,status='old')
       read(3,*)           ! skip one line(header)
       do idata=1,ndata0
        read(3,*,err=10,end=10)fr(idata),xa(idata)
        write(6,'(i3,2f10.3)') idata,fr(idata),xa(idata)
       enddo
   10  close(3)
       write(6,*)'++++++++++++++++++++++++++++++++++++++++'
       ndata=idata-1
       write(6,'(a11,i5,a8)')'Originally ',ndata,' samples'
       write(6,*)
       fmin=max(    fr(1),0.01)
       fmax=min(fr(ndata), 20.)
C call SPLINE to get second derivatives
       call spline(fr,xa,ndata,ndata0,fmin,fmax,x2)
c
      df=10**(alog10(fmax/fmin)/real(nf0-1))
      do ifr=1,nf0
       f(ifr)=fmin*(df**real(ifr-1))
      enddo
c     write(6,'(f10.3)')(f(ifr),ifr=1,nf0)
C call SPLINT for interpolations
      do ifr=1,nf0
       call splint(fr,xa,x2,ndata,ndata0,f(ifr),y)
       ya(ifr)=y
      enddo
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c smoothing by moving average (7 points)
      yb(1)=ya(1)
      yb(2)=(ya(1)+ya(2)+ya(3))/3.
      yb(3)=(ya(1)+ya(2)+ya(3)+ya(4)+ya(5))/5.
c
      do i=4,nf0-3
       sum=0
       do j=-3,3
        sum=sum+ya(i-j)
       enddo
       yb(i)=sum/7.
      enddo
c
      yb(nf0-2)=(ya(nf0-4)+ya(nf0-3)+ya(nf0-2)+ya(nf0-1)+ya(nf0))/5.
      yb(nf0-1)=(ya(nf0-2)+ya(nf0-1)+ya(nf0))/3.
      yb(nf0)=ya(nf0)
      write(6,'(a)')'Smooting by 7 points moving average performed.'
      write(6,*)
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      filen='./cca_wkf/data/results/dispersion_thinned.dat'
      write(6,'(a27,a37)')'Output dispersion curve to ',filen
      open(3,file=filen,status='unknown')
      write(3,'(2a14)')'Frequency(Hz) ','Velocity(m/s) '
      do ifr=1,nf0
       write(3,'(f13.5,1x,f13.5)')f(ifr),yb(ifr)
       write(6,'(i3,f13.5,1x,f13.5)')ifr,f(ifr),yb(ifr)
      enddo
      close(3)
      stop
      end
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE spline(x,y,n,n0,yp1,ypn,y2)
       INTEGER n,n0,NMAX
       REAL yp1,ypn,x(n0),y(n0),y2(n0)
       PARAMETER (NMAX=2000)
       INTEGER i,k
       REAL p,qn,sig,un,u(NMAX)
       if (yp1.gt..99e30) then
         y2(1)=0.
         u(1)=0.
       else
         y2(1)=-0.5
         u(1)=(3./(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
       endif
       do 11 i=2,n-1
         sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
         p=sig*y2(i-1)+2.
         y2(i)=(sig-1.)/p
         u(i)=(6.*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1))/
     *        (x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*u(i-1))/p
11    continue
       if (ypn.gt..99e30) then
         qn=0.
         un=0.
       else
         qn=0.5
         un=(3./(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
       endif
       y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.)
       do 12 k=n-1,1,-1
         y2(k)=y2(k)*y2(k+1)+u(k)
12    continue
       return
       END
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE splint(xa,ya,y2a,n,n0,x,y)
       INTEGER n
       REAL x,y,xa(n0),y2a(n0),ya(n0)
       INTEGER k,khi,klo
       REAL a,b,h
       klo=1
       khi=n
1     if (khi-klo.gt.1) then
         k=(khi+klo)/2
         if(xa(k).gt.x)then
           khi=k
         else
           klo=k
         endif
       goto 1
       endif
       h=xa(khi)-xa(klo)
       if (h.eq.0.) then
        write(6,*)'Bad xa input in splint. Termination.'
        stop
       endif
       a=(xa(khi)-x)/h
       b=(x-xa(klo))/h
       y=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+
     *                        (b**3-b)*y2a(khi))*(h**2)/6.
       return
       END

