      program ch_pivot
      parameter(nmax=1200000,nch0=15)
      real      x(nmax,nch0)
      integer   pv(nch0)
      character filem*80,filen*80,cout*12,cform1*15,
     *          cform2*15
      character cdrv*10,cwkf*80,comment*50,cunit*5
c root folder name
      data cdrv/'./cca_wkf/'/ 
c working folder name
      cwkf=cdrv//'prm/'
      write(6,*)' Working Folder=',cwkf(1:14)
c     
      filen=cwkf(1:14)//'ch_pivot.prm'
      write(6,*)filen
      open(2,file=filen,status='old')       ! parameter file
      read(2,*) mch
      read(2,*) (pv(j),j=1,mch)             ! pivot list
      close(2)
c
      cwkf=cdrv//'data/'//'multiplexed_files/'
      filen=cwkf(1:33)//'mltfile.lst'
      write(6,*)filen
      open(2,file=filen,status='old')       ! file list
      do ifile=1,10000
       read(2,*,end=999)filem
       filen=cwkf(1:33)//filem
       write(6,*)filen
       open(1,file=filen,status='old')      ! input
       filem(1:1)='r'
       filen=cwkf(1:33)//filem
c      write(6,*)filen
       open(3,file=filen,status='unknown')  ! output(pivoted)
c header
       read (1,*) nch,dt,scale,ndur0,cunit
       if(nch.ne.mch) then
        write(6,*)'Error in channel numbers'
        stop
       endif
       write(3,'(i8,f8.4,e16.4,i8,2x,a5)')nch,dt,scale,ndur0,cunit
c      write(6,'(i8,f8.4,e16.4,i8,2x,a5)')nch,dt,scale,ndur0,cunit
       read (1,'(a50)')comment
       write(3,'(a50)')comment
c      write(6,'(a50)')comment
       if(ifile.eq.1) then
        nsamp=nint(1./dt)
        call formatter(nch,cform1,cform2)
c       write(6,*)nsamp
c       write(6,*)cform2
       endif
c data
       do i=1,ndur0
        read (1,cform2,end=888)adum,(x(i,j),j=1,nch)
       enddo
  888  continue
       do i=1,ndur0
        write(3,cform2)real(i-1)/real(nsamp),
     *                          (x(i,pv(j)),j=1,nch)
       enddo
       close(1)
       close(3)
      enddo
  999 close(2)
      stop
      end
c+++++
      subroutine formatter(nch,cform1,cform2)
      character cform1*15,cform2*15
      if(nch.ge.10) then
       write(cform1,'(a4,i2,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a7,i2,a6)')'(f12.6,',nch,'e15.7)'
      else if(nch.ge.3) then
       write(cform1,'(a4,1x,i1,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a7,1x,i1,a6)')'(f12.6,',nch,'e15.7)'
      else
       write(6,*)'nch should be bigger than 2!'
      endif
      end

