      Program deconc
c                     copyright Toshiaki. Yokoi, IISEE, BRI, Japan Dec. 22, 2019
c
      parameter(nn0=4096,nmax=nn0,nch0=10,lmax0=2048)
      complex   c0,cr_sum,cr_ave,cz,cf(nn0),cg(nn0)
      real      x(nn0,nch0),y(nn0,nch0),f(nn0),g(nn0),fr(nn0),
     *          w(lmax0),tt(nn0),pw(nn0),h(nn0),g1(nn0**2),g2(nn0**2)
      character filen*80,finput*12,cunit*5,cform1*15,cform2*20,
     *          cform3*18,cform4*18,cform9*18,cdrv*2,cwkf*10
c constants
      data cwkf/'./cca_wkf/'/ c0,eps/(0.,0.),1.e-5/ pai/3.141592/
      ppai=180./pai
c
      write(6,*)'Program deconc.for'
c parameter file
      filen=cwkf//'prm/deconc.prm'
      write(6,*)filen
      open(11,file=filen,status='old')
      read(11,*)fmin,fmax,dt,bw
c
      f_nyq=0.5/dt*0.95
      if(fmax.ge.f_nyq) then
       fmax=f_nyq
       write(6,*)'fmax is adjusted below f_Nyquist:',fmax
      endif
c read field data file
      read(11,*) finput                ! resampled data file
      filen=cwkf//'data/resampled_files/'//finput
      open(12,file=filen,status='old')
      read(12,'(i2,2i5,i2,2f8.2,1x,a18,1x,a5)')
     *      nch,mblk,nn,nch_center,ph0,rr,cform9,cunit
      write(6,'(i2,2i5,i2,2f8.2,1x,a18,1x,a5)')
     *      nch,mblk,nn,nch_center,ph0,rr,cform9,cunit
      call formatter(nch,cform1,cform2,cform3,cform4)
      if(rr.le.eps) then
       write(6,*)' This file is not of field data!'
       stop
      endif
      read(12,*)idum,t1
      read(12,*)idum,t2
      dt1=t2-t1
      backspace(12)
      backspace(12)
      if(abs(dt-dt1).ge.eps) then
       write(6,*)' dt does not coincide.',dt,dt1,dt-dt1
       stop
      else
       dt=dt1
      endif      
c duration and frequency
      td=real(nn)*dt
      if(bw.gt.eps.and.bw.le.3.71/td) then
       write(6,*)' bw is too small, use bigger than',3.71/td
       stop
      endif
      do i=1,nn
       fr(i)=real(i-1)/td
      enddo
      isf=int(fmin/fr(2)+0.5)
      if(isf.eq.1) isf=isf+1
      ief=int(fmax/fr(2))
c output file (deconvilved data)
      filen=cwkf//'data/resampled_files/'//finput(1:5)//'D'//'.dat'
      open(13,file=filen,status='unknown')
c deconvolution 
c
      do iblk=1,mblk             ! loop over time blocks
c
       if(mod(iblk,10).eq.0) write(6,'(i4,a1,i4)') iblk,'/',mblk
c read input data
       do i=1,nn
        read(12,cform9)idum,tt(i),(x(i,ich),ich=1,nch)
       enddo
c
       do idecon=1,1
c++++++ 
       do ich=1,nch
c
        if(ich.eq.1) then           ! reference sensor at center
 	 do i=1,nn
          f(i)=x(i,ich)
  	 enddo
c        write(6,*)'iblk=',iblk,'ich=',ich,'nn=',nn
         call taper(f,nn,dt)
         do i=1,nn
          cf(i)=cmplx(f(i),0.0)
         enddo
c Fourier Transform
         call cfft(cf,nn,-1)
         do i=1,nn
          cf(i)=cf(i)/real(nn)
         enddo
c Parzen window 
         do i=1,nn
          pw(i)= cf(i)*conjg(cf(i))
         enddo
         if(bw.ge.eps) then
          call w_parzen(pw,nn,nmax,dt,bw,g1,g2,nmax*2,w,lmax0)
         endif
        endif
c
        do i=1,nn
         g(i)=x(i,ich)
        enddo
        call taper(g,nn,dt)
        do i=1,nn
         cg(i)=cmplx(g(i),0.0)
        enddo
c Fourier Transform
        call cfft(cg,nn,-1)
        do i=1,nn
         cg(i)=cg(i)/real(nn)
        enddo
c deconvolution
         do i=1,nn/2+1
          if(isf.lt.i.and.i.lt.ief) then
          cg(i)=cg(i)*conjg(cf(i))/sqrt(pw(i))	
          else
          cg(i)=0.0
          endif
         cg(nn-i+2)=cg(i)
         enddo
c inverse Fourier Transform
         call cfft(cg,nn,1)
        do i=1,nn
         y(i,ich)=real(cg(i))
        enddo
c time shift
         do i=1,nn/2
          f(i)     =y(i+nn/2,ich)
          f(i+nn/2)=y(i     ,ich)
         enddo
c         do i=1,nn/4          ! half
c          f(i)     =0.0
c          f(nn-i+1)=0.0
c         enddo
         do i=1,nn
          y(i,ich)=f(i)
         enddo
c
       enddo                     ! ich loop ends
       do ich=1,nch
        do i=1,nn
         x(i,ich)=y(i,ich)
        enddo
       enddo
c++++++
       enddo                     ! repetition of deconvolution
C normalize
       ymax=abs(y(1,1))
       do ich=1,nch
        do i=1,nn
         if(ymax.lt.abs(y(i,ich))) ymax=abs(y(i,ich))
        enddo
       enddo
       if(ymax.gt.eps) then 
        do ich=1,nch
         do i=1,nn
          y(i,ich)=y(i,ich)/ymax
         enddo
        enddo
       endif
c output
       if(iblk.eq.1) then 
        write(13,'(i2,2i5,i2,2f8.2,1x,a18,1x,a5)')
     *   nch,mblk,nn,nch_center,ph0,rr,cform9,cunit
       endif 
       do i=1,nn
        write(13,cform3)i,tt(i),(y(i,ich),ich=1,nch)
       enddo     
c
      enddo                      ! iblk loop ends
      close(12)
      close(13)
      stop
      end
c+++++
      SUBROUTINE CFFT(X,N,IND)
c...........................................................................
c
c     Complex Fast Fourier Transform
c
c     Coded by Y. OHSAKI in "Introduction to spectral analysis for
c                            seismic waves"
c     Typed by D.Suetsugu, IISEE
c     Modified by H.Inoue, IISEE
c
c     Usage.......   CALL FFT(N,X,IND)
c
c     where
c
c     X(N)    In/Out  Equi-spaced N complex data/Transformed values
c     N       In      Number of data, MUST be a power of 2.
c     IND     In      -1=Fourier transform,  1=Inverse Fourier transform
c
c     Note..... You must divide the output X() by N to get Fourier
c               coefficient when IND=-1.
c
c...........................................................................
      complex x(n),temp,theta
c
      j=1
      do 140 i=1,n
        if(i.ge.j) goto 110
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
  110   m=n/2
  120   if(j.le.m) goto 130
        j=j-m
        m=m/2
        if(m.ge.2) goto 120
  130   j=j+m
  140 continue
c  
      kmax=1
      do 150 kkk=1,9999
        if(kmax.ge.n) return
        istep=kmax*2
        do 170 k=1,kmax
          theta=cmplx(0.0,3.141593*float(ind*(k-1))/float(kmax))
          do 160 i=k,n,istep
            j=i+kmax
            temp=x(j)*cexp(theta)
            x(j)=x(i)-temp
            x(i)=x(i)+temp
  160     continue
  170   continue
        kmax=istep
  150 continue
      end
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine taper(x,n,dt)
      real x(n)
      data pai/3.141592/
      mwin=int(real(n)/20.+0.5)
c     write(6,*)'n=',n,' mwin=',mwin
c linear trend fitting
      b1=x(1)
      do i=2,n
       b1=b1+real(i)*x(i)
      enddo
      b2=x(1)
      do i=1,n
       b2=b2+x(i)
      enddo
      a0=real(n*(n+1)*(2*n+1))/6.*dt
      b0=real(n*(n+1))/2.
      c0=b0*dt
      d0=real(n)
      f0=a0*d0-b0*c0
      aa=( d0*b1-b0*b2)/f0
      bb=(-c0*b1+a0*b2)/f0
      do i=1,n
       x(i)=x(i)-aa*real(i)*dt-bb
      enddo
c tapering
      do i=1,mwin+1
      x(i)=x(i)*SIN(PAI/2.*REAL(i-1)/REAL(mwin))
c      write(6,*)i,x(i)
      enddo
      do i=n-mwin,n
      x(i)=x(i)*SIN(PAI/2.*REAL(n-i)/REAL(mwin))
c     write(6,*)i,x(i)
      enddo
      return
      end
c+++++
      subroutine w_parzen(h,nn,n,dt,bw,g1,g2,n2,w,lmax0)
      real h(n),g1(n2),g2(n2),w(lmax0)
      data pai/3.141592/
c parzen window
      df=1./(dt*real(nn))
      udf=1.854305/bw*df
      if(udf.gt.0.5) then
       write(6,*)' Bandwidth is too narrow'
      endif
      lmax=int(2./udf+0.5)
      if(lmax.gt.lmax0) then
       write(6,*)'Bandwidth is too wide'
      endif
      w(1)=0.75*udf
      do l=2,lmax
       dif=pai/2.*real(l-1)*udf
       w(l)=w(1)*(sin(dif)/dif)**4
      enddo
      ll=lmax*2-1
      ln=ll-1+nn
      lt=(ll-1)*2+nn
      le=lt-lmax+1
      do k=1,lt
       g1(k)=0.
      enddo
      do k=1,nn
       g1(ll-1+k)=h(k)
      enddo
      do k=lmax,le
       s=w(1)*g1(k)
       do l=2,lmax
        s=s+w(l)*(g1(k-l+1)+g1(k+l-1))
       enddo
       g2(k)=s
      enddo
      do l=2,lmax
       g2(ll+l-1)=g2(ll+l-1)+g2(ll-l+1)
       g2(ln-l+1)=g2(ln-l+1)+g2(ln+l-1)
      enddo
      do k=1,nn
       h(k)=g2(ll-1+k)
      enddo
      return
      end
c+++++
      subroutine formatter(nch,cform1,cform2,cform3,cform4)
      character cform1*15,cform2*20,cform3*18,cform4*18
      if(nch.ge.10) then
       write(cform1,'(a4,i2,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a10,10x)')'(2i4,f8.2)'
       write(cform3,'(a10,i2,a6)')'(i8,f16.4,',nch,'e15.7)'
       write(cform4,'(a10,i2,a6)')'(8x,f16.4,',nch,'e15.7)'
      else if(nch.ge.3) then
       write(cform1,'(a4,1x,i1,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a10,10x)')'(2i4,f8.2)'
       write(cform3,'(a10,1x,i1,a6)')'(i8,f16.4,',nch,'e15.7)'
       write(cform4,'(a10,1x,i1,a6)')'(8x,f16.4,',nch,'e15.7)'
      else
       write(6,*)'nch should be bigger than 2!'
      endif
      end
