      subroutine bandp1(x,n,dt,fl,fh,fs,ap,as,ntype,nchara,ncausal)
      real*4 x(n),y(250000),f(512)
c
      if(nchara.eq.1) then
c         Low-Cut (High-Pass) Filter
       if(fs.ge.fl) then
	  write(6,*)'fs<fl is not fulfilled.'
        stop
       endif
      else if(nchara.eq.2) then
c         High-Cut (Low-Pass) Filter
       if(fh.ge.fs) then
	  write(6,*)'fh<fs is not fulfilled.'
        stop
       endif
      else if(nchara.eq.3) then
c         Band-Pass Filter
       if((fs-fh)*(fh-fl).le.0.) then
	  write(6,*)'fl<fh<fs is not fulfilled.'
        stop
       endif
      else
c         Band-Stop Filter
       if((fh-fs)*(fs-fl).le.0.) then
	  write(6,*)'fl<fs<fh is not fulfilled.'
        stop
       endif
      endif
c     write(6,*)' Filter coefficients calculation started'
      flu=fl*dt
      fhu=fh*dt
      fsu=fs*dt
c............................................Calculation of filter coefficients
      if(ntype.eq.1) then
c       Butterworth Filter
        if(nchara.eq.1) then
c         Low-Cut (High-Pass) Filter
          call buthip(f,mf,gn,nchb,flu,fsu,ap,as)
        else if(nchara.eq.2) then
c         High-Cut (Low-Pass) Filter
          call butlop(f,mf,gn,nchb,fhu,fsu,ap,as)
        else if(nchara.eq.3) then
c         Band-Pass Filter
          call butpas(f,mf,gn,nchb,flu,fhu,fsu,ap,as)
        else
c         Band-Stop Filter
          call butstp(f,mf,gn,nchb,flu,fhu,fsu,ap,as)        
        endif
      else if(ntype.eq.2) then
c       Chevyshev-I FIlter
        if(nchara.eq.1) then
c         Low-Cut (High-Pass) Filter
c         call chbhip(f,mf,gn,nchb,eps,fhu,fsu,ap,as)
          call chbhip(f,mf,gn,nchb,eps,flu,fsu,ap,as)
        else if(nchara.eq.2) then
c         High-Cut (Low-Pass) Filter
c         call chblop(f,mf,gn,nchb,eps,flu,fsu,ap,as)
          call chblop(f,mf,gn,nchb,eps,fhu,fsu,ap,as)
        else if(nchara.eq.3) then
c         Band-Pass Filter
          call chbpas(f,mf,gn,nchb,eps,flu,fhu,fsu,ap,as)
        else
c         Band-Stop Filter
          call chbstp(f,mf,gn,nchb,eps,flu,fhu,fsu,ap,as)
        endif
      else if(ntype.eq.3) then
c       Chevyshev-II FIlter
        if(nchara.eq.1) then
c         Low-Cut (High-Pass) Filter
c         call tchhip(f,mf,gn,nchb,eps,fhu,fsu,ap,as)
          call tchhip(f,mf,gn,nchb,eps,flu,fsu,ap,as)
        else if(nchara.eq.2) then
c         High-Cut (Low-Pass) Filter
c         call tchlop(f,mf,gn,nchb,eps,flu,fsu,ap,as)
          call tchlop(f,mf,gn,nchb,eps,fhu,fsu,ap,as)
        else if(nchara.eq.3) then
c         Band-Pass Filter
          call tchpas(f,mf,gn,nchb,eps,flu,fhu,fsu,ap,as)
        else
c         Band-Stop Filter
          call tchstp(f,mf,gn,nchb,eps,flu,fhu,fsu,ap,as)
        endif
      else
c       Elliptic Filter
        if(nchara.eq.1) then
c         Low-Cut (High-Pass) Filter
c         call equhip(f,mf,gn,nchb,eps,ek,er,fhu,fsu,ap,as)
          call equhip(f,mf,gn,nchb,eps,ek,er,flu,fsu,ap,as)
        else if(nchara.eq.2) then
c         High-Cut (Low-Pass) Filter
c         call equlop(f,mf,gn,nchb,eps,ek,er,flu,fsu,ap,as)
          call equlop(f,mf,gn,nchb,eps,ek,er,fhu,fsu,ap,as)
        else if(nchara.eq.3) then
c         Band-Pass Filter
          call equpas(f,mf,gn,nchb,eps,ek,er,flu,fhu,fsu,ap,as)
        else
c         Band-Stop Filter
          call equstp(f,mf,gn,nchb,eps,ek,er,flu,fhu,fsu,ap,as)
        endif
      endif
c
c      write(6,*)' Filter coefficients are calculated.'
c      write(6,'(2x,a3,i3,2x,a3,f10.6)')'mf=',mf,'gn=',gn
c      write(6,'(2x,i2,f10.6)') (i,f(i),i=1,mf)
c..........................................................Filtering subroutine
      call gnf(x,y,n,f,mf,gn,ncausal)
      return
      end
      SUBROUTINE  BUTHIP(H,M,GN,N,FP,FS,AP,AS)
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      BUTTERWORTH HIGH PASS FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER  (M=(N+1)/2)
C        GN     : GAIN FACTOR
C        N      : ORDER OF BUTTERWORTH FUNCTION
C        FP     : PASS BAND FREQUENCY  (NON-DIMENSIONAL)
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      M. SAITO  (7/I/76)
C
      WP = AMAX1(ABS(FP),ABS(FS))*PI
      WS = AMIN1(ABS(FP),ABS(FS))*PI
      IF( WS.EQ.0. .OR. WS.EQ.WP .OR. WP.GE.HP )  GO TO  100
C****  DETERMINE N & C
      TP = TAN(WP)
      TS = TAN(WS)
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.5
      IF( SA.EQ.0. )  SA = 5.
      N  = MAX0(2,IFIX(ABS(ALOG(SA/PA)/ALOG(TP/TS))+0.5))
      CC = EXP(ALOG(PA*SA)/FLOAT(N))*TP*TS
      C  = SQRT(CC)
C
      DP = HP/FLOAT(N)
      M  = N/2
      K  = M*4
      G  = 1.
      FJ = 1.
      C2 =-2.*(1.-C)*(1.+C)
C
      DO  1  J=1,K,4
        SJ = COS(DP*FJ)**2
        TJ = SIN(DP*FJ)
        FJ = FJ+2.
        A  = 1./((C+TJ)**2+SJ)
        G  = G*A
          H( J ) =-2.
          H(J+1) = 1.
          H(J+2) = C2*A
          H(J+3) = ((C-TJ)**2+SJ)*A
    1 CONTINUE
C****  EXIT
      GN = G
      IF( MOD(N,2).EQ.0 )  RETURN
C****  FOR ODD N
      M = M+1
        GN = G/(C+1.)
          H(K+1) =-1.
          H(K+2) = 0.
          H(K+3) = (C-1.)/(C+1.)
          H(K+4) = 0.
      RETURN
C****  ERROR
  100 WRITE(6,101)  FP,FS
  101  FORMAT(/1X,5('?'),'   (BUTHIP)   INVALID INPUT   FP =',
     *        1PE14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      SUBROUTINE  BUTLOP(H,M,GN,N,FP,FS,AP,AS)
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      BUTTERWORTH LOW PASS FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER  (M=(N+1)/2)
C        GN     : GAIN FACTOR
C        N      : ORDER OF BUTTERWORTH FUNCTION
C        FP     : PASS BAND FREQUENCY  (NON-DIMENSIONAL)
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      M. SAITO  (17/XII/75)
C
      WP = AMIN1(ABS(FP),ABS(FS))*PI
      WS = AMAX1(ABS(FP),ABS(FS))*PI
      IF( WP.EQ.0. .OR. WP.EQ.WS .OR. WS.GE.HP )  GO TO  100
C****  DETERMINE N & C
      TP = TAN(WP)
      TS = TAN(WS)
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.5
      IF( SA.EQ.0. )  SA = 5.
      N  = MAX0(2,IFIX(ABS(ALOG(PA/SA)/ALOG(TP/TS))+0.5))
      CC = EXP(ALOG(PA*SA)/FLOAT(N))/(TP*TS)
      C  = SQRT(CC)
C
      DP = HP/FLOAT(N)
      M  = N/2
      K  = M*4
      G  = 1.
      FJ = 1.
      C2 = 2.*(1.-C)*(1.+C)
C
      DO  1  J=1,K,4
        SJ = COS(DP*FJ)**2
        TJ = SIN(DP*FJ)
        FJ = FJ+2.
        A  = 1./((C+TJ)**2+SJ)
        G  = G*A
          H( J ) = 2.
          H(J+1) = 1.
          H(J+2) = C2*A
          H(J+3) = ((C-TJ)**2+SJ)*A
    1 CONTINUE
C****  EXIT
      GN = G
      IF( MOD(N,2).EQ.0 )  RETURN
C****  FOR ODD N
      M  = M+1
        GN = G/(1.+C)
          H(K+1) = 1.
          H(K+2) = 0.
          H(K+3) = (1.-C)/(1.+C)
          H(K+4) = 0.
      RETURN
C****  ERROR
  100 WRITE(6,101)  FP,FS
  101  FORMAT(/1X,5('?'),'   (BUTLOP)   INVALID INPUT   FP =',
     *        1PE14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      SUBROUTINE  BUTPAS(H,M,GN,N,FL,FH,FS,AP,AS)
      COMPLEX  R(2),OJ,CQ
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      BUTTERWORTH BAND PASS FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : ORDER OF BUTTERWORTH FUNCTION
C        FL     : LOW  FREQUENCY CUT-OFF  (NON-DIMENSIONAL)
C        FH     : HIGH FREQUENCY CUT-OFF
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      M. SAITO  (7/I/76)
C
      WL = AMIN1(ABS(FL),ABS(FH))*PI
      WH = AMAX1(ABS(FL),ABS(FH))*PI
      WS = ABS(FS)*PI
      IF( WL.EQ.0. .OR. WL.EQ.WH .OR. WH.GE.HP .OR. WS.EQ.0. .OR.
     *    WS.GE.HP .OR. (WS-WL)*(WS-WH).LE.0. )  GO TO  100
C****  DETERMINE N & C
      CLH= 1./(COS(WL)*COS(WH))
      OP = SIN(WH-WL)*CLH
      WW = TAN(WL)*TAN(WH)
      TS = TAN(WS)
      OS = ABS(TS-WW/TS)
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.5
      IF( SA.EQ.0. )  SA = 5.
      N  = MAX0(2,IFIX(ABS(ALOG(PA/SA)/ALOG(OP/OS))+0.5))
      CC = EXP(ALOG(PA*SA)/FLOAT(N))/(OP*OS)
      C  = SQRT(CC)
      WW = WW*CC
C
      DP = HP/FLOAT(N)
      K  = N/2
      M  = K*2
      L  = 0
      G  = 1.
      FJ = 1.
C
      DO  2  J=1,K
        OJ = CMPLX(COS(DP*FJ),SIN(DP*FJ))*0.5
        FJ = FJ+2.
        CQ = CSQRT(OJ**2+WW)
        R(1) = OJ+CQ
        R(2) = OJ-CQ
        G  = G*CC
C
        DO  1  I=1,2
          RE =  REAL(R(I))**2
          RI = AIMAG(R(I))
          A  = 1./((C+RI)**2+RE)
          G  = G*A
            H(L+1) = 0.
            H(L+2) =-1.
            H(L+3) = 2.*((RI-C)*(RI+C)+RE)*A
            H(L+4) = ((RI-C)**2+RE)*A
            L = L+4
    1   CONTINUE
C
    2 CONTINUE
C****  EXIT
      GN = G
      IF( N.EQ.M )  RETURN
C****  FOR ODD N
      M = M+1
      WPC = CC*COS(WH-WL)*CLH
      WMC =-CC*COS(WH+WL)*CLH
          A  = 1./(WPC+C)
          GN = G*C*A
            H(L+1) = 0.
            H(L+2) =-1.
            H(L+3) = 2.*WMC*A
            H(L+4) = (WPC-C)*A
      RETURN
C****  ERROR
  100 WRITE(6,101)  FL,FH,FS
  101  FORMAT(/1X,5('?'),'   (BUTPAS)   INVALID INPUT   FL =',
     *        1PE14.6,3X,'FH =',E14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      SUBROUTINE  BUTSTP(H,M,GN,N,FL,FH,FS,AP,AS)
      COMPLEX  R(2),OJ,CQ
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      BUTTERWORTH BAND STOP FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : ORDER OF BUTTERWORTH FUNCTION
C        FL     : LOW  FREQUENCY CUT-OFF  (NON-DIMENSIONAL)
C        FH     : HIGH FREQUENCY CUT-OFF
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      M. SAITO  (7/I/76)
C
      WL = AMIN1(ABS(FL),ABS(FH))*PI
      WH = AMAX1(ABS(FL),ABS(FH))*PI
      WS = ABS(FS)*PI
      IF( WL.EQ.0. .OR. WL.EQ.WH .OR. WH.GE.HP .OR.
     *   (WS-WL)*(WS-WH).GE.0. )  GO TO  100
C****  DETERMINE N & C
      CLH= 1./(COS(WL)*COS(WH))
      OP = SIN(WH-WL)*CLH
      WW = TAN(WL)*TAN(WH)
      TS = TAN(WS)
      OS = ABS(TS-WW/TS)
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.5
      IF( SA.EQ.0. )  SA = 5.
      N  = MAX0(2,IFIX(ABS(ALOG(SA/PA)/ALOG(OP/OS))+0.5))
      CC = EXP(-ALOG(PA*SA)/FLOAT(N))/(OP*OS)
      C  = SQRT(CC)
C
      WW = WW*CC
      DP = HP/FLOAT(N)
      K  = N/2
      M  = K*2
      L  = 0
      G  = 1.
      FJ = 1.
      WPC= CC*COS(WH-WL)*CLH
      WMC=-CC*COS(WH+WL)*CLH
      A0 = WPC
      A2 = A0**2
      A1 = 2.*WMC/A0
C
      DO  2  J=1,K
        OJ = CMPLX(-COS(DP*FJ),SIN(DP*FJ))*0.5
        FJ = FJ+2.
        CQ = CSQRT(OJ**2+WW)
        R(1) = OJ+CQ
        R(2) = OJ-CQ
        G  = G*A2
C
        DO  1  I=1,2
          RE =  REAL(R(I))**2
          RI = AIMAG(R(I))
          A  = 1./((C+RI)**2+RE)
          G  = G*A
            H(L+1) = A1
            H(L+2) = 1.
            H(L+3) = 2.*((RI-C)*(RI+C)+RE)*A
            H(L+4) = ((RI-C)**2+RE)*A
            L = L+4
    1   CONTINUE
C
    2 CONTINUE
C****  EXIT
      GN = G
      IF( N.EQ.M )  RETURN
C****  FOR ODD N
      M = M+1
          A  = 1./(WPC+C)
          GN = G*A0*A
            H(L+1) = A1
            H(L+2) = 1.
            H(L+3) = 2.*WMC*A
            H(L+4) = (WPC-C)*A
C
      RETURN
C****  ERROR
  100 WRITE(6,101)  FL,FH,FS
  101  FORMAT(/1X,5('?'),'   (BUTSTP)   INVALID INPUT   FL =',
     *        1PE14.6,3X,'FH =',E14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      FUNCTION  CELIN1(D,D1)
C
C      COMPLETE ELLIPTIC INTEGRAL OF 1-ST KIND
C
C      ARGUMENTS
C        D      : SQUARE OF MODULUS
C        D1     : SQUARE OF COMPLEMENTARY MODULUS
C
C      M. SAITO  (10/IX/76)
C
      IF( D.GT.0.828 )  GO TO  3
C      K**2 =< 0.828
      X = D
      IF( X.LT.0. )  GO TO  4
      A = 0.
      IF( X.LE.0.171 )  GO TO  1
C      LANDEN TRANSFORM
      X = X/(1.+SQRT(D1))**2
      A = 1.+X
      X = X**2
C      TAYLOR SERIES
    1 S = 1.57079633E+0+X*(3.9269908E-1+X*(2.2089323E-1+X*(1.5339808E-1
     *                 +X*(1.1744540E-1+X*(9.5130777E-2+X*(7.9936278E-2
     *                 +X*(6.8924648E-2)))))))
      IF( A.NE.0. )  S = S*A
C      EXIT
    2 CELIN1 = S
      RETURN
C      K**2 > 0.828
    3 X = D1
      IF( X.LE.0. )  GO TO  4
C      ASYMPTOTIC SERIES
      S = (2.77258872E+0-ALOG(X))
     *   *(0.5 +X*(0.125       +X*(7.03125E-2  +X*(4.8828125E-2
     *         +X*(3.7384033E-2+X*(3.0281067E-2+X*(2.5444508E-2
     *         +X*(2.1939397E-2))))))))
     * -X*(0.25+X*(0.1640625E+0+X*(1.2044271E-1+X*(9.4884236E-2
     *         +X*(7.8202056E-2+X*(6.6482496E-2+X*(5.7806378E-2)))))))
        GO TO  2
C      K < 0 OR K > 1
    4 WRITE(6,5)  D,D1
    5  FORMAT(//1X,5('?'),1X,'(CELIN1)',3X,'K =',E14.6,3X,'K','=',E14.6,
     *        3X,5('?')//)
      S = 1.E+30
        GO TO  2
      END
      SUBROUTINE  CHBHIP(H,M,GN,N,EPS,FP,FS,AP,AS)
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      CHEBYSHEV HIGH-PASS FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENT
C        M      : ORDER OF FILTER  (M=(N+1)/2)
C        GN     : GAIN FACTOR
C        N      : DEGREE OF CHEBYSHEV POLYNOMIAL
C        EPS    : RIPPLE
C        FP     : PASS BAND FREQUENCY  (NON-DIMENSIONAL)
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      M. SAITO  (16/XII/75)
C
      WP = AMAX1(ABS(FP),ABS(FS))*PI
      WS = AMIN1(ABS(FP),ABS(FS))*PI
      IF( WP.EQ.WS .OR. WS.EQ.0. .OR. WP.GE.HP )  GO TO  100
C      DETERMINE N, EPS & C
      C  = TAN(WP)
      OS = C*1./TAN(WS)
      TS = ALOG(OS+SQRT((OS+1.)*SIN(WP-WS)/(COS(WP)*SIN(WS))))
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.1
      IF( SA.EQ.0. )  SA = 5.
      PS = PA/SA
      N  = MAX0(2,IFIX(ABS(ALOG((1.+SQRT((1.-PS)*(1.+PS)))/PS)/TS)+0.5))
      FN = N
      EPS= SQRT(PA*SA/COSH(TS*FN))
C
      M  = N/2
      K  = M*4
      G  = 1./(EPS*FLOAT(2**(N-1)))
      PS = ALOG((1.+SQRT(1.+EPS**2))/EPS)/FN
      CH = COSH(PS)
      SH = SINH(PS)
      DP = HP/FN
      FJ = 1.
C
      DO  1  J=1,K,4
        SJ = (COS(DP*FJ)*CH)**2
        TJ =  SIN(DP*FJ)*SH
        FJ = FJ+2.
        A  = 1./((C+TJ)**2+SJ)
        G  = G*A
          H( J ) =-2.
          H(J+1) = 1.
          H(J+2) = 2.*((C-TJ)*(C+TJ)-SJ)*A
          H(J+3) = ((C-TJ)**2+SJ)*A
    1 CONTINUE
C      EXIT
      GN = G
      IF( MOD(N,2).EQ.0 )  RETURN
C      FOR ODD N
      M = M+1
        GN = G/(C+SH)
          H(K+1) =-1.
          H(K+2) = 0.
          H(K+3) = (C-SH)/(C+SH)
          H(K+4) = 0.
      RETURN
C      ERROR
  100 WRITE(6,101)  FP,FS
  101  FORMAT(/1X,5('?'),'   (CHBHIP)   INVALID INPUT   FP =',
     *        1PE14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      SUBROUTINE  CHBLOP(H,M,GN,N,EPS,FP,FS,AP,AS)
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      CHEBYSHEV LOW-PASS FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENT
C        M      : ORDER OF FILTER  (M=(N+1)/2)
C        GN     : GAIN FACTOR
C        N      : DEGREE OF CHEBYSHEV POLYNOMIAL
C        EPS    : RIPPLE
C        FP     : PASS BAND FREQUENCY  (NON-DIMENSIONAL)
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      M. SAITO  (15/XII/75)
C
      WP = AMIN1(ABS(FP),ABS(FS))*PI
      WS = AMAX1(ABS(FP),ABS(FS))*PI
      IF( WP.EQ.WS .OR. WP.EQ.0. .OR. WS.GE.HP )  GO TO  100
C      DETERMINE N, EPS & C
      C  = 1./TAN(WP)
      OS = C*TAN(WS)
      TS = ALOG(OS+SQRT((OS+1.)*SIN(WS-WP)/(COS(WS)*SIN(WP))))
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.1
      IF( SA.EQ.0. )  SA = 5.
      PS = PA/SA
      N  = MAX0(2,IFIX(ABS(ALOG((1.+SQRT((1.-PS)*(1.+PS)))/PS)/TS)+0.5))
      FN = N
      EPS= SQRT(PA*SA/COSH(TS*FN))
C
      M  = N/2
      K  = M*4
      G  = 1./(EPS*FLOAT(2**(N-1)))
      PS = ALOG((1.+SQRT(1.+EPS**2))/EPS)/FN
      CH = COSH(PS)
      SH = SINH(PS)
      DP = HP/FN
      FJ = 1.
C
      DO  1  J=1,K,4
        SJ = (COS(DP*FJ)*CH)**2
        TJ =  SIN(DP*FJ)*SH
        FJ = FJ+2.
        A  = 1./((C+TJ)**2+SJ)
        G  = G*A
          H( J ) = 2.
          H(J+1) = 1.
          H(J+2) = 2.*((TJ-C)*(TJ+C)+SJ)*A
          H(J+3) = ((TJ-C)**2+SJ)*A
    1 CONTINUE
C****  EXIT
      GN = G
      IF( MOD(N,2).EQ.0 )  RETURN
C****  FOR ODD N
      M = M+1
        GN = G/(SH+C)
          H(K+1) = 1.
          H(K+2) = 0.
          H(K+3) = (SH-C)/(SH+C)
          H(K+4) = 0.
      RETURN
C****  ERROR
  100 WRITE(6,101)  FP,FS
  101  FORMAT(/1X,5('?'),'   (CHBLOP)   INVALID INPUT   FP =',
     *        1PE14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      SUBROUTINE  CHBPAS(H,M,GN,N,EPS,FL,FH,FS,AP,AS)
      COMPLEX  R(2),OJ,CQ
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      CHEBYSHEV BAND-PASS FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENT
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : DEGREE OF CHEBYSHEV POLYNOMIAL
C        EPS    : RIPPLE
C        FL     : LOW FREQUENCY CUT-OFF  (NON-DIMENSIONAL)
C        FH     : HIGH FREQUENCY CUT-OFF
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      M. SAITO  (16/XII/75)
C
      WL = AMIN1(ABS(FL),ABS(FH))*PI
      WH = AMAX1(ABS(FL),ABS(FH))*PI
      WS = ABS(FS)*PI
      IF( WL.EQ.WH .OR. WL.EQ.0. .OR. WH.GE.HP .OR. WS.EQ.0. .OR.
     *    WS.GE.HP .OR. (WS-WL)*(WS-WH).LE.0. )  GO TO  100
C      DETERMINE N, EPS & C
      CLH= COS(WL)*COS(WH)
      C  = CLH/SIN(WH-WL)
      CC = C*C
      WW = TAN(WL)*TAN(WH)*CC
      WS = TAN(WS)*C
      OS = ABS(WS-WW/WS)
      TS = ALOG(OS+SQRT((OS-1.)*(OS+1.)))
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.1
      IF( SA.EQ.0. )  SA = 5.
      PS = PA/SA
      N  = MAX0(2,IFIX(ABS(ALOG((1.+SQRT((1.-PS)*(1.+PS)))/PS)/TS)+0.5))
      FN = N
      EPS= SQRT(PA*SA/COSH(TS*FN))
C
      K  = N/2
      M  = K*2
      L  = 0
      FJ = 1.
      G  = 1./(EPS*FLOAT(2**(N-1)))
      PS = ALOG((1.+SQRT(1.+EPS**2))/EPS)/FN
      CH = COSH(PS)
      SH = SINH(PS)
      DP = HP/FN
C
      DO  2  J=1,K
        OJ = CMPLX(COS(DP*FJ)*CH,SIN(DP*FJ)*SH)*0.5
        FJ = FJ+2.
        CQ = CSQRT(OJ**2+WW)
        R(1) = OJ+CQ
        R(2) = OJ-CQ
        G  = G*CC
C
        DO  1  I=1,2
          RE =  REAL(R(I))**2
          RI = AIMAG(R(I))
          A  = 1./((C+RI)**2+RE)
          G  = G*A
            H(L+1) = 0.
            H(L+2) =-1.
            H(L+3) = 2.*((RI-C)*(RI+C)+RE)*A
            H(L+4) = ((RI-C)**2+RE)*A
            L = L+4
    1   CONTINUE
C
    2 CONTINUE
C      EXIT
      GN = G
      IF( N.EQ.M )  RETURN
C      FOR ODD N
      M  = M+1
      WPC= CC*COS(WH-WL)/CLH
      WMC=-CC*COS(WL+WH)/CLH
          A  = 1./(WPC+C*SH)
          GN = G*C*A
            H(L+1) = 0.
            H(L+2) =-1.
            H(L+3) = 2.*WMC*A
            H(L+4) = (WPC-C*SH)*A
      RETURN
C      ERROR
  100 WRITE(6,101)  FL,FH,FS
  101  FORMAT(/1X,5('?'),'   (CHBPAS)   INVALID INPUT   FL =',
     *        1PE14.6,3X,'FH =',E14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      SUBROUTINE  CHBSTP(H,M,GN,N,EPS,FL,FH,FS,AP,AS)
      COMPLEX  R(2),OJ,CQ
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      CHEBYSHEV BAND STOP FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENT
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : DEGGREE OF CHEBYSHEV POLYNOMIAL
C        EPS    : RIPPLE
C        FL     : LOW  FREQUENCY CUT-OFF  (NON-DIMENSIONAL)
C        FH     : HIGH FREQUENCY CUT-OFF
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      M. SAITO  (16/XII/75)
C
      WL = AMIN1(ABS(FL),ABS(FH))*PI
      WH = AMAX1(ABS(FL),ABS(FH))*PI
      WS = ABS(FS)*PI
      IF( WL.EQ.WH .OR. WL.EQ.0. .OR. WH.GE.HP .OR.
     *   (WS-WL)*(WS-WH).GE.0. )  GO TO  100
C      DETERMINE N, EPS & C
      CLH= COS(WL)*COS(WH)
      C  = CLH/SIN(WH-WL)
      CC = C*C
      WW = TAN(WL)*TAN(WH)*CC
      WS = C*TAN(WS)
      WPC= CC*COS(WH-WL)/CLH
      WMC=-CC*COS(WL+WH)/CLH
      OS = 1./ABS(WS-WW/WS)
      TS = ALOG(OS+SQRT((OS-1.)*(OS+1.)))
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.1
      IF( SA.EQ.0. )  SA = 5.
      PS = PA/SA
      N  = MAX0(2,IFIX(ABS(ALOG((1.+SQRT((1.-PS)*(1.+PS)))/PS)/TS)+0.5))
      FN = N
      EPS= SQRT(PA*SA/COSH(TS*FN))
C
      K  = N/2
      M  = K*2
      L  = 0
      FJ = 1.
      G  = 1./(EPS*FLOAT(2**(N-1)))
      PS = ALOG((1.+SQRT(1.+EPS**2))/EPS)/FN
      CH = COSH(PS)
      SH = SINH(PS)
      DP = HP/FN
      A0 = WPC
      A2 = A0*A0*4.
      A1 = 2.*WMC/A0
C
      DO  2  J=1,K
        OJ =-0.5/CMPLX(COS(DP*FJ)*CH,SIN(DP*FJ)*SH)
        FJ = FJ+2.
        CQ = SQRT(OJ**2+WW)
        R(1) = OJ+CQ
        R(2) = OJ-CQ
        G  = G*A2*(REAL(OJ)**2+AIMAG(OJ)**2)
C
        DO  1  I=1,2
          RE =  REAL(R(I))**2
          RI = AIMAG(R(I))
          A  = 1./((C+RI)**2+RE)
          G  = G*A
            H(L+1) = A1
            H(L+2) = 1.
            H(L+3) = 2.*((RI-C)*(RI+C)+RE)*A
            H(L+4) = ((RI-C)**2+RE)*A
            L = L+4
    1   CONTINUE
C
    2 CONTINUE
C      EXIT
      GN = G
      IF( N.EQ.M )  RETURN
C      FOR ODD N
      M  = M+1
          A  = 1./(WPC+C/SH)
          GN = G*A0*A/SH
            H(L+1) = A1
            H(L+2) = 1.
            H(L+3) = 2.*WMC*A
            H(L+4) = (WPC-C/SH)*A
      RETURN
C      ERROR
  100 WRITE(6,101)  FL,FH,FS
  101  FORMAT(/1X,5('?'),'   (CHBSTP)   INVALID INPUT   FL =',
     *        1PE14.6,3X,'FH =',E14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      SUBROUTINE  EQUHIP(H,M,GN,N,EPS,EK,ER,FP,FS,AP,AS)
      DIMENSION  H(4)
      DATA  PI,HP/3.141593,1.570796/
C
C      EQUIRIPPLE HIGH-PASS FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : NUMBER OF POLES
C        EPS    ; RIPPLE
C        EK     : K**2
C        ER     : K1**2
C        FP     : PASS BAND FREQUENCY  (NON-DIMENSIONAL)
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      SUBROUTINE REQUIRED : EQUPOL(CELIN1,SNTHET)
C
C      M. SAITO  (1/X/76)
C
      WP = AMAX1(ABS(FP),ABS(FS))*PI
      WS = AMIN1(ABS(FP),ABS(FS))*PI
      IF( WP.EQ.WS .OR. WS.EQ.0. .OR. WP.GE.HP )  GO TO  3
      TP = TAN(WP)
      TS = TAN(WS)
      CC = TP*TS
      C  = SQRT(CC)
      EK = (TS/TP)**2
      EKP= SIN(WP-WS)*SIN(WP+WS)/((COS(WS)*SIN(WP))**2)
      CALL  EQUPOL(H,N,EPS,EK,EKP,ER,ERP,AP,AS)
C
      M  = N/2
      K  = M*4
      G  = 1.
C
      DO  1  J=1,K,4
        RJ = H( J )
        RJ2= RJ*RJ
        SJ = H(J+2)**2
        TJ = H(J+3)
        A  = 1./((C+TJ)**2+SJ)
        G  = G*(1.+CC/RJ2)*(SJ+TJ**2)*A
          H( J ) = 2.*(C-RJ)*(C+RJ)/(CC+RJ2)
          H(J+1) = 1.
          H(J+2) = 2.*((C-TJ)*(C+TJ)-SJ)*A
          H(J+3) = ((C-TJ)**2+SJ)*A
    1 CONTINUE
C
      IF( MOD(N,2).NE.0 )  GO TO  2
      GN = G/SQRT(1.+EPS**2)
      RETURN
C****  N = ODD
    2 M = M+1
        TJ = H(K+4)
        GN = G*TJ/(C+TJ)
          H(K+1) =-1.
          H(K+2) = 0.
          H(K+3) = (C-TJ)/(C+TJ)
          H(K+4) = 0.
      RETURN
C****  ERROR
    3 WRITE(6,4)  FP,FS
    4  FORMAT(/1X,5('?'),3X,'(EQUHIP)   INVALID INPUT   FP =',
     *        1PE14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      SUBROUTINE  EQULOP(H,M,GN,N,EPS,EK,ER,FP,FS,AP,AS)
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      EQUIRIPPLE LOW-PASS FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : NUMBER OF POLES
C        EPS    : RIPPLE
C        EK     : K**2
C        ER     : K1**2
C        FP     : PASS BAND FREQUENCY  (NON-DIMENSIONAL)
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      SUBROUTINE REQUIRED : EQUPOL(CELIN1,SNTHET)
C
C      M. SAITO  (22/IX/76)
C
      WP = AMIN1(ABS(FP),ABS(FS))*PI
      WS = AMAX1(ABS(FP),ABS(FS))*PI
      IF( WP.EQ.WS .OR. WP.EQ.0. .OR. WS.GE.HP )  GO TO  3
      TANP = TAN(WP)
      TANS = TAN(WS)
      CC   = 1./(TANP*TANS)
      C    = SQRT(CC)
      EK   = (TANP/TANS)**2
      EKP  = SIN(WS-WP)*SIN(WS+WP)/((SIN(WS)*COS(WP))**2)
      CALL  EQUPOL(H,N,EPS,EK,EKP,ER,ERP,AP,AS)
C
      M = N/2
      K = M*4
      G = 1.
C
      DO  1  J=1,K,4
        RJ = H( J )
        RJ2=RJ*RJ
        SJ = H(J+2)**2
        TJ = H(J+3)
        A  = 1./((C+TJ)**2+SJ)
        G  = G*(1.+CC/RJ2)*(SJ+TJ**2)*A
          H( J ) = 2.*(RJ-C)*(RJ+C)/(CC+RJ2)
          H(J+1) = 1.
          H(J+2) = 2.*((TJ-C)*(TJ+C)+SJ)*A
          H(J+3) = ((C-TJ)**2+SJ)*A
    1 CONTINUE
C
      IF( MOD(N,2).NE.0 )  GO TO  2
      GN = G/SQRT(1.+EPS**2)
      RETURN
C      N = ODD
    2 M = M+1
        TJ = H(K+4)
        GN = G*TJ/(C+TJ)
          H(K+1) = 1.
          H(K+2) = 0.
          H(K+3) =-(C-TJ)/(C+TJ)
          H(K+4) = 0.
      RETURN
C      ERROR
    3 WRITE(6,4)  FP,FS
    4  FORMAT(/1X,5('?'),3X,'(EQULOP)   INVALID INPUT   FP =',
     *        1PE14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      SUBROUTINE  EQUPAS(H,M,GN,N,EPS,EK,ER,FL,FH,FS,AP,AS)
      COMPLEX  Q(2),OJ,CQ
      DIMENSION  H(4),R(2)
      DATA  PI,HP/3.141593,1.570796/
C
C      EQUIRIPPLE BAND-PASS FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : NOMBER OF POLES
C        EPS    : RIPPLE
C        EK     : K**2
C        ER     : K1**2
C        FL     : LOW  FREQUENCY CUT-OFF  (NON-DIMENSIONAL)
C        FH     : HIGH FREQUENCY CUT-OFF
C        FS     : STOP BAND FREQUENCY
C        AP     : MPX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      SUBROUTINE REQUIRED : EQUPOL(CELIN1,SNTHET)
C
C      M. SAITO  (1/X/76)
C
      WL = AMIN1(ABS(FL),ABS(FH))*PI
      WH = AMAX1(ABS(FL),ABS(FH))*PI
      WS = ABS(FS)*PI
      IF( WL.EQ.WH .OR. WL.EQ.0. .OR. WH.GE.HP .OR. WS.EQ.0. .OR.
     *    WS.GE.HP .OR. (WS-WL)*(WS-WH).LE.0. )  GO TO  5
      CLH= 1./(COS(WL)*COS(WH))
      OP = SIN(WH-WL)*CLH
      TS = TAN(WS)
      WW = TAN(WL)*TAN(WH)
      OS = ABS(TS-WW/TS)
      CC = 1./(OP*OS)
      WW = WW*CC
      C  = SQRT(CC)
      EK = OP/OS
      EKP= (1.-EK)*(1.+EK)
      EK = EK**2
      CALL  EQUPOL(H,N,EPS,EK,EKP,ER,ERP,AP,AS)
C
      K  = N/2
      L1 = K*4
      L2 = L1*2
      M  = K*2
      IF( MOD(N,2).NE.0 )  GO TO  1
C****  N = EVEN
      G  = 1./SQRT(1.+EPS**2)
        GO TO  2
C****  N = ODD
    1 M  = M+1
      WPC= CC*COS(WH-WL)*CLH
      WMC=-CC*COS(WL+WH)*CLH
          TJ = H(L1+4)
          A  = 1./(WPC+C*TJ)
          G  = TJ*C*A
            H(L2+1) = 0.
            H(L2+2) =-1.
            H(L2+3) = 2.*WMC*A
            H(L2+4) = (WPC-C*TJ)*A
C
    2 DO  4  J=1,K
        L1 = L1-4
        RJ = H(L1+1)*0.5
        RJ2= RJ**2
        R(1) = 2.*RJ*(RJ+SQRT(RJ2+WW))+WW
        R(2) = WW**2/R(1)
        OJ = CMPLX(H(L1+3),H(L1+4))*0.5
        CQ = CSQRT(OJ**2+WW)
        Q(1) = OJ+CQ
        Q(2) = OJ-CQ
        G  = G*(REAL(OJ)**2+AIMAG(OJ)**2)/RJ2
C
        DO  3  I=1,2
          L2 = L2-4
          RJ = R(I)
          SJ =  REAL(Q(I))**2
          TJ = AIMAG(Q(I))
          A  = 1./((C+TJ)**2+SJ)
          G  = G*(CC+RJ)*A
            H(L2+1) = 2.*(RJ-CC)/(CC+RJ)
            H(L2+2) = 1.
            H(L2+3) = 2.*((TJ-C)*(TJ+C)+SJ)*A
            H(L2+4) = ((TJ-C)**2+SJ)*A
    3   CONTINUE
C
    4 CONTINUE
C
      GN = G
      RETURN
C****  ERROR
    5 WRITE(6,6)  FL,FH,FS
    6  FORMAT(/1X,5('?'),3X,'(EQUPAS)   INVALID INPUT   FL =',
     *        1PE14.6,3X,'FH =',E14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      SUBROUTINE  EQUPOL(H,N,EPS,EK,EKP,ER,ERP,AP,AS)
      DIMENSION  H(4)
C
C      ZEROS & POLES OF EQUIRIPPLE FILTER
C
C      ARGUMENTS
C        H      : ZEROS & POLES
C        N      : ORDER
C        EPS    : EPSILON
C        EK     : K**2
C        EKP    : 1-K**2
C        ER     : K1**2
C        ERP    : 1-K1**2
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      SUBROUTINE REQUIRED : CELIN1, SNTHET
C
C      M. SAITO  (22/IX/76)
C
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 1.E-1
      IF( SA.EQ.0. )  SA = 1.E+1
      ER = PA/SA
      ERP= (1.+ER)*(1.-ER)
      ER = ER**2
      QK = CELIN1(EKP,EK)/CELIN1(EK,EKP)
C      DETERMINE N & K1
      N  = MAX0(2,IFIX((CELIN1(ERP,ER)/CELIN1(ER,ERP))/QK+0.5))
      FN = N
      QR = QK*FN
      ER = SNTHET(1.,QR)**2
      ERP= (1.+ER)*(1.-ER)
      EPS2= ER*PA*SA
      EPS = SQRT(EPS2)
      ER = ER**2
C      COMPUTE ARCSN(I/EPSILON,K1)
    1 EP = ER/EPS2
      EE = SQRT(1.+EPS2)
      B2 = 9.765625 E-2+ER*B3
      B3 = 7.4768066E-2+ER*6.0562134E-2
      B1 = 0.140625    +ER*B2
      B0 = 0.25        +ER*B1
      V  = 0.63661977E0*ALOG((1.+EE)/EPS)/QR-EP*(EE/CELIN1(ERP,ER))
     *    *(B0-EP*(0.6666667E0*B1-EP*(0.5333333E0*B2-EP*(0.4571429E0*B3)
     *      )))
C      CONSTANT FACTOR
      SQK = SQRT(EK)
      SNV = SNTHET(V,1./QK)/SQRT(SQRT(EKP))
      CNV = SQRT((1.-SNV)*(1.+SNV))
      SNV2= SNV**2
      DNV = SQRT(1.-EKP*SNV2)
      SCV = SNV*CNV
C
      M  = N/2
      K  = M*4
      FJ = N-1
      DO  2  J=1,K,4
        SN = SNTHET(FJ/FN,QK)
        DN2= 1.-SQK*SN**2
        CD = SQRT(DN2*(SQK-SN**2))
        SD = 1./(1.-SNV2*DN2)
          H( J ) = 1./SN
          H(J+2) = SN*DNV*SD
          H(J+3) = SCV*CD*SD
        FJ = FJ-2.
    2 CONTINUE
C
      IF( MOD(N,2).NE.0 )  H(K+4) = SQRT(SQK)*SNV/CNV
      RETURN
      END
      SUBROUTINE  EQUSTP(H,M,GN,N,EPS,EK,ER,FL,FH,FS,AP,AS)
      COMPLEX  Q(2),OJ,CQ
      DIMENSION  H(4),R(2)
      DATA  PI,HP/3.141593,1.570796/
C
C      EQUIRIPPLE BAND-STOP FILTER COEFFICIENT
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : NUMBER OF POLE
C        EPS    : RIPPLE
C        EK     : K**2
C        ER     : K1**2
C        FL     : LOW  FREQUENCY CUT-OFF  (NON-DIMENSINAL)
C        FH     : HIGH FREQUENCY CUT-OFF
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      SUBROUTINE REQUIRED : EQUPOL(CELIN1,SNTHET)
C
C      M. SAITO  (1/X/76)
C
      WL = AMIN1(ABS(FL),ABS(FH))*PI
      WH = AMAX1(ABS(FL),ABS(FH))*PI
      WS = ABS(FS)*PI
      IF( WL.EQ.WH .OR. WL.EQ.0. .OR. WH.GE.HP .OR.
     *    (WS-WL)*(WS-WH).GE.0. )  GO TO  5
      CLH= 1./(COS(WL)*COS(WH))
      OP = SIN(WH-WL)*CLH
      TS = TAN(WS)
      WW = TAN(WL)*TAN(WH)
      OS = ABS(TS-WW/TS)
      CC = 1./(OP*OS)
      WW = WW*CC
      C  = SQRT(CC)
      EK = OS/OP
      EKP= (1.-EK)*(1.+EK)
      EK = EK**2
      CALL  EQUPOL(H,N,EPS,EK,EKP,ER,ERP,AP,AS)
C
      K  = N/2
      L1 = K*4
      L2 = L1*2
      M  = K*2
      IF( MOD(N,2).NE.0 )  GO TO  1
C****  N = EVEN
      G  = 1./SQRT(1.+EPS**2)
        GO TO  2
C****  N = ODD
    1 M = M+1
      WPC= CC*COS(WH-WL)*CLH
      WMC=-CC*COS(WL+WH)*CLH
          TJ = H(L1+4)
          A  = 1./(WPC+C/TJ)
          G  = WPC*A
            H(L2+1) = 2.*WMC/WPC
            H(L2+2) = 1.
            H(L2+3) = 2.*WMC*A
            H(L2+4) = (WPC-C/TJ)*A
C
    2 DO  4  J=1,K
        L1 = L1-4
        RJ = 0.5/H(L1+1)
        RJ2= RJ**2
        R(1) = 2.*RJ*(RJ+SQRT(RJ2+WW))+WW
        R(2) = WW**2/R(1)
        OJ =-0.5/CMPLX(H(L1+3),H(L1+4))
        CQ = CSQRT(OJ**2+WW)
        Q(1) = OJ+CQ
        Q(2) = OJ-CQ
C
        DO  3  I=1,2
          L2 = L2-4
          RJ = R(I)
          SJ =  REAL(Q(I))**2
          TJ = AIMAG(Q(I))
          A  = 1./((C+TJ)**2+SJ)
          G  = G*(CC+RJ)*A
            H(L2+1) = 2.*(RJ-CC)/(CC+RJ)
            H(L2+2) = 1.
            H(L2+3) = 2.*((TJ-C)*(TJ+C)+SJ)*A
            H(L2+4) = ((TJ-C)**2+SJ)*A
    3   CONTINUE
C
    4 CONTINUE
C
      GN = G
      RETURN
C****  ERROR
    5 WRITE(6,6)  FL,FH,FS
    6  FORMAT(/1X,5('?'),3X,'(EQUSTP)   INVALID INPUT   FL =',
     *        1PE14.6,3X,'FH =',E14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
      subroutine gnf(x,y,nn,f,mf,gn,ncausal)
      real*4 x(nn),y(nn),f(128)
      if(ncausal.eq.2) then
        call tandem(x,y,nn,f,mf,-1)
c        write(6,*)' TANDEM-1'
        do 813 i=1,nn
  813     x(i)=y(i)*gn
      endif
      call tandem(x,y,nn,f,mf, 1)
c      write(6,*)' TANDEM 1'
      do 815 i=1,nn
  815   x(i)=y(i)*gn
      return
      end
      SUBROUTINE  RECFIL(X,Y,N,H,NML)
      DIMENSION  X(N),Y(N),H(4)
C
C      RECURSIVE FILTERING : F(Z) = (1+A*Z+AA*Z**2)/(1+B*Z+BB*Z**2)
C
C      ARGUMENTS
C        X      : INPUT TIME SERIES
C        Y      : OUTPUT TIME SERIES  (MAY BE EQUIVALENT TO X)
C        N      : LENGTH OF X & Y
C        H      : FILTER COEFFICIENTS ; H(1)=A, H(2)=AA, H(3)=B, H(4)=BB
C        NML    : >0 ; FOR NORMAL  DIRECTION FILTERING
C                 <0 ; FOR REVERSE DIRECTION FILTERING
C
C      M. SAITO  (6/XII/75)
C
      IF(   N.LE.0 )  GO TO  4
      IF( NML.GE.0 )  GO TO  1
C****  REVERSE FILTERING
      J  = N
      JD =-1
        GO TO  2
C****  NORMAL FILTERING
    1 J  = 1
      JD = 1
C
    2 A  = H(1)
      AA = H(2)
      B  = H(3)
      BB = H(4)
      U1 = 0.
      U2 = 0.
      V1 = 0.
      V2 = 0.
C****  FILTERING
      DO  3  I=1,N
        U3 = U2
        U2 = U1
        U1 = X(J)
        V3 = V2
        V2 = V1
        V1 = U1+A*U2+AA*U3-B*V2-BB*V3
        Y(J) = V1
        J  = J+JD
    3 CONTINUE
C****  EXIT
      RETURN
C****  ERROR
    4 WRITE(6,5)  N
    5  FORMAT(//1X,5('?'),3X,'(RECFIL)',3X,'INVALID INPUT',3X,'N =',I5,
     *        3X,5('?')//)
      RETURN
      END
      SUBROUTINE  RECRES(H,M,GN,FM,DF,G,P,N)
      DIMENSION  H(4),G(N),P(N)
      DATA  PI/3.141593/,PI2/6.283185/
C
C      RECURSIVE FILTER FREQUENCY RESPONSE FUNCTION
C
C      ARGUMENTS
C        H      : COEFFICIENTS OF FILTER
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        FM     : MIN. FREQUENCY  (NON-DIMENSIONAL)
C        DF     : STEP OF FREQUENCY ; FREQ = FM,FM+DF,...,FM+(N-1)DF
C        G      : POWER TRANSFER FUNCTION
C        P      : PHASE DELAY
C        N      : NUMBER OF G & P
C
C      M. SAITO  (13/XII/75)
C
      IF( M.LE.0 .OR. N.LE.0 )  GO TO  4
      K  = M*4
      C  = GN**2
      CS = COS(FM*PI2)
      SN = SIN(FM*PI2)
      DC =-2.*SIN(DF*PI)**2
      DS = SIN(DF*PI2)
C
      DO  3  I=1,N
        GG = C
        PP = 0.
C
        DO  1  J=1,K,4
C****  NUMERATOR
          A  = (H(J+1)+1.)*CS+H(J)
          B  = (H(J+1)-1.)*SN
          GG = GG*(A**2+B**2)
          IF( GG.LE.0. )  GO TO  2
          PP = PP+ATAN2(B,A)
C****  DENOMINATOR
          A  = (H(J+3)+1.)*CS+H(J+2)
          B  = (H(J+3)-1.)*SN
          GG = GG/(A**2+B**2)
          PP = PP-ATAN2(B,A)
C****  REDUCE PHASE
          IF( ABS(PP).GT.PI )  PP = PP-SIGN(PI2,PP)
    1   CONTINUE
C
    2   G(I) = GG
        P(I) = PP
C****  STEP UP FREQUENCY
        W  = CS
        CS = CS*DC-SN*DS+CS
        SN = W *DS+SN*DC+SN
        W  = (1.-CS**2-SN**2)*0.5
        CS = CS*W+CS
        SN = SN*W+SN
    3 CONTINUE
C
      RETURN
C****  ERROR
    4 WRITE(6,5)  M,N
    5  FORMAT(//1X,5('?'),3X,'(RECRES)',3X,'INVALID INPUT',3X,'M =',I5,
     *        3X,'N =',I5,3X,5('?')//)
      RETURN
      END
      FUNCTION  SNTHET(U,Q)
C
C      JACOBI'S ELLIPTIC FUNCTION THROUGH THETA FUNCTION
C
C        SNTHET = SQRT(MOD)*SN(U*K,MOD)
C
C      WHERE
C        MOD    : MODULUS
C        K, K'  : COMPLETE ELLIPTIC INTEGRAL OF 1-ST KIND
C        Q      : K'/K
C
C      M. SAITO  (10/IX/76)
C
      IF( U.EQ.0. )  GO TO  5
      QP = Q*3.141593
      IF( QP.LE.0. )  GO TO  3
      N  = 4.1/SQRT(QP)+0.5
      IF( N.GT.10 )  GO TO  2
      IF( N.LE.0 )  GO TO  5
      X  = (U-1.)*3.141593
      XX = X*0.5
      C  = COS(X)
      CC = C*2.
      V1 = 0.
      V2 = 0.
      W1 = 0.
      W2 = 0.
      FN = N
C      GOERTZEL'S RECURSION
      DO  1  I=1,N
        V3 = V2
        V2 = V1
        V1 = V2*CC-V3+EXP(-QP*FN**2)
        W3 = W2
        W2 = W1
        W1 = W2*CC-W3+EXP(-QP*(FN-0.5)**2)
        FN = FN-1.
    1 CONTINUE
C
      SNTHET = (COS(XX)*(W1*C-W2)+SIN(XX)*W1*SIN(X))/(0.5+V1*C-V2)
      RETURN
C      N > 10
    2 SNTHET = TANH(U*1.570796/Q)
      RETURN
C      Q =< 0
    3 WRITE(6,4)  U,Q
    4  FORMAT(//1X,5('?'),3X,'(SNTHET)',3X,'INVALID INPUT',3X,'U =',
     *        E14.6,3X,'Q =',E14.6,3X,5('?')//)
C
    5 SNTHET = 0.
      RETURN
      END
      SUBROUTINE  TANDEM(X,Y,N,H,M,NML)
      DIMENSION  X(N),Y(N),H(4)
C
C      RECURSIVE FILTERING IN SERIES
C
C      ARGUMENTS
C        X      : INPUT TIME SERIES
C        Y      : OUTPUT TIME SERIES  (MAY BE EQUIVALENT TO X)
C        N      : LENGTH OF X & Y
C        H      : COEFFICIENTS OF FILTER
C        M      : ORDER OF FILTER
C        NML    : >0 ; FOR NORMAL  DIRECTION FILTERING
C                 <0 ;     REVERSE DIRECTION FILTERING
C
C      SUBROUTINE REQUIRED : RECFIL
C
C      M. SAITO  (6/XII/75)
C
      IF( N.LE.0 .OR. M.LE.0 )  GO TO  2
C****  1-ST CALL
      CALL  RECFIL(X,Y,N,H,NML)
      IF( M.LE.1 )  RETURN
C****  2-ND AND AFTER
      DO  1  I=2,M
        CALL  RECFIL(Y,Y,N,H(I*4-3),NML)
    1 CONTINUE
C
      RETURN
C****  ERROR
    2 WRITE(6,3)  N,M
    3  FORMAT(//1X,5('?'),3X,'(TANDEM)',3X,'INVALID INPUT',3X,'N =',I5,
     *        3X,'M =',I5,5('?')//)
      RETURN
      END
      SUBROUTINE  TCHHIP(H,M,GN,N,EPS,FP,FS,AP,AS)
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      CHEBYSHEV HIGH-PASS FILTER COEFFICIENT  (EQUI-RIPPLE STOP BAND)
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : ORDER OF CHEBYSHEV POLYNOMIAL
C        EPS    : RIPPLE
C        FP     : PASS BAND FREQUENCY  (NON-DIMENSIONAL)
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      M. SAITO  (1/XI/77)
C
      WP = AMAX1(ABS(FP),ABS(FS))*PI
      WS = AMIN1(ABS(FP),ABS(FS))*PI
      IF( WP.EQ.WS .OR. WS.EQ.0. .OR. WP.GE.HP )  GO TO  100
C      DETERMINE N,EPS & C
      C  = TAN(WS)
      OP = TAN(WP)/C
      TP = ALOG(OP+SQRT((OP+1.)*SIN(WP-WS)/(COS(WP)*SIN(WS))))
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.5
      IF( SA.EQ.0. )  SA = 10.
      PS = PA/SA
      N  = MAX0(2,IFIX(ABS(ALOG((1.+SQRT((1.-PS)*(1.+PS)))/PS)/TP)+0.5))
      FN = N
      EPS= SQRT(1./(PA*SA*COSH(TP*FN)))
C
      M  = N/2
      K  = M*4
      G  = 1.
      PS = ALOG((1.+SQRT(1.+EPS**2))/EPS)/FN
      CH = COSH(PS)
      SH = SINH(PS)
      DP = HP/FN
      FJ = 1.
C
      DO  1  J=1,K,4
        RJ = COS(DP*FJ)
        SJ = RJ*CH
        TJ = SIN(DP*FJ)*SH
        ST = SJ**2+TJ**2
        SJ = (SJ/ST)**2
        TJ = TJ/ST
        CR = C*RJ
        FJ = FJ+2.
        A  = 1./((C+TJ)**2+SJ)
        B  = 1.+CR**2
        G  = G*A*B/ST
          H( J ) = 2.*(CR-1.)*(CR+1.)/B
          H(J+1) = 1.
          H(J+2) = 2.*((C+TJ)*(C-TJ)-SJ)*A
          H(J+3) = ((C-TJ)**2+SJ)*A
    1 CONTINUE
C
      GN = G
      IF( MOD(N,2).EQ.0 ) RETURN
C      ODD N
      M = M+1
        GN = GN/(1.+SH*C)
          H(K+1) =-1.
          H(K+2) = 0.
          H(K+3) =-(1.-SH*C)/(1.+SH*C)
          H(K+4) = 0.
      RETURN
C      ERROR
  100 WRITE(6,101)  FP,FS
  101  FORMAT(/1X,5('?'),3X,'(TCHHIP)   INVALID INPUT   FP =',1PE14.6,
     *        3X,'FS =',E14.6,3X,5('?')/)
      RETURN
      END
      SUBROUTINE  TCHLOP(H,M,GN,N,EPS,FP,FS,AP,AS)
      DIMENSION  H(4)
      DATA  PI/3.141593/,HP/1.570796/
C
C      CHEBYSHEV LOW-PASS FILTER COEFFICIENT (EQUI-RIPPLE STOP BAND)
C
C       ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : ORDER OF CHEBYSEV POLYNOMIAL
C        EPS    : RIPPLE
C        FP     : PASS BAND FREQUENCY  (NON-DIMENSIONAL)
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN PASS BAND
C
C      M. SAITO  (1/XI/77)
C
      WP = AMIN1(ABS(FP),ABS(FS))*PI
      WS = AMAX1(ABS(FP),ABS(FS))*PI
      IF( WP.EQ.WS .OR. WP.EQ.0. .OR. WS.GE.HP )  GO TO  100
C      DETERMINE N,EPS & C
      C  = 1./TAN(WS)
      OP = 1./TAN(WP)/C
      TP = ALOG(OP+SQRT((OP+1.)*SIN(WS-WP)/(COS(WS)*SIN(WP))))
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.5
      IF( SA.EQ.0. )  SA = 10.
      PS = PA/SA
      N  = MAX0(2,IFIX(ABS(ALOG((1.+SQRT((1.-PS)*(1.+PS)))/PS)/TP)+0.5))
      FN = N
      EPS= SQRT(1./(PA*SA*COSH(TP*FN)))
C
      M  = N/2
      K  = M*4
      G  = 1.
      CH = COSH(PS)
      PS = ALOG((1.+SQRT(1.+EPS**2))/EPS)/FN
      SH = SINH(PS)
      DP = HP/FN
      FJ = 1.
C
      DO  1  J=1,K,4
        RJ = COS(DP*FJ)
        SJ = RJ*CH
        TJ = SIN(DP*FJ)*SH
        ST = SJ**2+TJ**2
        SJ = (SJ/ST)**2
        TJ = TJ/ST
        CR = C*RJ
        FJ = FJ+2.
        A  = 1./((C+TJ)**2+SJ)
        B  = 1.+CR**2
        G  = G*A*B/ST
          H( J ) =-2.*(CR-1.)*(CR+1.)/B
          H(J+1) = 1.
          H(J+2) =-2.*((C+TJ)*(C-TJ)-SJ)*A
          H(J+3) = ((C-TJ)**2+SJ)*A
    1 CONTINUE
C
      GN = G
      IF( MOD(N,2).EQ.0 )  RETURN
C      ODD N
      M = M+1
        GN = GN/(1.+SH*C)
          H(K+1) = 1.
          H(K+2) = 0.
          H(K+3) = (1.-SH*C)/(1.+SH*C)
          H(K+4) = 0.
      RETURN
C      ERROR
  100 WRITE(6,101)  FP,FS
  101  FORMAT(/1X,5('?'),3X,'(TCHLOP)   INVALID INPUT   FP =',1PE14.6,
     *        3X,'FS =',E14.6,3X,5('?')/)
      RETURN
      END
      SUBROUTINE  TCHPAS(H,M,GN,N,EPS,FL,FH,FS,AP,AS)
      DIMENSION  H(4),R(2)
      COMPLEX  Q(2),OJ,CQ
      DATA  PI/3.141593/,HP/1.570796/
C
C      CHEBYSHEV BAND-PASS FILTER COEFFICIENT  (EQUI-RIPPLE STOP BAND)
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : ORDER OF CHEBYSHEV POLYNOMIAL
C        EPS    : RIPPLE
C        FL     : LOW FREQUENCY CUT-OFF  (NON-DIMENSIONAL)
C        FH     : HIGH FREQUENCY CUT-OFF
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOO BAND
C
C      M. SAITO  (1/XI/77)
C
      WL = AMIN1(ABS(FL),ABS(FH))*PI
      WH = AMAX1(ABS(FL),ABS(FH))*PI
      WS = ABS(FS)*PI
      IF( WL.EQ.WH .OR. WL.EQ.0. .OR. WH.GE.HP .OR. WS.EQ.0. .OR.
     *    WS.GE.HP .OR. (WS-WL)*(WS-WH).LE.0. )  GO TO  100
C      DETERMINE N,EPS & C
      TL = TAN(WL)
      TH = TAN(WH)
      TS = TAN(WS)
      C  = 1./ABS(TS-TL*TH/TS)
      CC = C**2
      WW = CC*TH*TL
      CLH= COS(WL)*COS(WH)
      OP = CLH/(C*SIN(WH-WL))
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.5
      IF( SA.EQ.0. )  SA = 10.
      TP = ALOG(OP+SQRT((OP-1.)*(OP+1.)))
      PS = PA/SA
      N  = MAX0(2,IFIX(ABS(ALOG((1.+SQRT((1.-PS)*(1.+PS)))/PS)/TP)+0.5))
      FN = N
      EPS= SQRT(1./(PA*SA*COSH(TP*FN)))
C
      K  = N/2
      M  = K*2
      L  = 0
      FJ = 1.
      G  = 1.
      PS = ALOG((1.+SQRT(1.+EPS**2))/EPS)/FN
      CH = COSH(PS)
      SH = SINH(PS)
      DP = HP/FN
C
      DO  2  J=1,K
        RJ = COS(DP*FJ)
        SJ = RJ*CH
        TJ = SIN(DP*FJ)*SH
        ST = SJ**2+TJ**2
        RJ = RJ**2
        R(1) = ((1.+SQRT(1.+4.*WW*RJ))*0.5)**2/RJ
        R(2) = WW**2/R(1)
        OJ = CMPLX(SJ/ST,TJ/ST)*0.5
        FJ = FJ+2.
        CQ = CSQRT(OJ**2+WW)
        Q(1) = OJ+CQ
        Q(2) = OJ-CQ
        G  = G*RJ/ST
C
        DO  1  I=1,2
          SJ =  REAL(Q(I))**2
          TJ = AIMAG(Q(I))
          A  = 1./((C+TJ)**2+SJ)
          G  = G*(CC+R(I))*A
            H(L+1) =-2.*(CC-R(I))/(CC+R(I))
            H(L+2) = 1.
            H(L+3) = 2.*((TJ+C)*(TJ-C)+SJ)*A
            H(L+4) = ((C-TJ)**2+SJ)*A
          L  = L+4
    1   CONTINUE
C
    2 CONTINUE
C
      GN = G
      IF( MOD(N,2).EQ.0 )  RETURN
C      ODD N
      M = M+1
      WPC = CC*COS(WH-WL)/CLH
      WMC =-CC*COS(WH+WL)/CLH
          A  = 1./(WPC+C/SH)
          GN = GN*C*A/SH
            H(L+1) = 0.
            H(L+2) = -1.
            H(L+3) = 2.*WMC*A
            H(L+4) = (WPC-C/SH)*A
      RETURN
C      ERROR
  100 WRITE(6,101)  FL,FH,FS
  101  FORMAT(/1X,5('?'),3X,'(TCHPAS)   INVALID INPUT   FL =',1PE14.6,
     *        3X,'FH =',E14.6,3X,'FS =',E14.6,3X,5('?')/)
      RETURN
      END
      SUBROUTINE  TCHSTP(H,M,GN,N,EPS,FL,FH,FS,AP,AS)
      DIMENSION  H(4),R(2)
      COMPLEX  Q(2),OJ,CQ
      DATA  PI/3.141593/,HP/1.570796/
C
C      CHEBYSHEV BAND-STOP FILTER COEFFICIENT  (EQUI-RIPPLE STOP BAND)
C
C      ARGUMENTS
C        H      : FILTER COEFFICIENTS
C        M      : ORDER OF FILTER
C        GN     : GAIN FACTOR
C        N      : ORDER OF CHEBYSHEV POLYNOMIAL
C        EPS    : RIPPLE
C        FL     : LOW  FREQUENCY CUT-OFF  (NON-DIMENSIONAL)
C        FH     : HIGH FREQUENCY CUT-OFF
C        FS     : STOP BAND FREQUENCY
C        AP     : MAX. ATTENUATION IN PASS BAND
C        AS     : MIN. ATTENUATION IN STOP BAND
C
C      M. SAITO  (1/XI/77)
C
      WL = AMIN1(ABS(FL),ABS(FH))*PI
      WH = AMAX1(ABS(FL),ABS(FH))*PI
      WS = ABS(FS)*PI
      IF( WL.EQ.WH .OR. WL.EQ.0. .OR. WH.GE.HP .OR.
     *    (WS-WL)*(WS-WH).GE.0. )  GO TO  100
C      DETERMINE N,EPS & C
      TL = TAN(WL)
      TH = TAN(WH)
      TS = TAN(WS)
      C  = 1./ABS(TS-TL*TH/TS)
      CC = C**2
      WW = CC*TL*TH
      CLH= 1./(COS(WL)*COS(WH))
      OP = C*SIN(WH-WL)*CLH
      PA = AMIN1(ABS(AP),ABS(AS))
      SA = AMAX1(ABS(AP),ABS(AS))
      IF( PA.EQ.0. )  PA = 0.5
      IF( SA.EQ.0. )  SA = 10.
      TP = ALOG(OP+SQRT((OP-1.)*(OP+1.)))
      PS = PA/SA
      N  = MAX0(2,IFIX(ABS(ALOG((1.+SQRT((1.-PS)*(1.+PS)))/PS)/TP)+0.5))
      FN = N
      EPS= SQRT(1./(PA*SA*COSH(TP*FN)))
C
      K  = N/2
      M  = K*2
      L  = 0
      FJ = 1.
      G  = 1.
      PS = ALOG((1.+SQRT(1.+EPS**2))/EPS)/FN
      CH = COSH(PS)
      SH = SINH(PS)
      DP = HP/FN
C
      DO  2  J=1,K
        RJ = COS(DP*FJ)
        OJ = CMPLX(RJ*CH,-SIN(DP*FJ)*SH)*0.5
        FJ = FJ+2.
        R(1) = (0.5*(RJ+SQRT(RJ**2+4.*WW)))**2
        R(2) = WW**2/R(1)
        CQ = CSQRT(OJ**2+WW)
        Q(1) =-OJ+CQ
        Q(2) =-OJ-CQ
C
        DO  1  I=1,2
          SJ =  REAL(Q(I))**2
          TJ = AIMAG(Q(I))
          A  = 1./((C+TJ)**2+SJ)
          G  = G*(CC+R(I))*A
            H(L+1) =-2.*(CC-R(I))/(CC+R(I))
            H(L+2) = 1.
            H(L+3) = 2.*((TJ-C)*(TJ+C)+SJ)*A
            H(L+4) = ((TJ-C)**2+SJ)*A
          L  = L+4
    1   CONTINUE
C
    2 CONTINUE
C
      GN = G
      IF( MOD(N,2).EQ.0 )  RETURN
C
      M = M+1
      WPC = CC*COS(WH-WL)*CLH
      WMC =-CC*COS(WH+WL)*CLH
          A  = 1./(WPC+C*SH)
          GN = GN*WPC*A
            H(L+1) = 2.*WMC/WPC
            H(L+2) = 1.
            H(L+3) = 2.*WMC*A
            H(L+4) = (WPC-C*SH)*A
      RETURN
C      ERROR
  100 WRITE(6,101)  FL,FH,FS
  101  FORMAT(/1X,5('?'),3X,'(TCHSTP)   INVALID INPUT   FL =',1PE14.6,
     *        'FH =',E14.6,3X,'FS =',E14.6,3X,5('?')//)
      RETURN
      END
