      program fourier_plt
      parameter(nch0=12,nnch0=(nch0-1)*(nch0-2)/2,nfr0=1000)
      integer ndum(3)
      real x(nnch0,nfr0),y(nnch0,nfr0),fr(nfr0)
      character cdrv*10,cwkf*50,cdum(3)*12,com1*70,c_10(100)*10,
     *          c_11(100)*11,cform*80,cfr*8,filen*80,cspac*12,
     *          c_8(100)*8,cfile*18
      cdrv='./cca_wkf/'
c parameter file     
      cwkf=cdrv//'prm/'
      filen=cwkf(1:14)//'graph_title.txt'
      open(1,file=filen,status='old')
      read(1,'(a70)')com1
      close(1)
      filen=cwkf(1:14)//'pwrcrs3.prm'
      open(1,file=filen,status='old')
      read(1,*)fmin,fmax,dt,bw,smthf
c     read(1,*)cdum(1),n_coh_hud,n_pow_hud
      read(1,*)cdum(2),n_coh    ,n_pow
      close(1)
      iist=1
      if(n_huddle.eq.0) iist=2
      do ii=iist,2
       do i=12,1,-1
        if(cdum(ii)(i:i).NE.' ') go to 10
       enddo
   10  ndum(ii)=i
c      write(6,*)ndum(ii),cdum(ii)(1:ndum(ii))
      enddo
      n_huddle=0
c
      filen=cdrv//'data/resampled_files/'//cdum(2)(1:ndum(2))
c     write(6,*)filen
      open(1,file=filen,status='old')
      read(1,*)nch,mmblk,nblk
      close(1)
      td=real(nblk)*dt
c     write(6,*)'Td=',td
      cwkf=cdrv//'prm/gnuplt_script/'
      filen=cwkf(1:28)//'fourier.plt'
      open(21,file=filen,status='unknown')
      write(21,*)
     *  'set palette define (0 "black", 1 "yellow", 2 "light-green",',
     * ' 3 "light-blue", 4 "coral", 5 "khaki", 6 "navy", 7 "purple",',
     *  ' 8 "turquoise", 9 "red", 10 "grey50")'
c
      if(n_pow.eq.1) then
c       write(6,*)
c     * 'Do you want to plot the spectra against',
c     * ' 0:period or 1:frequency?'
c       read(5,*)n_freq
        n_freq=1
       if(n_freq.eq.0) then
c       write(6,*)'Period'
       else
c       write(6,*)'Frequency'
       endif
c fsp
       cwkf=cdrv//'prm/gnuplt_script/'
       filen=cwkf(1:28)//cdum(2)(1:ndum(2)-4)//'_fsp.plt'  ! GNUPLOT scripts file
       write(21,*)'load '''//filen(1:32+ndum(2))//''''
c      write(21,*)'pause -1 "Hit return to continue"'
       write(6,*)filen
       open(12,file=filen,status='unknown')
c
       cwkf=cdrv//'data/results/'
       filen=cwkf(1:23)//cdum(2)(1:ndum(2)-4)//'_psp.dat'  ! data file
       cfile=filen(24:27+ndum(2))
c      write(6,*)filen
       open(1,file=filen,status='old')
       write(cform,'(a4,i2,a4)')'(a8,',2*nch+1,'a10)'
       read(1,cform)cfr,(c_10(ii),ii=1,nch)
c      write(6,cform)cfr,(c_10(ii),ii=1,nch)
       do ifr=1,nfr0
        read(1,*, end=110)fr(ifr),(x(ii,ifr),ii=1,nch)
       enddo
  110  nfr=ifr-1
       close(1)
       write(6,*)'td=',td
       pai2=2.*3.141592
       do ifr=1,nfr
        do ii=1,nch
         x(ii,ifr)=sqrt(real(x(ii,ifr))*td)/(Pai2*fr(ifr))
        enddo
       enddo
       open(1,file=cwkf(1:23)//'temp1.dat',status='unknown')
       write(cform,'(a1,i2,a6)')'(',nch+1,'e10.3)'
       if(n_freq.eq.0) then
        do ifr=1,nfr        ! Period
         write(1,cform)1/fr(ifr),(x(ii,ifr),ii=1,nch)
        enddo
       else                 ! Frequency
        do ifr=1,nfr
         write(1,cform)fr(ifr),(x(ii,ifr),ii=1,nch)
        enddo
       endif
       close(1)
c
       xmin=x(1,1)
       xmax=x(1,1)
       do ii=1,nch
        do ifr=1,nfr
         if(xmin.gt.x(ii,ifr)) xmin=x(ii,ifr)
         if(xmax.lt.x(ii,ifr)) xmax=x(ii,ifr)
        enddo
       enddo
c      write(6,*)xmin,xmax
       xmin=10.**real(int(log10(xmin)))/10.
       xmax=10.**real(int(log10(xmax)))
c      write(6,*)xmin,xmax
       if(n_freq.eq.0) then
c        tmin=0.05
c        tmax=10.0
        tmin=1./fmax
        tmax=1./fmin
       else
c        if(fmin.lt.1.0) then
c         fmin=0.1
c        else 
c         fmin=0.8
c        endif
c        if(fmax.gt.10) then
c         fmax=20.0
c        else
c         fmax=10.0
c        endif
       endif
c
       write(12,*)'set termoption noenhanced'
       write(12,*)'reset'
       write(12,*)'set key left top'
       write(12,*)'# Graph title'
c      write(12,*)'set title "'//com1(1:70)//' "'
       write(12,*)'set title "'//cfile//': '//com1(1:50)//' "'
       write(12,*)'# Horizontal axis: label & range'
       if(n_freq.eq.0) then
        write(12,*)'set xlabel "Period (sec)  "'
        write(12,*)'set xrange [',tmin,':',tmax,']'
       else
        write(12,*)'set xlabel "Frequency (Hz)  "'
        write(12,*)'set xrange [',fmin,':',fmax,']'
       endif
       write(12,*)'set logscale x'
       write(12,*)'# Verical axis: label & range'
       write(12,*)'set ylabel "FSD [M/Sec Sec]"'
       write(12,*)'set yrange [',xmin,':',xmax,']'
       write(12,*)'set logscale y'
       write(12,*)'set format y "%.1E"'
       write(12,*)'set grid'
       write(12,*)'set multiplot'
       write(cform,'(a5,i2,a24)')
     *       '(a6,a',32,',a10,i2,a20,i2,a8,a4,a4)'
       ich=2
       write(12,cform)'plot "',cwkf(1:23)//'temp1.dat',
     *              '" using 1:',ich,
     *              ' with lines lw 3 lc ',ich-1,
     *              ' title "',c_10(ich-1)(7:10),'", \'
       do ich=3,nch
       write(12,cform)'     "',cwkf(1:23)//'temp1.dat',
     *              '" using 1:',ich,
     *              ' with lines lw 3 lc ',ich-1,
     *              ' title "',c_10(ich-1)(7:10),'", \'
       enddo
       ich=nch+1
       write(12,cform)'     "',cwkf(1:23)//'temp1.dat',
     *              '" using 1:',ich,
     *              ' with lines lw 3 lc ',ich-1,
     *              ' title "',c_10(ich-1)(7:10),'"   '
       write(12,*)'unset multiplot'
c
       write(12,*)'set terminal postscript color noenhanced'
       write(6,*)filen(24:23+ndum(2)-3)//'fsp'//'.ps'
       write(12,*)
     * 'set output "./cca_wkf/data/results/fig_interim/'//
     *           filen(24:23+ndum(2)-3)//'fsp'//'.ps"'
       write(12,*)'reset'
       write(12,*)'set key left top'
       write(12,*)'# Graph title'
c      write(12,*)'set title "'//com1(1:70)//' "'
       write(12,*)'set title "'//cfile//': '//com1(1:50)//' "'
       write(12,*)'# Horizontal axis: label & range'
       if(n_freq.eq.0) then
        write(12,*)'set xlabel "Period (sec)  "'
        write(12,*)'set xrange [',tmin,':',tmax,']'
       else
        write(12,*)'set xlabel "Frequency (Hz)  "'
        write(12,*)'set xrange [',fmin,':',fmax,']'
       endif
       write(12,*)'set logscale x'
       write(12,*)'# Verical axis: label & range'
       write(12,*)'set ylabel "FSD [M/Sec Sec]"'
       write(12,*)'set yrange [',xmin,':',xmax,']'
       write(12,*)'set logscale y'
       write(12,*)'set format y "%.1E"'
       write(12,*)'set grid'
       write(12,*)'set multiplot'
       write(cform,'(a5,i2,a24)')
     *       '(a6,a',32,',a10,i2,a20,i2,a8,a4,a4)'
       ich=2
       write(12,cform)'plot "',cwkf(1:23)//'temp1.dat',
     *              '" using 1:',ich,
     *              ' with lines lw 3 lc ',nch-ich+1,
     *              ' title "',c_10(ich-1)(7:10),'", \'
       do ich=3,nch
       write(12,cform)'     "',cwkf(1:23)//'temp1.dat',
     *              '" using 1:',ich,
     *              ' with lines lw 3 lc ',nch-ich+1,
     *              ' title "',c_10(ich-1)(7:10),'", \'
       enddo
       ich=nch+1
       write(12,cform)'     "',cwkf(1:23)//'temp1.dat',
     *              '" using 1:',ich,
     *              ' with lines lw 3 lc ',nch-ich+1,
     *              ' title "',c_10(ich-1)(7:10),'"   '
       write(12,*)'unset multiplot'
       write(12,*)'set output'
       write(12,*)'set terminal x11'
       close(12)
      endif
      stop
      end
