      program lsh2lsm
c program to convert the files of one hour (binary) made by ls8800 
c (win format) to those of one minute (binary).
c                           copyright T. Yokoi, IISEE, BRI May 12 2019
c
      parameter (nsite0=4,kbni=7,kbno=8,nfile0=100)
      character filen*80,cdrv*15,cdir_i*80,cdir_o*80,cdummy*80,
     *          cnum(10)*1
c     common /a_infor/nyear,nmont,ndays,nhour,nmins
      data  cnum/'1','2','3','4','5','6','7','8','9','a'/
c current directry:
      cdrv='./cca_wkf/data/'
c directory of input files (one-hour files) 
      write(cdir_i,'(a15,a10)')cdrv,'lsh_files/'
c open log file
      write(filen,'(a25,a10)')cdir_i,'mf_s_e.dat'
      open(3,file=filen,status='unknown') 
c open input file list
      write(filen,'(a25,a11)')cdir_i,'1h_file.lst'
      open(1,file=filen,status='old') 
c
      do ifile=1,nfile0   ! loop over input 1h files
c
       read(1,'(a14)',end=999)cdummy
       do ii=1,nsite0
        if(cnum(ii).eq.cdummy(5:5))then
         isite=ii
         go to 10
        endif
       enddo
   10  continue
c directory of output files (one-minutes files)
       write(cdir_o,'(a15,a11,i1,a1)')cdrv,'ls_files/no',isite,'/'
c      write(6,'(a28)')cdir_o
c name of input 1h file
       filen=cdrv//'lsh_files/'//cdummy(3:14)
       write(6,'(a10,a13)')'1h_files: ', filen(25:37)
       write(3,'(a10,a13)')'1h_files: ', filen(25:37)
c========================================================
c                                                       |
       call lsh_lsm(kbni,kbno,filen,cdir_o)             !
c                                                       |
c========================================================
c
      enddo               ! loop over input 1h files
  999 close(1)
      close(3)
      stop
      end
c+++++
      subroutine lsh_lsm(kbni,kbno,filen,cdir_o)
      character cx(0:511)*1,filen*80,filem*80,cdir_o*80,
     *          cdate(6)*2,cdummy*80
      integer   ndate(6)
c open input data file for one hour:
      open(kbni,file=filen,access='direct',recl=1,form='unformatted')
c loop over second block:
      nblock=3600          ! one-hour file </= 3600 second blocks
      i0=0                 ! initilize pointer
      n_out=0     ! initialize the flag for output to 1m_file
      n_nxt=0     ! initialize the flag for terminate 1m_file creation
c
      do iblock =1,nblock  ! loop over one-second block
c      write(6,*) iblock
c
       do i=i0+1,i0+10     ! block size (0-3) & header (4-9)
        read(kbni,rec=i,err=9999)  cx(i-i0-1) 
       enddo
       i0=i-1
c one-second header: block size of 1s block
       nblk_size=ichar(cx(0))*256**3+ichar(cx(1))*256**2+
     +           ichar(cx(2))*256   +ichar(cx(3))
c      write(6,*)'Block Size = ',nblk_size  ! size of 1s block
c one-second header: year, month, day, hour, min., sec.
       ndate(1)=10*int(ichar(cx( 4))/16)+Mod(ichar(cx( 4)),16) ! nyear
       ndate(2)=10*int(ichar(cx( 5))/16)+Mod(ichar(cx( 5)),16) ! nmont
       ndate(3)=10*int(ichar(cx( 6))/16)+Mod(ichar(cx( 6)),16) ! ndays
       ndate(4)=10*int(ichar(cx( 7))/16)+Mod(ichar(cx( 7)),16) ! nhour
       ndate(5)=10*int(ichar(cx( 8))/16)+Mod(ichar(cx( 8)),16) ! nmins
       ndate(6)=10*int(ichar(cx( 9))/16)+Mod(ichar(cx( 9)),16) ! nsecs
c      write(6,*)nyear,nmont,ndays,nhour,nmins,nsecs  ! 
       do idate=1,6
        if(ndate(idate).lt.10) then
         write(cdate(idate),'(a1,i1)')'0',ndate(idate)
        else
         write(cdate(idate),'(i2)'   )    ndate(idate)
        endif
       enddo
c      write(6,'(6i2)')(ndate(idate),idate=1,6)
c      write(6,'(6a2)')(cdate(idate),idate=1,6)
c      write(6,*) n_out,n_nxt
       if(ndate(5).eq.59.and.ndate(6).eq.59) then  ! nmins=59, nsecs=59
        n_nxt=1                    ! final second block of this 1h file
       endif
c Judge for 0 second & activate output to one-minute file
       if(ndate(6).eq.0) then ! nsecs=0
        if(n_out.eq.1) then
         close(kbno)
        else
         n_out=1     ! activate the flag for output to one-minute file
c        write(3,'(a22,a28,4a2,a1,2a2)')
c    *   'Output activated from ',cdir_o,
c    *   (cdate(idate),idate=1,4),'.',cdate(5),cdate(6)
         write(3,'(2x,a5,4a2,a1,2a2)')
     *   'Act: ',(cdate(idate),idate=1,4),'.',cdate(5),cdate(6)
        endif
c open new one-minute file
        write(cdummy,'(4a2,a1,a2)')
     *    cdate(1),cdate(2),cdate(3),cdate(4),'.',cdate(5)
c       write(6,*)cdummy
        write(filem,'(a28,a11)')cdir_o,cdummy
c       if(ndate(5).eq.0.or.ndate(5).eq.59) then
c        write(6,'(a6,a39)')'Open: ',filem
c       endif
        open(kbno,file=filem,access='direct',recl=1,
     *            form='unformatted',status='unknown',action='write')
        j0=0              ! initialize rec number of the output 1m file 
       endif
c
       if(n_out.eq.1) then
        do j=j0+1,j0+10
         write(kbno,rec=j) cx(j-j0-1)
        enddo
        j0=j-1
       endif
c
c channel block loop:
       do ich=1,3
        do i=i0+1,i0+4
         read(kbni,rec=i,err=9999)cx(i-i0-1)  ! ch number,sample size(byte),number of samples
        enddo
        i0=i-1
        if(n_out.eq.1) then
         do j=j0+1,j0+4
          write(kbno,rec=j) cx(j-j0-1)
         enddo
         j0=j-1
        endif
c
        nsample_size=int(ichar(cx(2))/16)          ! Number of samples
        nsample=Mod(ichar(cx(2)),16)+ichar(cx(3))  ! Sampling frequency
c
        do i=i0+1,i0+4
         read(kbni,rec=i,err=9999)  cx(i-i0-1) ! the first sample
        enddo
        i0=i-1
        if(n_out.eq.1) then
         do j=j0+1,j0+4
          write(kbno,rec=j) cx(j-j0-1)
         enddo
         j0=j-1
        endif
c data loop for each channel
        if(nsample_size.ge.1) then
         do k=2,nsample
          do i=i0+1,i0+nsample_size
           read(kbni,rec=i,err=9999)  cx(i-i0-1)
          enddo
          i0=i-1
          if(n_out.eq.1) then
           do j=j0+1,j0+nsample_size
            write(kbno,rec=j) cx(j-j0-1)
           enddo
           j0=j-1
          endif
         enddo           ! data loop
        else if(nsample_size.eq.0) then   ! 0.5byte data
         do k=2,int(nsample/2)+1
          i=i0+1
          read(kbni,rec=i,err=9999)  cx(0)
          i0=i
          if(n_out.eq.1) then
           j=j0+1
           write(kbno,rec=j) cx(0)
           j0=j
          endif
         enddo
        endif
       enddo           ! channel loop
 9990  continue
       if(n_nxt.eq.1) then
        n_nxt=0
        goto 9999      ! end of 1h_file
       endif
      enddo            ! one-second block loop 
 9999 continue
c     write(3,'(a22,a28,4a2,a1,2a2)')
c    *   'One min file closed:  ',cdir_o,
c    *   (cdate(idate),idate=1,4),'.',cdate(5),cdate(6)
      write(3,'(2x,a5,4a2,a1,2a2)')
     *   'End: ',(cdate(idate),idate=1,4),'.',cdate(5),cdate(6)
      close(kbni)
c
      return
      end
