      program lstocdm2
c program to convert the files made by ls8800 (win format) to cdm(ascii) format
c                                   copyright T. Yokoi, IISEE, BRI Mar. 7 2017
c corrected for 0.5byte data reading       by T. Yokoi, IISEE, BRI Apr.20 2017
c
      parameter (nn0=360000,nch0=3,kbn=20)
      real      xx(nn0,nch0),scale(nch0),sens(nch0)
      integer   ndum(8),npiv(nch0)
      character filen*80,adum*11,bdum*12,file_s*80,file_e*80,
     +          filem*80,cdummy*80,cname*2,chnam(nch0)*4,
     +          chlabel(nch0)*2
      character cdrv*10
c     common /a_infor/nyear,nmont,ndays,nhour,nmins,ndum2
c switch: nflg1=1 creation of one minute files in ascii format
      data nflg1/0/ nfile/10/  ! create 10 min files 
      data chlabel/'NS','EW',' V'/ 
c on the current directry: parameter file
      cdrv='./cca_wkf/'
      filen=cdrv//'prm/lstocdm2.prm'
      write(6,*)'Parameter file: ',filen
      open(1,file=filen,status='old')
c
      read(1,*)ncase
      do icase=1,ncase
c data directory:
      read(1,*)
      read(1,*)bdum
c     write(6,*)'Directory of input data files:', bdum
      write(6,'(a18,a8)')'Name of the site: ',bdum(1:8) 
      bdum=bdum(10:12)
      write(6,'(a16,a3)')'No. of station: ',bdum
      if(bdum(1:2).ne.'no') then
       write(6,*)'Inappropriate Descrption in',
     *           './spacwkf/prm/lstocdm2.prm'
      endif
      read(1,*)(sens(ich),ich=1,nch0)
      write(6,*)'Sensitivity(M/s): ',(sens(ich),ich=1,nch0)  ! V/M/sec
      read(1,*)(chlabel(ich),ich=1,nch0)
      write(6,*)'Components: ',(chlabel(ich),ich=1,nch0)  ! V/M/sec
c scale=voltage per Least Significant Bit (V/LSB)
      read(1,*)scale0
      write(6,*) 'voltage per Least Significant Bit',scale0,'(V/LSB)'
      do ich=1,nch0
       scale(ich)=scale0/sens(ich)*1.0E5        ! mkine/LSB        
      enddo
      write(6,*)(scale(ich),ich=1,nch0)
      read(1,*)cname,nfile
      read(1,*)(npiv(ich),ich=1,nch0), nchout
      if(nchout.eq.0) then
       nchout=3
       write(6,'(a21,3(2x,a2))')'Output all 3 channels', 
     +           (chlabel(npiv(ich)),ich=1,nch0)
      else if(nchout.eq.1) then
       write(6,'(a16,2x,a2)')'Output 1 channel', chlabel(npiv(1))
      else
       write(6,*)'Error at output channel selection.'
       stop
      endif
c
  100 read(1,'(a11,i5)')adum,noutf0
c     if(adum.eq.'           ') then
c      write(6,*)'To the next case'
c      go to 900
c     endif
      file_s=adum 
      write(6,'(2(a11,1x),a2,i5,a5)')
     *             'Start from:',file_s,', ',nfile,' files'
c
c loop over combined output files
      do noutf=0,noutf0-1
c
      if(noutf.eq.0) then
       read(adum,'(4i2,1x,i2)')l1,l2,l3,l4,l5
      else
       l5=m5+1      ! minute
       l4=m4        ! hour
       l3=m3        ! day
       l2=m2        ! month
       l1=m1        ! year-2000
       if(l5.ge.60) then
        l4=l4+1
        l5=l5-60
       endif
       if(l4.ge.24) then
        l3=l3+1
        l4=l4-24
       endif
      endif
c     write(6,*)l1,l2,l3,l4,l5
      m5=l5+nfile-1
      if(m5.ge.60) then
       m4=l4+1
       m5=m5-60
      else
       m4=l4
      endif
      if(m4.ge.24) then
       m3=l3+1
       m4=l4-24
      else
       m3=l3
      endif
      m2=l2
      m1=l1
c     write(6,*)'                     ',m1,m2,m3,m4,m5
      write(file_e,'(4i2,a1,i2)')m1,m2,m3,m4,'.',m5
      if(m1.lt.10) write(file_e(1:1),'(a1)') '0'
      if(m2.lt.10) write(file_e(3:3),'(a1)') '0'
      if(m3.lt.10) write(file_e(5:5),'(a1)') '0'
      if(m4.lt.10) write(file_e(7:7),'(a1)') '0'
      if(m5.lt.10) write(file_e(10:10),'(a1)') '0'
c      write(6,*)file_s,'_',file_e
c output file name: 1st file name _ final file name
      if(noutf.eq.0) then
       namin=l5
       nahor=l4
       naday=l3
      else
       namin=namin+nfile
       if(namin.ge.60) then
        namin=namin-60
        nahor=nahor+1
       endif
       if(nahor.ge.24) then
        nahor=nahor-24
        naday=naday+1
       endif
      endif
      write(file_s(10:11),'(i2)') namin
      if(namin.lt.10) file_s(10:10)='0'
      write(file_s(7:8),'(i2)') nahor
      if(nahor.lt.10) file_s(7:7)='0'
      write(file_s(5:6),'(i2)') naday
      if(naday.lt.10) file_s(5:5)='0'
      filen=cdrv//'data/ls_files/Combined_Data'//
     *    '/'//cname//file_s(5:8)//file_s(10:11)//'.cdm'
      write(6,*)'Output file: ',filen
      open(10,file=filen,status='unknown')
      write(10,'(a5,a23)')'File=',file_s(1:11)//'_'//file_e(1:11)
      write(10,'(22x,a5,a5)') 'UNIT=','mkine'
      write(10,'(22x,3(6x,a4,6x))')(chlabel(npiv(ich)),ich=1,nchout) 
c
c loop over one-minute files
      do ifile=0,nfile-1
c one-minute file name
       m5=l5+ifile
       if(m5.ge.60) then
        m4=l4+1
        m5=m5-60
       else
        m4=l4
       endif
       if(m4.ge.24) then
        m3=l3+1
        m4=l4-24
       else
        m3=l3
       endif
       m2=l2
       m1=l1
       write(file_e,'(4i2,a1,i2)')m1,m2,m3,m4,'.',m5
       if(m1.lt.10) write(file_e(1:1),'(a1)') '0'
       if(m2.lt.10) write(file_e(3:3),'(a1)') '0'
       if(m3.lt.10) write(file_e(5:5),'(a1)') '0'
       if(m4.lt.10) write(file_e(7:7),'(a1)') '0'
       if(m5.lt.10) write(file_e(10:10),'(a1)') '0'
       filem=cdrv//'data/ls_files/'//bdum(1:3)//'/'//file_e(1:11)
       if(ifile.eq.0) write(6,*)'Input file: ',filem
c
c
      call ls_read(kbn,filem,xx,nn0,nch0,ndata,nsample,dt)
c     write(6,*) 'ndata=',ndata,'nsample=',nsample,'dt=',dt
c DC comp. removal
       do ich=1,nch0
        sum=0.0
        do i=1,ndata
         sum=sum+xx(i,ich)
        enddo
        ave=sum/real(ndata)
        do i=1,ndata
         xx(i,ich)=xx(i,ich)-ave
        enddo
       enddo
c combined output:
       do i=1,ndata
        tt=real(i-1)*dt+real(ifile)*60.0
        asec=tt-int(tt/60.)*60
        nmin=mod(int(tt/60.),60)
        nhou=int(int(tt/60.)/60)
        write(cdummy(1:9),'(i8,a1)') i-1+ifile*60*nsample,' '
c       write(6,'(i8,a1)') i-1+ifile*60*nsample,' '
        if(nhou.lt.10) then
         write(cdummy(10:12),'(a1,i1,a1)')'0',nhou,':'
        else
         write(cdummy(10:12),'(i2,a1)')nhou,':'
        endif  
        if(nmin.lt.10) then
         write(cdummy(13:15),'(a1,i1,a1)')'0',nmin,':'
        else
         write(cdummy(13:15),'(i2,a1)')nmin,':'
        endif  
        if(asec.lt.10.0) then
         write(cdummy(16:21),'(a1,f5.3)')'0',asec
        else
         write(cdummy(16:21),'(f6.3)') asec
        endif  
c
        if(nchout.eq.3) then
         write(cdummy(22:69),'(3e16.7)')
c    *      (xx(i,npiv(ich)),ich=1,nch0)
     *      (xx(i,npiv(ich))*scale(npiv(ich)),ich=1,nch0)
         write(10,'(a69)')cdummy
        else if(nchout.eq.1) then
         write(cdummy(22:37),'(e16.7)') 
c    *       xx(i,npiv(1))
     *       xx(i,npiv(1))*scale(npiv(1))
         write(10,'(a37)')cdummy
        endif
       enddo
c
      enddo   ! loop over one-minute input files
      close(10)
      enddo   ! loop over combined output files
c     go to 100  
      enddo   ! loop over cases
c
  999 close(1)
      stop
      end
c+++++
      subroutine ls_read(kbn,filen,xx,nn0,nch0,ndata,nsample,dt)
c 
      real      xx(nn0,nch0),z(200)
      character cx(0:511)*1,filen*80,cdum*25
c     common /a_infor/nyear,nmont,ndays,nhour,nmins,ndum2
      data cdum/'All zero for 0.5byte data'/
c open data file for one minute:
      open(kbn,file=filen,access='direct',recl=1,form='unformatted')
c loop over second block: 60 blocks in one minute file
      nblock=60            ! 60 one second blocks in one minute file
      i0=0                 ! initilize pointer
      do iblock =1,nblock
c
      do i=i0+1,i0+10
       read(kbn,rec=i) cx(i-i0-1)
      enddo
      i0=i-1
c one second block:
       nblk_size=ichar(cx(0))*256**3+ichar(cx(1))*256**2+
     +           ichar(cx(2))*256   +ichar(cx(3))
c      write(6,*)'Block Size = ',nblk_size  ! size of 1 sec block
c one second header: year, month, day, hour, min., sec1, sec2 in "BCD"
       nyear=10*int(ichar(cx( 4))/16)+Mod(ichar(cx( 4)),16)
       nmont=10*int(ichar(cx( 5))/16)+Mod(ichar(cx( 5)),16)
       ndays=10*int(ichar(cx( 6))/16)+Mod(ichar(cx( 6)),16)
       nhour=10*int(ichar(cx( 7))/16)+Mod(ichar(cx( 7)),16)
       nmins=10*int(ichar(cx( 8))/16)+Mod(ichar(cx( 8)),16)
       nsecs=10*int(ichar(cx( 9))/16)+Mod(ichar(cx( 9)),16)
c      write(6,*)nyear,nmont,ndays,nhour,nmins,nsecs  ! ,ichar(cx( 9))
c channel block loop:
       do ich=1,3
        do i=i0+1,i0+4
         read(kbn,rec=i) cx(i-i0-1)
        enddo
        i0=i-1
        ndum1=ichar(cx(0))     ! ??????? identifier
        ndum2=ichar(cx(1))     ! channel identifier
c       write(6,*)ndum1,ndum2+1,'ch'
        nsample_size=int(ichar(cx(2))/16)
        nsample=Mod(ichar(cx(2)),16)+ichar(cx(3))
        dt=1./real(nsample)
c       write(6,*)ndum2+1,nsample_size,'Bytes',nsample,'Hz'  ! ,'dt=',dt,'sec'
c first data (4byte)
        do i=i0+1,i0+4
         read(kbn,rec=i) cx(i-i0-1)
        enddo
        i0=i-1
c       write(6,*)ichar(cx(0))
        if(ichar(cx(0)).gt.127) then
         z(1)=-((((255-ichar(cx(0)))*256+255-ichar(cx(1)))*256
     +            +255-ichar(cx(2)))*256+256-ichar(cx(3)))        ! Negative
        else
         z(1)=((ichar(cx(0))*256+ichar(cx(1)))*256                
     +         +ichar(cx(2)))*256+ichar(cx(3))                    ! Positive
        endif
c data loop for a channel
        if(nsample_size.ge.1) then
         do j=2,nsample
          do i=i0+1,i0+nsample_size
           read(kbn,rec=i) cx(i-i0-1)
          enddo
          i0=i-1
c
          if(nsample_size.eq.1) then                  ! 1Byte data 
           if(ichar(cx(0)).gt.127) then 
            z(j)=-(256-ichar(cx(0)))                  ! Negative
           else
            z(j)=ichar(cx(0))                         ! Positive
           endif
          else if(nsample_size.eq.2) then             ! 2Byte data 
           if(ichar(cx(0)).gt.127) then 
            z(j)=-((255-ichar(cx(0)))*256+256-ichar(cx(1)))       ! Negative
           else
            z(j)=ichar(cx(0))*256+ichar(cx(1))        ! Positive
           endif
          else if(nsample_size.eq.3) then             ! 3Byte data
           if(ichar(cx(0)).gt.127) then
            z(j)= -(((255-ichar(cx(0)))*256+255-ichar(cx(1)))
     *                                 *256+256-ichar(cx(2)))     ! Negative
           else
            z(j)=(ichar(cx(0))*256+ichar(cx(1)))*256+ichar(cx(2)) ! Positive
           endif
          else if(nsample_size.eq.4.or.nsample_size.eq.5) then       ! 4Byte data
           if(ichar(cx(0)).gt.127) then
            z(j)=-((((255-ichar(cx(0)))*256+255-ichar(cx(1)))*256
     +               +255-ichar(cx(2)))*256+256-ichar(cx(3)))     ! Negative
           else
            z(j)=((ichar(cx(0))*256+ichar(cx(1)))*256                
     +           +ichar(cx(2)))*256+ichar(cx(3))                 ! Positive
           endif
          else if(nsample_size.gt.5) then
           write(6,*)'Error-1 in binary input file!'
           write(6,*)'sample size=', nsample_size
           stop
          endif
c
         enddo           ! data loop
        else if(nsample_size.eq.0) then                       ! 0.5byte data
         do j=2,int(nsample/2)+1
          i=i0+1
          read(kbn,rec=i) cx(0)
          i0=i
          x_upper=int(ichar(cx(0))/16)
          x_lower=mod(ichar(cx(0)),16)
          if(x_upper.gt.7) then                               ! Negative
           z(2*j-2)=-(16-x_upper)
          else                                                ! Positive
           z(2*j-2)= x_upper
          endif
          if(2*j-1.le.nsample) then
           if(x_lower.gt.7) then                               ! Negative
            z(2*j-1)=-(16-x_lower)
           else                                                ! Positive
            z(2*j-1)= x_lower
           endif
          endif
         enddo
         z_max=z(2)
         do j=3,nsample
          if(z_max.lt.z(j)) z_max=z(j)
         enddo
        if(z_max.le.1.e-8) then
          write(6,'(a25,4(1x,i2),1x,a3,i2,f10.1)')
     *         cdum,ndays,nhour,nmins,nsecs,'ch-',ndum2,z_max
        endif
        else
         write(6,*)'Error-2 in binary input file!'
         write(6,*)'sample size=', nsample_size
         stop
        endif
c
        xx(nsample*(iblock-1)+1,ich)=z(1)
        if(nsample_size.le.4) then
         do j=2,nsample
          xx(nsample*(iblock-1)+j,ich)=
     *             xx(nsample*(iblock-1)+j-1,ich)+z(j) 
         enddo 
        else if(nsample_size.eq.5) then
         do j=2,nsample
          xx(nsample*(iblock-1)+j,ich)=z(j) 
         enddo 
        else
          write(6,*)'Error-3 in binary input file!'
          write(6,*)'sample size=', nsample_size
        endif
c
       enddo           ! channel loop
cc
c      do j=1,nsample
c        write(6,*)j,(xx(nsample*(iblock-1)+j,ich), ich=1,nch0)   ! test
c       enddo
cc
      enddo            ! second block loop 
      ndata=nsample*nblock
c
 9999 continue 
c     write(6,*)'end of ',filen
      close(kbn)
c
      return
      end
