      program multi_pre
      parameter(np0=4,n_mea0=50)
      integer   npv(np0)
      character cdrv*10,cwkf*80,c_1st*8,c_ext*4,ccom*50,file_out*6
      character clabel(np0,n_mea0)*8,filen*80
      character c1*1,c2*2,c4*4
c root folder name
      data cdrv/'./cca_wkf/'/ 
c working folder name
      cwkf=cdrv//'prm/'
      write(6,*)' Working Folder=',cwkf(1:14)
c default values
      dt=0.01
      np=np0
      tst=0.0
      file_out='CC.dat'
c parameter file (input)
      filen=cwkf(1:14)//'multi_pre.prm'
      open(1,file=filen,status='old')
      read(1,'(a50)') ccom   ! comment (a50)
      read(1,*) ndurm        ! duration of each connected file in min.(integer)
      read(1,*) c_1st        ! V1122035    : first file name (yymmddhh.mm)
      read(1,*) c_ext(2:4)   ! extention (A3) 
      read(1,*) (npv(jp),jp=1,np) ! station pivot
      read(1,*) n_mea        ! number of output connected files
      close(1)
      nnp=np
      do jp=1,np
       if(npv(jp).eq.0) nnp=nnp-1 
      enddo
      np=nnp
      write(6,'(a19)')'  Default Settings:'
      write(6,'(a13,f4.1)')'    dt      =',dt
      write(6,'(a13,i4)'  )'    np      =',np
      write(6,'(a13,f4.1)')'    tst     =',tst
      write(6,'(a13,a8)'  )'    file_out=','CC**.dat'
      write(6,*)
c calculated values
      tdur=real(ndurm)*60.   ! sec
      c_ext(1:1)='.'
c parameter file (output)
      filen=cwkf(1:14)//'multipx6.prm'
      open(1,file=filen,status='unknown')
      write(1,'(4x,a1,23x,a17)')'1',    ': Number of cases'
      write(1,'(28x,a25)')              ': This blank is necessary'
      write(1,'(i3,f6.3,19x,a25)')np,dt,': Number of obs points,dt'
      write(1,'(2f12.1,4x,a15)')tst,tdur,': tst,tdur(sec)'
      write(1,'(a11,17x,a44)')'1.e0  mkine',
     *     ': scale(input data is divided by this scale)'
      write(1,'(a16,12x,a35,a29)')' 0 3 0.1 1.0 1.5',
     *     ': nfilter(=1:apply), ncharacter(=2:',
     *     'lowpass,=3:bandpass),fl,fh,fs'
      write(1,'(2(a4,10x),a18)')'  4 ',c_ext,': nattach, cattach'
      write(1,'(a11,17x,a40)')' 2   CC    ',
     *     ': n_out(A12),cout ("**.dat" is attached)'
      write(1,'(a50,a14)')ccom,': comment(A50)'
      write(1,'(i5,5x,a8,10x,2a34)')n_mea,'8',
     *     ': number of measurement in the sam',
     *     'e array configuration,n_character '
c input file list                        ! V1122035
      read(c_1st,'(a1)')     c1          ! V
      read(c_1st(3:4),'(i2)') nday       ! 12
      read(c_1st(5:8),'(2i2)')nhour,nmin ! 20 35
      nmin=nmin-ndurm
      if(nmin.lt.0) then
       nmin=nmin+60
       nhour=nhour-1
       if(nhour.lt.0) then
        nhour=nhour+24
        nday=nday-1
       endif
      endif
      do i_mea=1,n_mea
       nmin=nmin+ndurm
       if(nmin.ge.60) then
        nmin=nmin-60
        nhour=nhour+1
        if(nhour.ge.24) then
         nhour=nhour-24
         nday=nday+1
        endif
       endif
       do ip=1,np
        write(clabel(ip,i_mea)(1:8),'(a1,i1,3i2)')
     *                             c1,npv(ip),nday,nhour,nmin
        if( nday.lt.10) write(clabel(ip,i_mea)(3:3),'(a1)')'0'
        if(nhour.lt.10) write(clabel(ip,i_mea)(5:5),'(a1)')'0'
        if( nmin.lt.10) write(clabel(ip,i_mea)(7:7),'(a1)')'0'
       enddo
       write(6,'(4(a8,1x))')(clabel(ip,i_mea),ip=1,np)
      enddo
      do i_mea=1,n_mea
       write(1,'(4(a8,1x))')(clabel(ip,i_mea),ip=1,np)
      enddo
      close(1)
c graph title
      filen=cwkf(1:14)//'graph_title.txt'
      open(1,file=filen,status='unknown')
      write(1,'(a50)')ccom
      close(1)
      stop
      end
