      include 'dgflt.f'
      program multipx6
c program to multiplex the microtremor data observed independently
c & simultaneously.
c
c				                Apr,13,2010 T. Yokoi, IISEE, BRI
c bandpass filter introduced                    Jun,10,2016 T. Yokoi, IISEE, BRI
c renovated                                     Mar.10,2017 T. Yokoi, IISEE, BRI
c
      parameter(nmax=1200000,nch0=15)
      character cline(3)*80,cdum*13,filen*80,cfn(nch0)*20,
     *          cdummy*8,cout*12,cattach*50,cform1*15,cform2*15,
     *		comment*50,cchar*10
c     character cdrv*3,cwkf*11
c     character cdrv*2,cwkf*2
      character cdrv*10,cwkf*80,cunit*5
      real*4 x(nmax,nch0),y(nmax)
      data cchar/'0123456789'/
c default values
      data fl,fh,fs/0.033,10.,12./ ap,as/0.1,10.0/
c Chebishev I(2), Lowpass (2) Bandpass(3), Causal(1)
      data ntype,nchara,ncausal/2,3,1/
c root folder name
      data cdrv/'./cca_wkf/'/ 
c working folder name
      cwkf=cdrv//'prm/'
      write(6,*)' Working Folder=',cwkf(1:14)
      filen=cwkf(1:14)//'multipx6.prm'
      open(10,file=filen,status='old')
c
      read(10,*) ntr
      read(10,*)
      do itr=1,ntr
c
c channel number
      read(10,*)nch,dt
      write(6,*)' Nch=',nch,' dt=',dt
c start and end time 
      read(10,*)tst,tdur
      nst0=int(tst/dt)+1
      ndur0=int(tdur/dt)
c scale factor fixed for all measurement
      read(10,*)scale,cunit
      write(6,*)' Scale Factor=',scale
      write(6,*)' Does this scale convert the unit of data mkine ?'
      write(6,*)' Please change the value if not.' 
      read(10,*)nfilter,nchara,fl,fh,fs
      write(6,*)nfilter,nchara,fl,fh,fs
c number of letters, character string automatically attched to the input file name
      read(10,*)nattach,cattach
c output file name
      read(10,*)n_out,cout
c comment
      read(10,'(a50)')comment
      write(6,*)comment
c number of measurement in the same array configuration
      read(10,*)n_mea,ncfrm
c      
      call formatter(nch,cform1,cform2)
c
      do i_mea=1,n_mea
c      write(6,*)i_mea,'-th measurement:',nch
c input file names
       read(10,*)(cfn(ich),ich=1,nch)
       write(6,'(7(a8,1x))')(cfn(ich),ich=1,nch)
       ndat=ndur0
       cwkf=cdrv//'data/cdm_files/'
       do j=1,nch
        filen=cwkf(1:25)//cfn(j)(1:ncfrm)//cattach(1:nattach)
        open(1,file=filen,status='old')
        do i=1,3
         read(1,'(a80)')cline(i)
        enddo
c       cunit=cline(2)(28:32)
        do i=1,nst0-1
         read(1,*)cdummy
        enddo
c       write(6,*)j,scale
        do i=1,ndur0
c read input data
         read(1,*,end=10)cdummy,cdum,xdum
c         read(1,*,end=10)cdum,xdum
ccccc        if(j.eq.4)xdum=xdum*0.1 !for gain arrangement
	 x(i,j)=xdum/scale
        enddo
   10   ndur0=i-1
c       write(6,*)ndur0
        close(1)
       enddo
c Bandpass filter
        do j=1,nch
         if(nfilter.eq.1) then
c         write(6,*)'bandpass filter applied','j=',j,ndur0
         else
c         write(6,*)' DC and trend removal only'
         endif
         do i=1,ndur0
          y(i)=x(i,j)
         enddo
         call taper(y,ndur0,dt)
         sum=0.0
         nnave=1./dt          ! 1 sec
c         do i=1,nnave
c          sum=sum+y(i)
c         enddo
c         ave=sum/real(nnave)
c         do i=1,ndur0
c          y(i)=y(i)-ave
c         enddo
         ntaper=nnave  
         do i=1,ntaper+1
          y(i)=y(i)*real(i-1)/real(ntaper)
         enddo   
         if(nfilter.eq.1) then
         write(6,*)ndur0,dt,fl,fh,fs,ap,as,ntype,nchara,ncausal  
c
         call bandp1(y,ndur0,dt,fl,fh,fs,ap,as,ntype,nchara,ncausal)
c
         endif
         do i=1,ndur0
          x(i,j)=y(i)
         enddo
        enddo
c
c
       cwkf=cdrv//'data/multiplexed_files/'
c
       i_mea1=mod(i_mea,10)
       if(i_mea.lt.10) then
        filen=cwkf(1:33)//cout(1:n_out)//'0'
     *                          //cchar(i_mea1+1:i_mea1+1)//'.dat'
       else if(i_mea.lt.100) then
	  i_mea2=mod(i_mea/10,10)
        filen=cwkf(1:33)//cout(1:n_out)//cchar(i_mea2+1:i_mea2+1)
     *                           //cchar(i_mea1+1:i_mea1+1)//'.dat'
       else
        write(6,*) 'measurement number > 99.'
       endif
c      write(6,*)filen
       open(2,file=filen,status='unknown')
       write(2,'(i8,f8.4,e16.4,i8,2x,a5)')nch,dt,scale,ndur0,cunit
       write(2,'(a50)')comment
       do i=1,ndur0
        write(2,cform2)real(i-1)*dt,(x(i,j),j=1,nch)
       enddo
      enddo
      read(10,*,end=999)
c
      enddo
      close(10)
      write(6,*)'Normal End'
c
  999 stop
      end
c+++++
      subroutine formatter(nch,cform1,cform2)
      character cform1*15,cform2*15
      if(nch.ge.10) then
       write(cform1,'(a4,i2,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a7,i2,a6)')'(f12.6,',nch,'e15.7)'
      else if(nch.ge.3) then
       write(cform1,'(a4,1x,i1,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a7,1x,i1,a6)')'(f12.6,',nch,'e15.7)'
      else
       write(6,*)'nch should be bigger than 2!'
      endif
      end
c+++++
      subroutine taper(x,n,dt)
      real x(n)
      data pai/3.141592/
      mwin=int(real(n)/20.+0.5)
c linear trend fitting
      b1=x(1)
      do i=2,n
       b1=b1+real(i)*x(i)
      enddo
      b2=x(1)
      do i=1,n
       b2=b2+x(i)
      enddo
      a0=real(n*(n+1)*(2*n+1))/6.*dt
      b0=real(n*(n+1))/2.
      c0=b0*dt
      d0=real(n)
      f0=a0*d0-b0*c0
      aa=( d0*b1-b0*b2)/f0
      bb=(-c0*b1+a0*b2)/f0
      do i=1,n
       x(i)=x(i)-aa*real(i)*dt-bb
      enddo
      return
      end
c+++++

