      Program pwrcrs3
c caluculate the followings for multichannel microremor data
c multi-dataset version
c  1. power & cross-spectra
c  2. Parzen window
c  3. block averaging
c  4. correction for sensor characteristics 
c  5. Integration over azimuth
c  6. Spectral smoothing
c  7. CCA coefficient & Incoming Azimuth
c
c If a sensor is located at the center of the circler array and used 
c for incoherent noise correction, the corresponding data must be 
c assigned to ch-1. Then, other channels must be listed following
c the order counter clock wise. The value of the azimuth of the first
c peripheral sensor must be given to the parameter ph00 and the in-coming
c azimuth of the pre-dominant wave is calculated. 
c
c                     copyright Toshiaki. Yokoi, IISEE, BRI, Japan Dec. 26, 2007
c
c  Ref:Cho et al.(2006), J. Geophys. Res., 111, B09315.
c
c Updatead at Feb. 10, 2012: 
c     Spectral smoothing of G{Z0,Z0(r,r,omg)}, G{Z1,Z1(r,r,omg)} using esmthf.
c     Modification for system correction using Huddle test records.
c     Upgrade of calculation of phase velocity from CCA coefficient.
c  
c Last update at Apr. 13 2017:
c
c Note: Uncertainty analysis is not completed, yet
c
      parameter(nn0=4096,nmax=nn0,nch0=12,ij00=nch0*(nch0+1)/2,
     *                                   mblk0=2048,lmax0=1024)
      complex   c0,cr_sum,cr_ave,cz,
     *          cf(nn0),cg(nn0),crr(nn0,nch0**2),
     *          cr(nn0,nch0**2),sd(nn0,nch0**2),
     *          cr0(nn0,nch0**2),sd0(nn0,nch0**2),
     *          cv(nn0,nch0,nch0),cv0(nn0,nch0,nch0),
     *          coh0(nn0,nch0**2),soh0(nn0,nch0**2), 
     *          cof(nn0,nch0**2), 
     *          coh1(nn0,nch0**2),soh1(nn0,nch0**2),
     *          cdum(nch0,nch0),sp0(nn0,4),cp0(nn0,4)
      real      x(nn0,nch0),f(nn0),g(nn0),fr(nn0),w(lmax0),
     *          h(nn0),g1(nn0**2),g2(nn0**2),kr,
     *          au(nn0,nch0**2),au0(nn0,nch0**2),
     *          bu(nn0,nch0**2),bu0(nn0,nch0**2),az(nch0)
      integer   nf(nch0**2),ng(nch0**2),kk(nch0)
      character filen*80,finput*12,cunit*5,
     *          cform1*24,cform2*21,cform3*30,cform4*21,cform9*18
      character cdrv*2,cwkf*10
      data cdrv/'./'/ 
      data c0,eps/(0.,0.),1.e-3/ pai/3.141592/
      ppai=180./pai
      write(6,*)'Program pwrcrs3.for'
c working folder name
      cwkf=cdrv//'cca_wkf/'
      open(20,status='scratch')
      open(21,status='scratch')
      open(22,status='scratch')
c parameter file
      filen=cwkf//'prm/pwrcrs3.prm'
      open(11,file=filen,status='old')
      write(6,*)filen
      read(11,*)fmin,fmax,dt,bw,n_huddle,smthf
c
      f_nyq=0.5/dt*0.95
      if(fmax.ge.f_nyq) then
       fmax=f_nyq
       write(6,*)'fmax is adjusted below f_Nyquist:',fmax
      endif
c
      if(n_huddle.le.0) then
       read(11,*)
       write(6,*)'go to 100'
       go to 100
      else if(n_huddle.eq.2) then
       write(6,*)'go to 90'
       go to 90
      endif
c
c read huddle test file
c
c file name for huddle test
      read(11,*) finput,n_coh,n_pow
      n_plg=n_pow
      filen=cwkf//'data/resampled_files/'//finput
      write(6,*)finput,filen,n_coh,n_plg
      open(12,file=filen,status='old')
      read(12,'(i2,2i5,i2,2f8.2,1x,a18,1x,a5)')
     *      nch,mblk,nn,nch_center,ph0,rr,cform9,cunit
      write(6,'(i2,2i5,i2,2f8.2,1x,a18,1x,a5)')
     *      nch,mblk,nn,nch_center,ph0,rr,cform9,cunit
      if(rr.gt.eps) then
       write(6,*)' This file is not of Huddle Test!'
       stop
      endif
      if(cunit.eq.'mkine') scale=1.e-5  ! mkine to M/sec
      if(cunit.eq.'gal  '.or.cunit.eq.'gal') scale=1.e-2  ! gal to M/sec^2
      read(12,*)idum,t1
      read(12,*)idum,t2
      dt1=t2-t1
      backspace(12)
      backspace(12)
      if(abs(dt-dt1).ge.eps) then
       write(6,*)' dt does not coincide.',dt,dt1,dt-dt1
       stop
      else
       dt=dt1
      endif      
c duration and frequency
      td=real(nn)*dt   
      if(bw.gt.eps.and.bw.le.3.71/td) then
       write(6,*)' bw is too small, use bigger than',3.71/td
       stop
      endif
      do i=1,nn
       fr(i)=real(i-1)/td
      enddo
      isf=int(fmin/fr(2)+0.5)
	if(isf.eq.1) isf=isf+1
      ief=int(fmax/fr(2))
c calculate power & cross spectra of field data file
      do iblk=1,mblk
       if(mod(iblk,10).eq.0) then
        write(6,*) mblk,iblk
       endif
c read input data
       do i=1,nn
        read(12,cform9) idum,t,(x(i,ich),ich=1,nch)
       enddo
c 
       ij=0
       do ii=1,nch
        do jj=ii,nch
         ij=ij+1
         nf(ij)=ii
         do i=1,nn
          f(i)=x(i,ii)
         enddo
         call taper(f,nn,dt)
         do i=1,nn
          cf(i)=cmplx(f(i)*scale,0.0)
         enddo
c Fourier Transform
         call cfft(cf,nn,-1)
         do i=1,nn
          cf(i)=cf(i)/real(nn)
         enddo
c
         ng(ij)=jj
         do i=1,nn
          g(i)=x(i,jj)
         enddo
         call taper(g,nn,dt)
         do i=1,nn
          cg(i)=cmplx(g(i)*scale,0.0)
         enddo
c Fourier Transform
         call cfft(cg,nn,-1)
         do i=1,nn
          cg(i)=cg(i)/real(nn)
         enddo
c cross-correlation of cf(i) and cg(i) in the frequency domain
         do i=1,nn
          cf(i)=cf(i)*conjg(cg(i))
         enddo
c Parzen window 
         if(bw.ge.eps) then
          do i=1,nn
           f(i)= real(cf(i))
           g(i)=aimag(cf(i))
          enddo
          call w_parzen(f,nn,nmax,dt,bw,g1,g2,nmax*2,w,lmax0)
          call w_parzen(g,nn,nmax,dt,bw,g1,g2,nmax*2,w,lmax0)
          do i=1,nn
           cf(i)=cmplx(f(i),g(i))
          enddo
         endif
c store into temporary file
         do i=1,nn
          write(20,*)iblk,ij,i,cf(i)	
         enddo
        enddo
       enddo
       ij0=ij
      enddo
      close(12)
      rewind(20)
c
      ij=0
      do ii=1,nch
       do jj=ii,nch
        ij=ij+1
        if(ii.eq.jj) then
         kk(nf(ij))=ij
        endif
       enddo
      enddo
c auto and cross spectra and their variance
      write(6,*)
     * ' power and cross spectra for huddle test data calculated.'
c average
      do ij=1,ij0
       do i=1,nn
        cr0(i,ij)=c0
        cof(i,ij)=c0
       enddo
      enddo
      do iblk=1,mblk
       do ij=1,ij0
        do i=1,nn
         read(20,*)iblk_dum,ij_dum,i_dum,crr(i,ij)
         if(i.ne.i_dum.or.ij.ne.ij_dum.or.iblk.ne.iblk_dum) then
          write(6,*) ' Error in reading temporary file!'
          stop
         endif
         cr0(i,ij)=cr0(i,ij)+crr(i,ij)
        enddo
       enddo
       do i=1,nn
        do ij=1,ij0
          cr_ave=sqrt(real(crr(i,kk(nf(ij))))*real(crr(i,kk(ng(ij)))))
     *                                                     /crr(i,ij)
          cof(i,ij)=cof(i,ij)+cmplx(atan2(aimag(cr_ave),real(cr_ave)))
        enddo
       enddo
      enddo
c average of cross spectra
      do ij=1,ij0
       do i=1,nn
        cr0(i,ij)=cr0(i,ij)/real(mblk)
        cof(i,ij)=cof(i,ij)/real(mblk)
       enddo
      enddo		  
      do ij=1,ij0
       do i=1,nn
        ar_ave=real(cof(i,ij))
c        cof(i,ij)=cmplx(cos(ar_ave),sin(ar_ave))/real(cr0(i,1))
        cof(i,ij)=cmplx(cos(ar_ave),sin(ar_ave))
       enddo
      enddo		  
c variance
      rewind(20)
      do i=1,nn
       do ij=1,ij0
        sd0(i,ij)=c0
        au0(i,ij)=0.
        bu0(i,ij)=0.
       enddo
       do ich=1,nch
        do jch=1,nch
         cv0(i,ich,jch)=c0
        enddo
       enddo
      enddo
      do iblk=1,mblk
       do ij=1,ij0
        do i=1,nn
         read(20,*)iblk_dum,ij_dum,i_dum,crr(i,ij)
         if(i.ne.i_dum.or.ij.ne.ij_dum.or.iblk.ne.iblk_dum) then
          write(6,*) ' Error in reading temporary file!'
          stop
         endif
c variance of power & cross spectra
         sd0(i,ij)=sd0(i,ij)
     *            +cmplx(( real(crr(i,ij))- real(cr0(i,ij)))**2,
     *                   (aimag(crr(i,ij))-aimag(cr0(i,ij)))**2)
c variance of correction factor cof(i,ij)
c         if(ij,eq,1) then
c          sof(i,ij)=c0
c         else
c          cr_ave=real(crr(i,1)/crr(i,ij))
c          sof(i,ij)=sof(i,ij)+cmplx(( real(cr_ave)- real(cof(i,ij)))**2,
c                                    (aimag(cr_ave)-aimag(cof(i,ij)))**2)
c         endif
c covariance among real & imaginary parts of cross spectra
         bu0(i,ij)=bu0(i,ij)+ real(crr(i,ij)-cr0(i,ij))*
     *                       aimag(crr(i,ij)-cr0(i,ij))
        enddo
       enddo
       do ij=1,ij0
        ii=nf(ij)
        jj=ng(ij)
        ki=kk(ii)
        kj=kk(jj)
        if(nf(ij).ne.ng(ij)) then
         do i=1,nn
c covariance among different channel of power spectra
          au0(i,ij)=au0(i,ij)+real(crr(i,ki)-cr0(i,ki))*
     *                        real(crr(i,kj)-cr0(i,kj))
c covariance among power spectra & cross spectra
          cv0(i,ii,jj)=cv0(i,ii,jj)+cmplx(
     *    real(crr(i,ki)-cr0(i,ki))* real(crr(i,ij)-cr0(i,ij)),
     *    real(crr(i,ki)-cr0(i,ki))*aimag(crr(i,ij)-cr0(i,ij)))
          cv0(i,jj,ii)=cv0(i,jj,ii)+cmplx(
     *    real(crr(i,kj)-cr0(i,kj))* real(crr(i,ij)-cr0(i,ij)),
     *    real(crr(i,kj)-cr0(i,kj))*aimag(crr(i,ij)-cr0(i,ij)))
         enddo
        endif
       enddo
      enddo
      do ij=1,ij0
       do i=1,nn
        sd0(i,ij)=sd0(i,ij)/real(mblk)
        au0(i,ij)=au0(i,ij)/real(mblk)
        bu0(i,ij)=bu0(i,ij)/real(mblk)
       enddo
       if(nf(ij).ne.ng(ij)) then
        do i=1,nn
         cv0(i,nf(ij),ng(ij))=cv0(i,nf(ij),ng(ij))/real(mblk)
         cv0(i,ng(ij),nf(ij))=cv0(i,ng(ij),nf(ij))/real(mblk)
        enddo
       endif
      enddo
      rewind(20)
      write(6,*)'Block Averaging has been done.'
c format controller
      call formatter(nch,cform1,cform2,cform3,cform4)
c power spectra output
      if(n_pow.ne.0) then
       filen=cwkf//'data/results/'//finput(1:6)//'_psp.dat'
       write(6,*)filen,'Power Spectra Output for Huddle Test:',filen 
       open(2,file=filen,status='unknown')
       if(n_pow.eq.1) then
        write(2,cform1)'   Freq.', (ich,'-ch ',ich=1,nch),
     *              ' Power Spc', (ich,'-ch ',ich=1,nch),' S.D.     '
        if(rr.lt.0.) then		   ! Negative rr ==> Pulse test
c         do k=isf,ief 
c          a2a=(2.*pai*fr(k))**4
c          write(2,cform2)fr(k),(a2a*real(cr0(k,kk(ich))),ich=1,nch),
c     *                   (sqrt(real(sd0(k,kk(ich)))),ich=1,nch)
c         enddo
        else
         do k=isf,ief 
        if(cunit.eq.'mkine') then   ! velocity input
         a2a=td*(2.*pai*fr(k))**2
        else if(cunit.eq.'gal'.or.cunit.eq.'gal  ') then
         a2a=td
        endif
          write(2,cform2)fr(k),
     *          (a2a*     real(cr0(k,kk(ich))) ,ich=1,nch),
     *          (a2a*sqrt(real(sd0(k,kk(ich)))),ich=1,nch)
         enddo
        endif
c	write(6,*)cform1,cform2
       else if(n_pow.eq.2) then
        write(2,'(a8,10(7x,i1,a1,i1,a2,12x))')
     *     '   Freq.',(nf(ij),'-',ng(ij),'ch',ij=1,ij0)
        do k=isf,ief 
         write(2,'(f8.6,20e12.5)')
     *     fr(k),(real(cr0(k,ij)),aimag(cr0(k,ij)),ij=1,ij0)
        enddo
        stop
       endif
       close(2)
      endif
c
      do ij=1,ij0
       if(nf(ij).ne.ng(ij)) then
        do i=isf,ief
         xx=cabs(cr0(i,kk(nf(ij))))
         yy=cabs(cr0(i,kk(ng(ij))))
         cz=cr0(i,ij)
c complex coherence function
         coh0(i,ij)=cz/sqrt(xx*yy)
c variance
         sxx=real(sd0(i,kk(nf(ij))))/xx**2
         syy=real(sd0(i,kk(ng(ij))))/yy**2
         sxy=au0(i,ij)/(xx*yy)
         zz=real(cz)
         sxz=real(cv0(i,nf(ij),ng(ij)))/(xx*zz)
         syz=real(cv0(i,ng(ij),nf(ij)))/(yy*zz)
         szz=real(sd0(i,ij))/zz**2
         f2=real(coh0(i,ij))**2
         sxr=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
         if(sxr.lt.0.) sxr=abs(sxr)
         zz=aimag(cz)
         sxz=aimag(cv0(i,nf(ij),ng(ij)))/(xx*zz)
         syz=aimag(cv0(i,ng(ij),nf(ij)))/(yy*zz)
         szz=aimag(sd0(i,ij))/zz**2
         f2=aimag(coh0(i,ij))**2
         sxi=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
         if(sxi.lt.0) sxi=abs(sxi)
         soh0(i,ij)=cmplx(sxr,sxi)
        enddo
       endif
      enddo
c coherence output
      if(n_coh.ne.0) then
       filen=cwkf//'data/results/'//finput(1:6)//'_coh.dat'
       write(6,*)filen,' Coherence Output for Huddle Test.' 
       open(2,file=filen,status='unknown')
       write(2,cform3)
     *  '   Freq.',  ((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' Coherence',((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' S.D.     '
c
       do k=isf,ief
        id=0
        do ij=1,ij0
         if(nf(ij).lt.ng(ij)) then
          id=id+1
          f(id)=real(coh0(k,ij))
          g(id)=sqrt(real(soh0(k,ij)))
         endif
        enddo
        id0=id
        write(2,cform4) fr(k),(f(id),id=1,id0),(g(id),id=1,id0)
       enddo
       close(2)
      endif
   90 continue
c
  100 continue
      if(n_huddle.le.0) then
       write(6,*)' Huddle Test Skipped.'
      else
       write(6,*)' Correction using Huddle Test Data is conducted.'
      endif
c
c read field data file
c
      read(11,*) finput,n_coh,n_pow
      n_plg=n_pow
      filen=cwkf//'data/resampled_files/'//finput
      open(12,file=filen,status='old')
      read(12,'(i2,2i5,i2,2f8.2,1x,a18,1x,a5)')
     *      nch,mblk,nn_1,nch_center,ph0,rr,cform9,cunit
      write(6,'(i2,2i5,i2,2f8.2,1x,a18,1x,a5)')
     *      nch,mblk,nn_1,nch_center,ph0,rr,cform9,cunit
      if(rr.le.eps) then
       write(6,*)' This file is not of a field data!'
      endif
      if(nn_1.ne.nn.and.n_huddle.gt.0) then
	 write(6,*)' Block size not coincide!'
       stop
      else if(nn_1.ne.nn.and.n_huddle.le.0) then
       nn=nn_1
      endif
      call formatter(nch,cform1,cform2,cform3,cform4)
      read(12,*)idum,t1
      read(12,*)idum,t2
      dt1=t2-t1
      backspace(12)
      backspace(12)
      if(abs(dt-dt1).ge.eps) then
       write(6,*)' dt does not coincide.',dt,dt1,dt-dt1
       stop
      else
       dt=dt1
      endif      
      if(cunit.eq.'mkine') scale=1.e-5
      if(cunit.eq.'gal  '.or.cunit.eq.'gal') scale=1.e-2
c duration and frequency
      td=real(nn)*dt
      if(bw.gt.eps.and.bw.le.3.71/td) then
       write(6,*)' bw is too small, use bigger than',3.71/td
       stop
      endif
      do i=1,nn
       fr(i)=real(i-1)/td
      enddo
      isf=int(fmin/fr(2)+0.5)
      if(isf.eq.1) isf=isf+1
      ief=int(fmax/fr(2))
c calculate power & cross spectra of field data file
      do iblk=1,mblk
       if(mod(iblk,10).eq.0) write(6,*) mblk,iblk
c read input data
       do i=1,nn
        read(12,cform9)idum,t,(x(i,ich),ich=1,nch)
       enddo
c 
       ij=0
       do ii=1,nch
        do jj=ii,nch
	   ij=ij+1
	   nf(ij)=ii
	   do i=1,nn
          f(i)=x(i,ii)
 	   enddo
         call taper(f,nn,dt)
         do i=1,nn
          cf(i)=cmplx(f(i)*scale,0.0)
         enddo
c Fourier Transform
         call cfft(cf,nn,-1)
         do i=1,nn
          cf(i)=cf(i)/real(nn)
         enddo
c
         ng(ij)=jj
         do i=1,nn
          g(i)=x(i,jj)
         enddo
         call taper(g,nn,dt)
         do i=1,nn
          cg(i)=cmplx(g(i)*scale,0.0)
         enddo
c Fourier Transform
         call cfft(cg,nn,-1)
         do i=1,nn
          cg(i)=cg(i)/real(nn)
         enddo
c cross-correlation of cf(i) and cg(i) in the frequency domain
         do i=1,nn
          cf(i)=cf(i)*conjg(cg(i))	
         enddo
c Parzen window 
         if(bw.ge.eps) then
          do i=1,nn
           f(i)= real(cf(i))
           g(i)=aimag(cf(i))
          enddo
          call w_parzen(f,nn,nmax,dt,bw,g1,g2,nmax*2,w,lmax0)
          call w_parzen(g,nn,nmax,dt,bw,g1,g2,nmax*2,w,lmax0)
          do i=1,nn
           cf(i)=cmplx(f(i),g(i))
          enddo
         endif
c store into temporary file
         do i=1,nn
          write(20,*)iblk,ij,i,cf(i)	
         enddo
        enddo
       enddo
       ij0=ij
      enddo
      close(12)
      rewind(20)
c
      ij=0
      do ii=1,nch
       do jj=ii,nch
        ij=ij+1
        if(ii.eq.jj) then
         kk(nf(ij))=ij
        endif
       enddo
      enddo
c auto and cross spectra and their variance
      write(6,*)' power and cross spectra for field data calculated.'
c average
      do ij=1,ij0
       do i=1,nn
        cr(i,ij)=c0
       enddo
      enddo
      do iblk=1,mblk
       do ij=1,ij0
        do i=1,nn
         read(20,*)iblk_dum,ij_dum,i_dum,crr(i,ij)
         if(i.ne.i_dum.or.ij.ne.ij_dum.or.iblk.ne.iblk_dum) then
          write(6,*) ' Error in reading temporary file!'
          stop
         endif
         cr(i,ij)=cr(i,ij)+crr(i,ij)
        enddo
       enddo
      enddo
      do ij=1,ij0
       do i=1,nn
        cr(i,ij)=cr(i,ij)/real(mblk)
       enddo
      enddo
c variance
      rewind(20)
      do i=1,nn
       do ij=1,ij0
        sd(i,ij)=c0
        au(i,ij)=0.
        bu(i,ij)=0.
       enddo
       do ich=1,nch
        do jch=1,nch
         cv(i,ich,jch)=c0
        enddo
       enddo
      enddo
c
      do iblk=1,mblk
       do ij=1,ij0
        do i=1,nn
         read(20,*)iblk_dum,ij_dum,i_dum,crr(i,ij)
         if(i.ne.i_dum.or.ij.ne.ij_dum.or.iblk.ne.iblk_dum) then
          write(6,*) ' Error in reading temporary file!'
          stop
         endif
         sd(i,ij)=sd(i,ij)+cmplx((real(crr(i,ij))- real(cr(i,ij)))**2,
     *                          (aimag(crr(i,ij))-aimag(cr(i,ij)))**2)
c covariance among real & imaginary parts of cross spectra
         bu(i,ij)=bu(i,ij)+ 
     *            real(crr(i,ij)-cr(i,ij))*aimag(crr(i,ij)-cr(i,ij))
        enddo
       enddo
       do ij=1,ij0
        ii=nf(ij)
        jj=ng(ij)
        ki=kk(ii)
        kj=kk(jj)
        if(nf(ij).ne.ng(ij)) then
         do i=1,nn
c covariance among different channel of power spectra
          au(i,ij)=au(i,ij)+real(crr(i,ki)-cr(i,ki))*
     *                      real(crr(i,kj)-cr(i,kj))
c covariance among power spectra & cross spectra
          cv(i,ii,jj)=cv(i,ii,jj)+cmplx(
     *    real(crr(i,ki)-cr(i,ki))* real(crr(i,ij)-cr(i,ij)),
     *    real(crr(i,ki)-cr(i,ki))*aimag(crr(i,ij)-cr(i,ij)))
          cv(i,jj,ii)=cv(i,jj,ii)+cmplx(
     *    real(crr(i,kj)-cr(i,kj))* real(crr(i,ij)-cr(i,ij)),
     *    real(crr(i,kj)-cr(i,kj))*aimag(crr(i,ij)-cr(i,ij)))
         enddo
        endif
       enddo
      enddo
      do ij=1,ij0
       do i=1,nn
        sd(i,ij)=sd(i,ij)/real(mblk)
        au(i,ij)=au(i,ij)/real(mblk)
        bu(i,ij)=bu(i,ij)/real(mblk)
       enddo
       if(nf(ij).ne.ng(ij)) then
        do i=1,nn
         cv(i,nf(ij),ng(ij))=cv(i,nf(ij),ng(ij))/real(mblk)
         cv(i,ng(ij),nf(ij))=cv(i,ng(ij),nf(ij))/real(mblk)
        enddo
       endif
      enddo
      rewind(20)
      write(6,*)'Block Averaging has been done.'
c format controller
      call formatter(nch,cform1,cform2,cform3,cform4)
c power spectra output
      if(n_pow.ne.0) then
       filen=cwkf//'data/results/'//finput(1:6)//'_psp.dat'
       write(6,*)filen,'Power Spectra Output:',filen 
       open(2,file=filen,status='unknown')
       write(2,cform1)'   Freq.', (ich,'-ch ',ich=1,nch),
     *              ' Power Spc', (ich,'-ch ',ich=1,nch),' S.D.     '
       do k=isf,ief 
        if(cunit.eq.'mkine') then   ! velocity input
         a2a=td*(2.*pai*fr(k))**2
        else if(cunit.eq.'gal'.or.cunit.eq.'gal  ') then
         a2a=td
        endif
        write(2,cform2)fr(k),
     *          (a2a*     real(cr(k,kk(ich))) ,ich=1,nch),
     *          (a2a*sqrt(real(sd(k,kk(ich)))),ich=1,nch)
       enddo
       close(2)
      endif
c
      do ij=1,ij0
       if(nf(ij).ne.ng(ij)) then
        do i=isf,ief
         xx=cabs(cr(i,kk(nf(ij))))
         yy=cabs(cr(i,kk(ng(ij))))
         cz=cr(i,ij)
c complex coherence function
         coh1(i,ij)=cz/sqrt(xx*yy)
c variance
         sxx=real(sd(i,kk(nf(ij))))/xx**2
         syy=real(sd(i,kk(ng(ij))))/yy**2
         sxy=au(i,ij)/(xx*yy)
c
         zz=real(cz)
         sxz=real(cv(i,nf(ij),ng(ij)))/(xx*zz)
         syz=real(cv(i,ng(ij),nf(ij)))/(yy*zz)
         szz=real(sd(i,ij))/zz**2
         f2=real(coh1(i,ij))**2
         sxr=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
         if(sxr.lt.0.) sxr=abs(sxr)
         zz=aimag(cz)
         sxz=aimag(cv(i,nf(ij),ng(ij)))/(xx*zz)
         syz=aimag(cv(i,ng(ij),nf(ij)))/(yy*zz)
         szz=aimag(sd(i,ij))/zz**2
         f2=aimag(coh1(i,ij))**2
         sxi=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
         soh1(i,ij)=cmplx(sxr,sxi)
        enddo
       endif
      enddo
c coherence output
      if(n_coh.ne.0) then
       filen=cwkf//'data/results/'//finput(1:6)//'_coh.dat'
       write(6,*)filen,' Coherence Output' 
       open(2,file=filen,status='unknown')
       write(2,cform3)
     *  '   Freq.',  ((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' Coherence',((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' S.D.     '
c
       do k=isf,ief
        id=0
        do ij=1,ij0
         if(nf(ij).lt.ng(ij)) then
          id=id+1
          f(id)=real(coh1(k,ij))
          g(id)=sqrt(real(soh1(k,ij)))
         endif
        enddo
        id0=id
        write(2,cform4) fr(k),(f(id),id=1,id0),(g(id),id=1,id0)
       enddo
       close(2)
      endif
      close(20)
c correction using power spectra of the Field data
c estimation of variance is not completed.
c
      do k=isf,ief
       do ij=1,ij0
        if(n_huddle.eq.1) then
         coh1(k,ij)=cof(k,ij)                                         
     *           /sqrt(real(cr(k,kk(nf(ij))))*real(cr(k,kk(ng(ij)))))
        else if(n_huddle.eq.0) then
         coh1(k,ij)=
     *         1./sqrt(real(cr(k,kk(nf(ij))))*real(cr(k,kk(ng(ij)))))
        else if(n_huddle.eq.-1) then
         coh1(k,ij)=(1.,0.)
        endif
       enddo
       do ij=1,ij0
       cof(k,ij)=coh1(k,ij)
	 enddo
c power spectra 1ch and its variance
      coh0(k,1)=cr(k,1)
      soh0(k,1)=sd(k,1)
      enddo
c correction for system characteristics using auto & cross spectra of huddle test file
c system characteristics of all channels are ajusted to those of the 1-ch
c variance
      do k=isf,ief
       do ij=1,ij0
        zr= real(cr(k,ij))
        zi=aimag(cr(k,ij))
        xx=real(cr(k,kk(nf(ij))))
        yy=real(cr(k,kk(ng(ij))))
c variance/variable^2
        sxx = real(sd(k,kk(nf(ij))))/xx**2
        syy = real(sd(k,kk(ng(ij))))/yy**2
        if(nf(ij).ne.ng(ij)) then
         szzr= real(sd(k,ij))/zr**2
         szzi=aimag(sd(k,ij))/zi**2
        else	      ! if(nf(ij).eq.ng(ij)) then
         szzr=sxx   ! ==> variance of power spectra
         szzi=0.    ! zi=0 always
        endif
c covariance/variables
        if(nf(ij).ne.ng(ij)) then
         sxy =au(k,ij)/(xx*yy)
         sxzr= real(cv(k,nf(ij),ng(ij)))/(xx*zr)
         syzr= real(cv(k,ng(ij),nf(ij)))/(yy*zr)
         sxzi=aimag(cv(k,nf(ij),ng(ij)))/(xx*zi)
         syzi=aimag(cv(k,ng(ij),nf(ij)))/(yy*zi)
         szri=bu(k,ij)/(zr*zi)
        else	     ! if(nf(ij).eq.ng(ij)) then
         sxy =sxx  ! ==> variance of power spectra
         sxzr=sxx  !	==> variance of power spectra
	   syzr=sxx  !	==> variance of power spectra
         sxzi=0.	 ! zi=0 always
         syzi=0.	 ! zi=0 always
         szri=0.	 ! zi=0 always
        endif
c
        syrr=zr**2/(xx*yy)*((sxx+2.*sxy+syy)/4.+szzr-sxzr-syzr)
        if(syrr.lt.0.) syrr=abs(syrr)
        syii=zi**2/(xx*yy)*((sxx+2.*sxy+syy)/4.+szzi-sxzi-syzi)
        if(syii.lt.0.) syii=abs(syii)
        syri=zr*zi/(xx*yy)*((sxx+2.*sxy+syy)/4.+szri
     *                               -(sxzr+sxzi+syzr+syzi)/2.)
        if(syri.lt.0.) syri=abs(syri)
c correction factor (Cr,Ci)
        acr = real(cof(k,ij))*real(cr(k,1))
        aci =aimag(cof(k,ij))*real(cr(k,1))
        szrr=acr**2*syrr+aci**2*syii-2.*acr*aci*syri
        szii=aci**2*syrr+acr**2*syii+2.*acr*aci*syri
        szri=acr*aci*(syrr-syii)+(acr**2-aci**2)*syri
c Variance of converted variable
        sd0(k,ij)=cmplx(szrr,szii)
c Covarince of converted variable
        bu0(k,ij)=szri
        if(nf(ij).ne.ng(ij)) then
         au0(k,ij)=c0
         cv0(k,nf(ij),ng(ij))=c0
         cv0(k,ng(ij),nf(ij))=c0
c        else
c         au0(k,ij)=szrr
c         cv0(k,nf(ij),ng(ij))=cmplx(szrr,0.)
c         cv0(k,ng(ij),nf(ij))=cmplx(szrr,0.)
        endif
       enddo
      enddo
      do k=isf,ief
       do ij=1,ij0
        sd(k,ij)=sd0(k,ij)
        bu(k,ij)=bu0(k,ij)
        au(k,ij)=au0(k,ij)
        cv(k,nf(ij),ng(ij))=cv0(k,nf(ij),ng(ij))
        cv(k,ng(ij),nf(ij))=cv0(k,ng(ij),nf(ij))
       enddo
      enddo
c
      do ij=1,ij0
       do k=isf,ief
        cr(k,ij)=cr(k,ij)*cof(k,ij)
       enddo
      enddo
c
      if(n_huddle.gt.0) then
       write(6,*)' Correction by huddle test done.'
c
c power spectra output
c
       if(n_pow.ne.0) then
        filen=cwkf//'data/results/'//finput(1:6)//'_cor_psp.dat'
        write(6,*)filen,'Corrected Power Spectra Output' 
        open(2,file=filen,status='unknown')
        write(2,cform1)'   Freq.', (ich,'-ch ',ich=1,nch),
     *              ' Power Spc', (ich,'-ch ',ich=1,nch),' S.D.     '
        do k=isf,ief 
        if(cunit.eq.'mkine') then   ! velocity input
         a2a=td*(2.*pai*fr(k))**2
        else if(cunit.eq.'gal'.or.cunit.eq.'gal  ') then
         a2a=td
        endif
         write(2,cform2)fr(k),
     * (a2a*cabs(cr(k,kk(ich))*real(coh0(k,1))),ich=1,nch),
     * (a2a*sqrt(cabs(cr(k,kk(ich)))**2*real(soh0(k,1))),ich=1,nch)
        enddo
        close(2)
       endif
c
c coherence
c
       do ij=1,ij0
        if(nf(ij).ne.ng(ij)) then
         do i=isf,ief
          xx=real(cr(i,kk(nf(ij))))
          yy=real(cr(i,kk(ng(ij))))
          cz=cr(i,ij)
c complex coherence function
          coh1(i,ij)=cz/sqrt(xx*yy)
      if(real(coh1(i,ij)).gt.1.)
     *    write(6,*)i,ij,cabs(cof(i,ij)),cabs(cz)
c variance
          sxx=cabs(sd(i,kk(nf(ij))))/xx**2
          syy=cabs(sd(i,kk(ng(ij))))/yy**2
          sxy=au(i,ij)/(xx*yy)
          zz=real(cz)
          sxz=real(cv(i,nf(ij),ng(ij)))/(xx*zz)
          syz=real(cv(i,ng(ij),nf(ij)))/(yy*zz)
          szz=real(sd(i,ij))/zz**2
          f2=real(coh1(i,ij))**2
          sxr=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
          if(sxr.lt.0.) sxr=abs(sxr)
          zz=aimag(cz)
          sxz=aimag(cv(i,nf(ij),ng(ij)))/(xx*zz)
          syz=aimag(cv(i,ng(ij),nf(ij)))/(yy*zz)
          szz=aimag(sd(i,ij))/zz**2
          f2=aimag(coh1(i,ij))**2
          sxi=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
          if(sxi.lt.0) sxi=abs(sxi)
          soh1(i,ij)=cmplx(sxr,sxi)
         enddo
        endif
       enddo
c
c coherence output
c
       if(n_coh.ne.0) then
        filen=cwkf//'data/results/'//finput(1:6)//'_cor_coh.dat'
        write(6,*)filen,' Corrected Coherence Output' 
        open(2,file=filen,status='unknown')
        write(2,cform3)
     *  '   Freq.',  ((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' Coherence',((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' S.D.     '
c
        do k=isf,ief
         id=0
         do ij=1,ij0
          if(nf(ij).lt.ng(ij)) then
           id=id+1
           f(id)=real(coh1(k,ij))
           g(id)=sqrt(real(soh1(k,ij)))
          endif
         enddo
         id0=id
         write(2,cform4) fr(k),(f(id),id=1,id0),(g(id),id=1,id0)
        enddo
        close(2)
       endif
      endif
      close(21)
c cross-correlation             in cr(k,ij) 
c variance of cross-correlation in sd(k,ij)
c
c azimuth of sensors over circle in az(ich)
c pivoting for station at the center 
      ph00=ph0/ppai
      if(nch_center.eq.0) then
       write(6,*)' No obs. point at the center.'
       n_n=1
       mch=nch
      else if(nch_center.eq.1) then
       write(6,*)' Obs. point at the center.'
       n_n=2
       mch=nch-1
      else
       write(6,*)' nch_center should be 1(one) or 0(zero).' 
       stop
      endif
c Mapping:
      do i=isf,ief
c cross spectra with the station at the center:cr0(i,ij)
c                               their variance:sd0(i,ij)
c                  power spectra at the center:cr0(i,1) 
       ij=0
       do ii=1,nch
        do jj=ii,nch
         ij=ij+1
         cdum(ii,jj)=cr(i,ij)
        enddo
       enddo
       do ich=1,nch
        cr0(i,ich)=cdum(1,ich)
       enddo
c mapping of auto- & cross- spectra
       do ii=1,nch
        do jj=1,ii-1
         cdum(ii,jj)=conjg(cdum(jj,ii))
        enddo
       enddo 
       ij=0
       do ii=n_n,nch
        do jj=n_n,nch
         ij=ij+1
         cr(i,ij)=cdum(ii,jj)
        enddo
       enddo
c mapping of variance
       ij=0
       do ii=1,nch
        do jj=ii,nch
         ij=ij+1
         cdum(ii,jj)=sd(i,ij)
         cdum(jj,ii)=sd(i,ij)
        enddo
       enddo
       do ich=1,nch
        sd0(i,ich)=cdum(1,ich)
       enddo
       ij=0
       do ii=n_n,nch
        do jj=n_n,nch
         ij=ij+1
         sd(i,ij)=cdum(ii,jj)
        enddo
       enddo
c mapping of covariance among real and imaginary parts of cross spectra
       ij=0
       do ii=1,nch
        do jj=ii,nch
         ij=ij+1
         cdum(ii,jj)=cmplx(bu(i,ij),0.)
         cdum(jj,ii)=cmplx(bu(i,ij),0.)
        enddo
       enddo
       ij=0
       do ii=n_n,nch
        do jj=n_n,nch
         ij=ij+1
         bu(i,ij)=real(cdum(ii,jj))
        enddo
       enddo
       do ich=1,nch
        bu0(i,ich)=real(cdum(1,ich))
       enddo
c mapping of covariance among power spectra at the center and cross spectra
c between the center and peripherals
       if(nch_center.ne.0) then
        ij=0
        do ii=1,nch
         do jj=ii,nch
	  ij=ij+1 
          cdum(ii,jj)=cv(i,ii,jj)
         enddo
        enddo
        do ich=1,nch
         cv0(i,ich,1)=cdum(ich,1)
        enddo
       endif
c
      enddo
c re-numbering
      ij=0
      do ii=1,mch
       do jj=1,mch
        ij=ij+1
        nf(ij)=ii
        ng(ij)=jj
       enddo
      enddo
      ij0=ij
c
      dphi=2.*pai/real(mch)
      do ich=1,mch
       az(ich)=real(ich-1)*dphi+ph00
      enddo
c Sum over azimuth of power & cross spectra => G{Z0,Z0(r,r,omg)}
      write(6,*)' Power spectra: G{Z0,Z0(r,r,omg)}'  
      do i=isf,ief
c integration over azimuth & variance:
       cr_sum=c0
       cr_ave=c0
       do ij=1,ij0
c G{Z0,Z0(r,r,omg)}:real number
        cr_sum=cr_sum+cr(i,ij)
c variance
        cr_ave=cr_ave+sd(i,ij)
       enddo
       cp0(i,1)=cmplx(real(cr_sum),0.)
       sp0(i,1)=cmplx(real(cr_ave),0.)
c covariance between real and imaginary part
       au0(i,1)=0.
      enddo
c Sum with exp(-i*ph) over azimuth of power & cross spectra => G{Z1,Z1(r,r,omg)}
      write(6,*)' Power spectra: G{Z1,Z1(r,r,omg)}'
      do i=isf,ief
c integration over azimuth & variance: only real part is used for average
       cr_sum=c0
       cr_ave=c0
       ar_sum=0.
       do ij=1,ij0
        ph=az(nf(ij))-az(ng(ij))
        ar=cos(-ph)
        ai=sin(-ph)
c G{Z1,Z1(r,r,omg)}:real number
c     if(i.eq.25) write(6,*)i,cmplx(ar,ai)*cr(i,ij)
        cr_sum=cr_sum+cmplx(ar,ai)*cr(i,ij)
c variance
        cr_ave=cr_ave+cmplx(
     *  ar**2*real(sd(i,ij))-2.*ar*ai*bu(i,ij)+ai**2*aimag(sd(i,ij))
     *  ,0.)
c covariance with G{Z0,Z0(r,r,omg)}
        ar_sum=ar_sum+(  ar*real(sd(i,ij))-ai*bu(i,ij)  )
       enddo
       cp0(i,2)=cmplx(real(cr_sum),0.)
c     if(i.eq.25) write(6,*)i,real(cr_sum)
       sp0(i,2)=cmplx(real(cr_ave),0.)
c covariance between real and imaginary part
       au0(i,2)=0.
       au0(i,5)=ar_sum
      enddo
c                                               => G{Z0,Z1(r,r,omg)}
      write(6,*)' cross spectra: G{Z0,Z1(r,r,omg)}' 
      do i=isf,ief
       cr_sum=c0
       cr_ave=c0
       ar_ave=0.
       ij=0
       do ii=1,mch
        do jj=ii,mch
         ij=ij+1
         ar=cos(az(jj))
         ai=sin(az(jj))
         cr_sum=cr_sum+cmplx(ar,ai)*cr(i,ij)
c variance
         cr_ave=cr_ave+cmplx( 
     *    ar**2*real(sd(i,ij))-2.*ar*ai*bu(i,ij)+ai**2*aimag(sd(i,ij)),
     *    ai**2*real(sd(i,ij))+2.*ar*ai*bu(i,ij)+ar**2*aimag(sd(i,ij)))
c covariance between real and imaginary part
         ar_ave=ar_ave+(ar**2-ai**2)*bu(i,ij) 
        enddo
       enddo 
       cp0(i,3)=cr_sum	 
       sp0(i,3)=cr_ave     
       au0(i,3)=ar_ave
      enddo
c                                               => G{Z0,Z0(0,r,omg)}
       write(6,*)' cross spectra: G{Z0,Z0(0,r,omg)}' 
      if(nch_center.ne.0) then
       do i=isf,ief
c integration over azimuth & variance:
        cr_sum=c0
        cr_ave=c0
        ar_ave=0.
c        ar_sum=0.
        do ich=2,nch
         cr_sum=cr_sum+cr0(i,ich)
c variance
         cr_ave=cr_ave+sd0(i,ich)
c covariance between real and imaginary part
         ar_ave=ar_ave+bu0(i,ij) 
c covariance between power at the center and cross between the center and the peripheral
c         ar_sum=ar_sum+cv0(i,ich,1)
        enddo
        cp0(i,4)=cr_sum
        sp0(i,4)=cr_ave
        au0(i,4)=ar_ave
c        au0(i,6)=ar_sum
       enddo
      endif
c spectral smoothing
      do kl=1,4
       do i=isf,ief
	  f(i)=real(cp0(i,kl))
	 enddo 
	 call esmthf(f(isf),g(isf),fr(isf),ief-isf+1,smthf)
       do i=isf,ief
	  cp0(i,kl)=cmplx(g(i),aimag(cp0(i,kl)))
	 enddo 
	enddo 
c CCA coefficient and its variance
      do i=isf,ief
	 ax=real(cp0(i,1))
	 ay=real(cp0(i,2))
	 sx=real(sp0(i,1))
	 sy=real(sp0(i,2))								 
	 f(i)=real(cp0(i,1))/real(cp0(i,2))
       g(i)=(ay**2*sx-2.*ax*ay*au0(i,5)*0.+ax**2*sy)/ay**4
c      write(6,*)fr(i),f(i),sqrt(g(i))
c      if(g(i).gt.f(i)) write(6,'(7e10.3)')
c     *  fr(i),ax,ay,sx,sy,f(i),g(i)
	enddo
c In-coming azimuth
      do i=isf,ief
       ax= real(cp0(i,3))
       ay=aimag(cp0(i,3))
       sx= real(sp0(i,3))
       sy=aimag(sp0(i,3))
       h(i)=atan2(ay,ax)*ppai-90.
       g1(i)=(ay**2*sx-2.*ax*ay*au0(i,3)+ax**2*sy)
     *                    *(ppai**2/(ax**2+ay**2))
	enddo
c
      read(11,*)n_cor_center
      write(6,*)n_cor_center
c squared circle coherence coh2(omg) & spac coefficient roh(omg)
      if(n_cor_center.ne.0) then
       write(6,*)'Correction using the seismometer at the center'
c      write(6,*)isf,ief
       do i=isf,ief
c squared circle coherence coh2:
        ax=cabs(cp0(i,4))**2                     !|G{Z0,Z0(0,r,omg)}|
        ay=real(cp0(i,1))*real(cr0(i,1))         !G{Z0,Z0(r,r,omg)} * G{Z0,Z0(0,0,omg)}           
        coh2=ax/ay
c variance of coh2
c        sxx=4.*(real(cp0(i,4))**2*real(sp0(i,4))
c     *     +2.*real(cp0(i,4))*aimag(cp0(i,4))*au0(i,4)
c     *     +aimag(cp0(i,4))**2*aimag(sp0(i,4)))
c        sxy=0.                                   ! neglected
c        syy=real(cp0(i,1))**2*real(sd0(i,1))
c     *     +2.*real(cp0(i,1))*real(cr0(i,1))*au0(i,6)
c     *     +real(cr0(i,1))**2*real(sp0(i,1))
c        scoh2=(ay**2*sxx-2.*ax*ay*sxy+ax**2*syy)*ay**4
        if(i.ne.isf) then
         roh1=roh
        endif
        roh=real(cp0(i,4))/real(cr0(i,1))
        if(roh*roh1.lt.0.0) then
         write(6,*) 'Roh zero crossed at ',fr(i),' Hz'
         iieeff=i-1
         goto 200
        endif
c squared SPAC coefficient roh2
        ax=real(cp0(i,4))**2                     !G{Z0,Z0(0,r,omg)} 
        ay=real(cr0(i,1))**2                     !G{Z0,Z0(0,0,omg)}
        roh2=ax/ay
c variance of roh2
c        sxx=4.*real(cp0(i,4))**2*real(sp0(i,4))
c        sxy=0.                                   ! neglected
c        syy=4.*real(cr0(i,1))**2*real(sd0(i,1))
c        sroh2=(ay**2*sxx-2.*ax*ay*sxy+ax**2*syy)*ay**4
c covariance between roh2 and coh2
c        sroh2_coh2=0.                            ! neglected
c noise to signal ratio
        AA  =-roh2
        AB  = roh2/coh2-2.*roh2-1./real(mch)
        AC  = roh2*(1./coh2-1.)
        xx=AB/(AA*2.)
        yy=AC/AA
c noise to signal ratio epsiron  
        cr(i,1) =-xx-sqrt(xx**2-yy)
c variance of epsiron
c        sAA =sroh2
c        sAB= ((1-2.*coh2)**2*coh2**2*sroh2+roh2**2*scoh2)/coh2**4
c        sAC =((1-coh2)**2*coh2**2*sroh2+roh2**2*scoh2)/coh2**4
c        sAA_AB=roh2/coh2**2*sroh2_coh2
c        sAA_AC=sAA_AB
c        sAB_AC=-roh2/coh2**2*(2./coh2**2-3)*sroh2_coh2
c        sxx=(AB**2*sAA-2.*AA*AB*sAA_AB+AA**2*sAB)/(4.*AA**4)
c        sxy=(AB*AC*sAA-AA*AC*sAA_AB-AA*AB*sAA_AC+AA**2*sAB_AC)/(2.*AA**4)
c        syy=(AC**2*sAA-2.*AA*AC*sAA_AC+AA**2*sAC)/AA**4
c for sxx and syy: cobariance between AA & AB, AA & AC is neglected
c        ww=xx**2-yy
c        zz=2*xx+sqrt(ww)
c        sd(i,1)=(zz**2/ww)*sxx-2.*zz/ww*sxy+1./ww*syy  
       enddo
       iieeff=ief
  200  continue
      else
       do i=1,nn
        cr(i,1)=c0
        sd(i,1)=c0
        iieeff=ief
       enddo
      endif
c      write(6,*)isf,ief
c terminate calculation at zero-cross of roh
      ief=iieeff
c
c interim output
c
      if(n_huddle.le.0) then
      read(11,*)
      endif
      filen=cwkf//'data/results/'//'cca_coef.dat'
      write(6,*)filen
      open(2,file=filen,status='unknown')
      write(2,'(7(a8,5X),3f10.3,a20)')
     *  '   Freq.','   ALL  ',
     *  '  Z0/ALL','  Z1/ALL',
     *  '   Z0/Z1','   Azi  ',
     *  '   err/N',rr,fmin,fmax,' :Radius, fmin, fmax'
      do i=isf,ief
       if(fr(i).le.fmax) then
        a2a=td*(2.*pai*fr(i))**2
        aa1=a2a*real(coh0(i,1))
        write(2,'(f6.3,7x,5(3x,e10.3))') fr(i),
     *   aa1,real(cp0(i,1))/mch**2,real(cp0(i,2))/mch**2,
     *   f(i)           ,      h(i)       !,real(cr(i,1))/mch**2
       endif
      enddo
      close(2)
c
c Estimate of Phase Velocity
c
      if(n_cor_center.eq.0) then
       a_a=0.
      else
       a_a=1.	  
      endif
c     read(11,*)fileo
      filen=cwkf//'data/results/'//'dispersion.dat'
      write(6,'(a50)')filen
      open(2,file=filen,status='unknown') 
      write(2,'(5a10)')
     *    ' Frequency','  Velocity','   Azimuth','        KR'
      do i=isf,ief
c      ac=rr*pai*2.*fr(i)*sqrt(abs(f(i))+2.)/2.
       ac=rr*pai*2.*fr(i)*
     *     1.0003*(sqrt(abs(f(i))+0.97221)/2.0003+0.0015245)-0.0138
ccccc
       KR=pai*2.*fr(i)*rr/ac
       if(fr(i).le.fmax) then
c      if(fr(i).le.fmax.and.real(cp0(i,2)).gt.0.) then
        write(2,'(4f10.3)')fr(i),ac,h(i),KR
	 endif
      enddo
c
      close(22)
      close(11)
      stop
      end
c+++++
      subroutine formatter(nch,cform1,cform2,cform3,cform4)
      character cform1*24,cform2*21,cform3*30,cform4*21
      if(nch.ge.10) then
       write(cform1,'(a6,i2,a16)') '(a8,2(',nch,'(5x,i2,a3),a10))'
       write(cform2,'(a8,i2,a11)') '(f8.5,2(',nch,'e10.3,10x))'
      else if(nch.ge.3) then
       write(cform1,'(a6,1x,i1,a16)') '(a8,2(',nch,'(5x,i2,a3),a10))'
       write(cform2,'(a8,1x,i1,a11)') '(f8.5,2(',nch,'e10.3,10x))'
      else
       write(6,*)'nch should be begger than 2!'
      endif
c
      if(nch*(nch-1)/2.ge.10) then
       write(cform3,'(a6,i2,a22)') '(a8,2(',nch*(nch-1)/2  ,
     *                                     '(4x,i2,a1,i2,a2),a10))'
       write(cform4,'(a8,i2,a11)')'(f8.3,2(',nch*(nch-1)/2,
     *                                     'e11.3,10X))'
 
      else if(nch*(nch-1)/2.ge.2) then
       write(cform3,'(a6,1x,i1,a22)') '(a8,2(',nch*(nch-1)/2  
     *                                    ,'(4x,i2,a1,i2,a2),a10))'
       write(cform4,'(a8,1x,i1,a11)')'(f8.3,2(',nch*(nch-1)/2,
     *                                     'e11.3,10x))'
 
      endif
      end
c+++++
      subroutine w_parzen(h,nn,n,dt,bw,g1,g2,n2,w,lmax0)
      real h(n),g1(n2),g2(n2),w(lmax0)
      data pai/3.141592/
c parzen window
      df=1./(dt*real(nn))
      udf=1.854305/bw*df
      if(udf.gt.0.5) then
       write(6,*)' Bandwidth is too narrow'
      endif
      lmax=int(2./udf+0.5)
      if(lmax.gt.lmax0) then
       write(6,*)'Bandwidth is too wide'
      endif
      w(1)=0.75*udf
      do l=2,lmax
       dif=pai/2.*real(l-1)*udf
       w(l)=w(1)*(sin(dif)/dif)**4
      enddo
      ll=lmax*2-1
      ln=ll-1+nn
      lt=(ll-1)*2+nn
      le=lt-lmax+1
      do k=1,lt
       g1(k)=0.
      enddo
      do k=1,nn
       g1(ll-1+k)=h(k)
      enddo
      do k=lmax,le
       s=w(1)*g1(k)
       do l=2,lmax
        s=s+w(l)*(g1(k-l+1)+g1(k+l-1))
       enddo
       g2(k)=s
      enddo
      do l=2,lmax
       g2(ll+l-1)=g2(ll+l-1)+g2(ll-l+1)
       g2(ln-l+1)=g2(ln-l+1)+g2(ln+l-1)
      enddo
      do k=1,nn
       h(k)=g2(ll-1+k)
      enddo
      return
      end
c+++++
      subroutine taper(x,n,dt)
      real x(n)
      data pai/3.141592/
      mwin=int(real(n)/20.+0.5)
c linear trend fitting
      b1=x(1)
      do i=2,n
       b1=b1+real(i)*x(i)
      enddo
      b2=x(1)
      do i=1,n
       b2=b2+x(i)
      enddo
      a0=real(n*(n+1)*(2*n+1))/6.*dt
      b0=real(n*(n+1))/2.
      c0=b0*dt
      d0=real(n)
      f0=a0*d0-b0*c0
      aa=( d0*b1-b0*b2)/f0
      bb=(-c0*b1+a0*b2)/f0
      do i=1,n
       x(i)=x(i)-aa*real(i)*dt-bb
      enddo
c tapering
      do i=1,mwin
       x(i)=x(i)*SIN(PAI/2.*REAL(i-1)/REAL(MWIN))
      enddo
      do i=n-mwin,n
       x(i)=x(i)*SIN(PAI/2.*REAL(n-i)/REAL(MWIN))
      enddo
      return
      end
c+++++
      subroutine w_parzen2(h,nn,n,dt,bw,g1,g2,n2,w,lmax0)
      real h(n),g1(n2),g2(n2),w(lmax0)
      data pai/3.141592/
c parzen window
      df=1./(dt*real(nn))
      udf=1.854305/bw*df
      if(udf.gt.0.5) then
       write(6,*)' Bandwidth is too narrow'
      endif
      lmax=int(2./udf+0.5)
      if(lmax.gt.lmax0) then
       write(6,*)'Bandwidth is too wide'
      endif
      w(1)=0.75*udf
      do l=2,lmax
       dif=pai/2.*real(l-1)*udf
       w(l)=w(1)*(sin(dif)/dif)**4
cccccc
       w(l)=w(l)**2
cccccc
      enddo
cccccc
      w(1)=w(1)**2
cccccc
      ll=lmax*2-1
      ln=ll-1+nn
      lt=(ll-1)*2+nn
      le=lt-lmax+1
      do k=1,lt
       g1(k)=0.
      enddo
      do k=1,nn
       g1(ll-1+k)=h(k)
      enddo
      do k=lmax,le
       s=w(1)*g1(k)
       do l=2,lmax
        s=s+w(l)*(g1(k-l+1)+g1(k+l-1))
       enddo
       g2(k)=s
      enddo
      do l=2,lmax
       g2(ll+l-1)=g2(ll+l-1)+g2(ll-l+1)
       g2(ln-l+1)=g2(ln-l+1)+g2(ln+l-1)
      enddo
      do k=1,nn
       h(k)=g2(ll-1+k)
      enddo
      return
      end
c+++++
      SUBROUTINE CFFT(X,N,IND)
c...........................................................................
c
c     Complex Fast Fourier Transform
c
c     Coded by Y. OHSAKI in "Introduction to spectral analysis for
c                            seismic waves"
c     Typed by D.Suetsugu, IISEE
c     Modified by H.Inoue, IISEE
c
c     Usage.......   CALL FFT(N,X,IND)
c
c     where
c
c     X(N)    In/Out  Equi-spaced N complex data/Transformed values
c     N       In      Number of data, MUST be a power of 2.
c     IND     In      -1=Fourier transform,  1=Inverse Fourier transform
c
c     Note..... You must divide the output X() by N to get Fourier
c               coefficient when IND=-1.
c
c...........................................................................
      complex x(n),temp,theta
c
      j=1
      do 140 i=1,n
        if(i.ge.j) goto 110
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
  110   m=n/2
  120   if(j.le.m) goto 130
        j=j-m
        m=m/2
        if(m.ge.2) goto 120
  130   j=j+m
  140 continue
c  
      kmax=1
      do 150 kkk=1,9999
        if(kmax.ge.n) return
        istep=kmax*2
        do 170 k=1,kmax
          theta=cmplx(0.0,3.141593*float(ind*(k-1))/float(kmax))
          do 160 i=k,n,istep
            j=i+kmax
            temp=x(j)*cexp(theta)
            x(j)=x(i)-temp
            x(i)=x(i)+temp
  160     continue
  170   continue
        kmax=istep
  150 continue
      end
c+++++
      FUNCTION bessj0(x)
      REAL bessj0,x
      REAL ax,xx,z
      DOUBLE PRECISION p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,
     *s1,s2,s3,s4,s5,s6,y
      SAVE p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,s1,s2,s3,s4,
     *s5,s6
      DATA p1,p2,p3,p4,p5/1.d0,-.1098628627d-2,.2734510407d-4,
     *-.2073370639d-5,.2093887211d-6/, q1,q2,q3,q4,q5/-.1562499995d-1,
     *.1430488765d-3,-.6911147651d-5,.7621095161d-6,-.934945152d-7/
      DATA r1,r2,r3,r4,r5,r6/57568490574.d0,-13362590354.d0,
     *651619640.7d0,-11214424.18d0,77392.33017d0,-184.9052456d0/,s1,s2,
     *s3,s4,s5,s6/57568490411.d0,1029532985.d0,9494680.718d0,
     *59272.64853d0,267.8532712d0,1.d0/
      if(abs(x).lt.8.)then
        y=x**2
        bessj0=(r1+y*(r2+y*(r3+y*(r4+y*(r5+y*r6)))))/(s1+y*(s2+y*(s3+y*
     *(s4+y*(s5+y*s6)))))
      else
        ax=abs(x)
        z=8./ax
        y=z**2
        xx=ax-.785398164
        bessj0=sqrt(.636619772/ax)*(cos(xx)*(p1+y*(p2+y*(p3+y*(p4+y*
     *p5))))-z*sin(xx)*(q1+y*(q2+y*(q3+y*(q4+y*q5)))))
      endif
      return
      END
c+++++
      FUNCTION bessj1(x)
      REAL bessj1,x
      REAL ax,xx,z
      DOUBLE PRECISION p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,
     *s1,s2,s3,s4,s5,s6,y
      SAVE p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,s1,s2,s3,s4,
     *s5,s6
      DATA r1,r2,r3,r4,r5,r6/72362614232.d0,-7895059235.d0,
     *242396853.1d0,-2972611.439d0,15704.48260d0,-30.16036606d0/,s1,s2,
     *s3,s4,s5,s6/144725228442.d0,2300535178.d0,18583304.74d0,
     *99447.43394d0,376.9991397d0,1.d0/
      DATA p1,p2,p3,p4,p5/1.d0,.183105d-2,-.3516396496d-4,
     *.2457520174d-5,-.240337019d-6/, q1,q2,q3,q4,q5/.04687499995d0,
     *-.2002690873d-3,.8449199096d-5,-.88228987d-6,.105787412d-6/
      if(abs(x).lt.8.)then
        y=x**2
        bessj1=x*(r1+y*(r2+y*(r3+y*(r4+y*(r5+y*r6)))))/(s1+y*(s2+y*(s3+
     *y*(s4+y*(s5+y*s6)))))
      else
        ax=abs(x)
        z=8./ax
        y=z**2
        xx=ax-2.356194491
        bessj1=sqrt(.636619772/ax)*(cos(xx)*(p1+y*(p2+y*(p3+y*(p4+y*
     *p5))))-z*sin(xx)*(q1+y*(q2+y*(q3+y*(q4+y*q5)))))*sign(1.,x)
      endif
      return
      END
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine esmthf(ai,ao,f,nf,smthf)                               
c  subroutine for smoothing spectra or spectral ratio
c  window's shape: Parzen                   
      dimension ai(5000),ao(5000),f(5000)                               
      real madd 
      if(smthf.le.0.0) go to 100                                        
      ao(1)=ai(1)                                                       
      do 35 i=2,nf                                                      
       f1=(1.0-0.5*smthf)*f(i)                                           
       f2=(1.0+0.5*smthf)*f(i)                                           
	 u=1.854305/(smthf*f(i))
       if(f2.le.f(nf))go to 31                                           
   31  sum=0.0                                                           
       madd=0.0                                                          
       do 32 k=1,nf                                                      
        if(f(k).lt.f1) go to 32                                           
        if(f(k).gt.f2) go to 33                                           
        au=1.570796*u*abs(f(i)-f(k))
        if(i.eq.k) then
         w=0.75*u
        else
         w=0.75*u*(sin(au)/au)**4
        endif
        sum=sum+ai(k)*w                                                     
        madd=madd+W                                                       
   32  continue                                                          
   33  continue                                                          
       ao(i)=sum/madd                                                    
   35  continue                                                          
   36 continue                                                          
c      nf=mnf                                                            
      return                                                            
  100 continue                                                          
      do 101 i=1,nf                                                     
  101 ao(i)=ai(i)                                                       
      return                                                            
      end                                       
