      program seeblkc
c revised                                                           2019.09.02
      parameter(nmax0=10000,nch0=12,mblk0=2000,n_mea0=500) 
      character filen*80,filem*80,comment*50,cform9*18
      real*4 x(nmax0,nch0),xx(nmax0),amaxacc(nch0),
     +       xdum(nmax0),axmx(mblk0),fac_(nch0),aym_(nch0)
      character cdrv*10,cwkf*80,cform*5,cunit*5,
     +          c_mea(n_mea0)*10,cdum*80
      data aym,x0,yl,DTL/42.0,0.0,2.0,25.0/ ascale/28./
     +     fac_/0.65,0.65,0.65,0.65,0.65,0.65,0.65,0.55,
     +                                        0.5,0.45,0.4,0.35/
     +     aym_/42.,42.,42.,42.,42.,42.,42.,48.,54.,60.,66.,66./
      data cdrv/'./cca_wkf/'/ 
      data eps/1.e-3/ pai/3.141592/
c working folder name
      cwkf=cdrv//'prm/'
      data fl,fh,fs/0.1,1.5,2.0/ 
c Chebishev I(2), Lowpass (2) Bandpass(3), Causal(1)
      data ap,as/0.1,10./ ntype,nchara0,ncausal/2,3,1/
c
      filen=cdrv//'data/resampled_files/rsmfile.lst'
      write(6,*)filen
      open(1,file=filen,status='old')
      do i_mea=1,n_mea0
       read(1,'(a10)',end=2)c_mea(i_mea)
      enddo
    2 n_mea=i_mea-1
      close(1)
      ncharacter=10
c
      filen=cwkf(1:14)//'seeblkc.prm'
      write(6,'(a25)')filen
      open(11,file=filen,status='old')
      read(11,*)nbandp,fl,fh,fs,nchara
      close(11)
      if(ncharacter.le.9) then
       write(cform,'(a2,i1,a1)')'(a',ncharacter,')'
      else
       write(cform,'(a2,i2,a1)')'(a',ncharacter,')'
      endif
c
      do i_mea=1,n_mea
c
       cwkf=cdrv//'data/resampled_files/'
       filem=cwkf(1:31)//c_mea(i_mea)
       write(6,'(a41)')filem
       open(12,file=filem,status='old')
       read(12,'(i2,2i5,i2,2f8.2,1x,a18,1x,a5)')
     *      nch,mblk,nn,nch_center,ph0,rr,cform9,cunit
       write(6,'(i2,2i5,i2,2f8.2,1x,a18,1x,a5)')
     *      nch,mblk,nn,nch_center,ph0,rr,cform9,cunit
c
       if(nch.le.12) then 
	fac=fac_(nch)
	aym=aym_(nch)
       else if(nch.ge.13) then
	write(6,*)'Nch>12 is not available.'
        stop
       endif
       read(12,*)idum,t1
       read(12,*)idum,t2
       dt=t2-t1
       backspace(12)
       backspace(12)
       td=real(nn)*dt
       nmax=nn
c loop over time blocks
       do iblk=1,mblk
c read input data
        do i=1,nn
         read(12,cform9)idum,t,(x(i,ich),ich=1,nch)
        enddo
c
        do ich=1,nch
         if(nbandp.eq.1) then
          if(ich.eq.1.and.iblk.eq.1) then
           write(6,*)' DC-offset removed & tapered;'
          endif
          do i=1,nn
           xx(i)=x(i,ich)
          enddo
c
          call taper(xx,nn,dt)
c
          if(fs.lt.0.5/dt) then
           if(ich.eq.1.and.iblk.eq.1) then
	    if(nchara.eq.2) then
             write(6,*)'fs<f(nyquist), lowpass filter applied;'
            else if(nchara.eq.3) then
             write(6,*)'fs<f(nyquist), bandpass filter applied;'
            endif
           endif
           call bandp1(xx,nn,dt,fl,fh,fs,ap,as,ntype,nchara,ncausal)
           do i=1,nn
            x(i,ich)=xx(i)
           enddo
          else
           if(ich.eq.1.and.iblk.eq.1) then
	    write(6,*)'fs>f(nyquist), bandpass filter NOT applied;'
           endif
          endif
         endif
c      
         amaxacc(ich)=abs(x(1,ich))
         do i=2,nn
          if(amaxacc(ich).lt.abs(x(i,ich))) then
           amaxacc(ich)=abs(x(i,ich))
          endif
         enddo
c maximum value for each channel: amaxacc(ich)
c        write(6,'(i3,a8,e12.3)')ich,'-ch max=',amaxacc(ich)
c
        enddo                      ! ich loop
c maximum value for time block: amaxx
        amaxx=amaxacc(1)
        do ich=2,nch
         if(amaxx.lt.amaxacc(ich)) amaxx=amaxacc(ich)
        enddo
c
        nz1=log10(amaxx)
        z1=10**real(nz1)
        z2=amaxx/z1
        if(z2.lt.2.) then
         y2=1.
        else if(z2.lt.5.) then
         y2=2.
        else
         y2=5.
        endif
        axmx(iblk)=y2*z1
c        write(6,*)amaxx,axmx(iblk)
        if(iblk.eq.1) then
         nunit=nn                               ! samples in one page
c time/cm in horizontal axis
         dtl=td/ascale
         cwkf=cdrv//'data/results/fig_wave/'
         filen=cwkf(1:32)//c_mea(i_mea)(1:6)//'.ps'
         write(6,*) filen
         open(25,file=filen,status='unknown')
         n_page=0
        endif
c
        n_page=n_page+1
        CALL PLOTS(25)
c       call yoko(25) 
        CALL FACTOR(FAC)
        call plot(x0,0.,-3)
        CALL NEWPEN(1)
        ay=aym
        ndatamax=nn
        if(ndatamax.lt.nmax) then
         cdum(1:1)='C'
         call symbol(28.,0.5,0.3,cdum,0.0,1)
        endif
        do ich=1,nch
         cdum(1:4)='Max='
         call symbol(4.0,ay+yl+0.3,0.3,cdum,0.0,4)
         call number(5.5,ay+yl+0.3,0.3,amaxacc(ich),0.0,3)
         cdum(1:5)=cunit
         call symbol(7.5,ay+yl+0.3,0.3,cdum,0.0,5)
c        call number(9.3,ay+yl+0.3,0.3,scale,0.0,1)
         do i=1,nn
          xx(i)=x(i,ich)
         enddo
         CALL PLOT( 2., AY,-3)
         call pltwv2(xx,ndatamax,dt,dtl,axmx(iblk),yl,4)
         CALL PLOT(-2.,-AY,-3)
         ay=ay-3.*yl
        enddo
        if(n_page.eq.1) then
         write(filen,'(a41,i2,a8)')filem,n_page,'-st page'
        else if(n_page.eq.2) then
         write(filen,'(a41,i2,a8)')filem,n_page,'-nd page'
        else if(n_page.eq.3) then
         write(filen,'(a41,i2,a8)')filem,n_page,'-rd page'
        else
         write(filen,'(a41,i2,a8)')filem,n_page,'-th page'
        endif
        call symbol(0.0,ay+0.5,0.8,filen,0.0,51)     
        call plote(25)
c
       enddo                      ! loop on iblk
       close(25)
       close(12)
      enddo                       ! loop on i_mea
      close(1)
      stop
      end
      include 'dgflt.f'
      include 'pltwv2.for'
      include 'PSCAL.F'
c+++++
      subroutine taper(x,n,dt)
      real x(n)
      data pai/3.141592/
      mwin=int(real(n)/20.+0.5)
c linear trend fitting
      b1=x(1)
      do i=2,n
       b1=b1+real(i)*x(i)
      enddo
      b2=x(1)
      do i=1,n
       b2=b2+x(i)
      enddo
      a0=real(n*(n+1)*(2*n+1))/6.*dt
      b0=real(n*(n+1))/2.
      c0=b0*dt
      d0=real(n)
      f0=a0*d0-b0*c0
      aa=( d0*b1-b0*b2)/f0
      bb=(-c0*b1+a0*b2)/f0
      do i=1,n
       x(i)=x(i)-aa*real(i)*dt-bb
      enddo
      return
      end
c
