      program seg2read
c Input  File format: seg2 with extention sg2 or others 
c Output File format: ascii text with extention given in seg2read.prm
c
c Made by Toshiaki Yokoi (IISEE, BRI, Japan), APR. 11, 2017.
c Modified for GEOPSY export sg2 format Aug.13, 2017
      parameter(nch0=25,nn0=500000)
      real*8    xx(nn0,nch0)
      real      z(nn0),y(nch0)
      integer   npiv(nch0)
      character filen*80,filen1*80,cdm1*1,cdd*15,cname*9,cnam*4,
     *          cxi*4,cxo*4,cform1*15,cform2*15,comment*70,
     *          cdrv*2,cwkf*10,c_pv*80,cnam6*6,cunit*5,cdum*3,
     *          filei*80,fileo*80
c common blocks
c     COMMON /FACTOR/descale
      data kiban/1/ scale/1.e0/ cdrv/'./'/ cunit/'mkine'/
c default values
      data fl,fh,fs/0.033,10.,12./ ap,as/0.1,10.0/
c Chebishev I(2), Lowpass (2) Bandpass(3), Causal(1)
      data ntype,nchara,ncausal/2,3,1/
c
      cwkf=cdrv//'cca_wkf/'
      filen=cwkf//'prm/seg2read.prm'
      write(6,'(a50)')filen
      open(10,file=filen,status='old')
      read(10,'(a70)')comment
      read(10,'(a12)')filen
      read(filen,*,end=3) scale,cdum
      if(cdum.eq.'acc'.or.cdum.eq.'ACC') then
       cunit='gal  '
      endif
      go to 4
    3 read(filen,*) scale
      goto 5 
    4 continue
    5 continue
      write(6,*)scale, cunit
c
      read(10,'(a3)')cxi
      read(10,'(a3)')cxo
      read(10,*)nfilter,nchara,fl,fh,fs
      read(10,'(a80)') c_pv
      close(10)
      cxi='.'//cxi
      cxo='.'//cxo
c
      filen=cwkf//'data/sg2_files/sg2file.lst'
      write(6,'(a50)')filen
      open(2,file=filen,status='old')
      do ifile=1,1000
       read(2,*,end=10) filen1
c      write(6,*)filen1
      enddo
   10 nfile=ifile-1
      rewind(2)
      do ifile=1,nfile
       read(2,*,end=9000) filen1
       write(6,'(a16)')filen1
c get extention of input file
       do ic=1,80
        read(filen1(ic:ic),'(a1)', end=100) cdm1
        if(cdm1.eq.'.') then
         goto 100
        endif
       enddo
  100  i_dot=ic
c check extention of input file
       write(cnam,'(a4)')filen1(i_dot:i_dot+3)
c      write(6,*)cnam,'=',cxi
       if(cnam.eq.cxi) then
        go to 110
       else
        write(6,*)'skip'
        go to 8000                          ! skip
       endif
  110  filei=cwkf//'data/sg2_files/'
     *      //filen1(1:i_dot-1)//cxi    ! input file name
       write(6,*)' '
       write(6,'(a50)') filei
       fileo=cwkf//'data/multiplexed_files/'
     *      //filen1(1:i_dot-1)//cxo    ! output file name
       write(6,'(a50)') fileo
c    
       call seg2read1(xx,nch,nn,nch0,nn0,filei,kiban,dt)
c 
c  xx(nn0,nch0): output array of data
c  nch         : number of trace (output)
c  nn          : number of samples per trace (output)
c  nch0,nn0    : declared array size
c  filen1      : input file name (SEG2 format)
c  kbn         : kiban(unit number) allocated to the input file
c  dt          : Sampling interval (output)
cccccc
       write(6,'(4(a4,i3,a4,f6.3,a4,i8))')
     *                  'nch=',nch,' dt=',dt,' nn=',nn
       call formatter(nch,cform1,cform2)
c channel pivoting
       read(c_pv,*) cnam6
       nnch=nch
       if(cnam6.eq.'normal') then         ! no pivoting
        do ich=1,nch
         npiv(ich)=ich
        enddo
       else if(cnam6.eq.'rev_al') then    ! reverse all channels
        do ich=1,nch
         npiv(ich)=nch-ich+1
        enddo
       else if(cnam6.eq.'rev_fh') then    ! reverse former half channels
        if(mod(nch,2).ne.0) then
         write(6,*)'Number of channels is not an even number.'
         stop
        endif 
        do ich=1,nch/2
         npiv(ich)=nch/2-ich+1
        enddo
       else if(cnam6.eq.'rev_lh') then    ! reverse latter half channels
        if(mod(nch,2).ne.0) then
         write(6,*)'Number of channels is not an even number.'
         stop
        endif 
        do ich=nch/2+1,nch
         npiv(ich)=3*nch/2-ich+1
        enddo
       else if(cnam6.eq.'pvlist') then    ! pivot channels using list
        do ii=1,75
         if(c_pv(ii:ii+5).eq.cnam6) then
          go to 200
         endif
        enddo
  200   is=ii+6
        nnch=0
        do ii=is,80
         if(c_pv(ii:ii).ne.' '.and.c_pv(ii:ii).ne.':') then
          nnch=nnch+1
          if(c_pv(ii-1:ii-1).ne.' ') then
           nnch=nnch-1
          endif
         endif
         if(c_pv(ii:ii).eq.':') then
          go to 210
         endif
        enddo
  210   read(c_pv,*)cnam6,(npiv(ich),ich=1,nnch)
       else
        write(6,*)'Error at pivoting list in','seg2read.prm' 
        stop
       endif
       if(cnam6.ne.'normal') then
        do i=1,nn
         do ich=1,nnch
c         y(ich)=real(xx(i,npiv(ich)))
          y(ich)=real(sign(1,npiv(ich)))*real(xx(i,abs(npiv(ich))))
         enddo
         do ich=1,nnch
          xx(i,ich)=dble(y(ich))
         enddo
        enddo
       endif
c Bandpass filter
       do ich=1,nnch
        if(ich.eq.1) then
         if(nfilter.eq.1) then
          write(6,*)'bandpass filter applied','ich=',ich,nn
         else if(nfilter.eq.2) then
          write(6,*)' DC and trend removal only'
         endif
        endif
        if(nfilter.ne.0) then
         do i=1,nn
          z(i)=real(xx(i,ich))
         enddo
         call taper(z,nn,dt)
         sum=0.0
         nnave=1./dt          ! 1 sec
         ntaper=nnave  
         do i=1,ntaper+1
          z(i)=z(i)*real(i-1)/real(ntaper)
         enddo   
         if(nfilter.eq.1) then
c         write(6,*)nn,dt,fl,fh,fs,ap,as,ntype,nchara,ncausal  
          call bandp1(z,nn,dt,fl,fh,fs,ap,as,ntype,nchara,ncausal)
c
         endif
         do i=1,nn
          xx(i,ich)=dble(z(i))
         enddo
        endif
       enddo
       open(kbn,file=fileo,status='unknown')
       write(kbn,'(i8,f8.4,e16.4,i8,2x,a5)')nnch,dt,scale,nn,cunit
       write(6,'(i8,f8.4,e16.4,i8,2x,a5)')nnch,dt,scale,nn,cunit
       write(kbn,'(a70)')comment
       write(6,'(a70)')comment
       do i=1,nn
        write(kbn,cform2)real(i-1)*dt,(xx(i,ich)*scale,ich=1,nnch)
       enddo
c
 8000  continue
      enddo
 9000 nfile=ifile-1
      write(6,'(i6,a27)')nfile,' files have been converted.'
      write(6,'(a11)')'Normal End.'
      stop
      end
c+++++
      include 'dgflt.f'
c+++++
      subroutine formatter(nch,cform1,cform2)
      character cform1*15,cform2*15
      if(nch.ge.10) then
       write(cform1,'(a4,i2,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a7,i2,a6)')'(f12.6,',nch,'e15.7)'
      else if(nch.ge.3) then
       write(cform1,'(a4,1x,i1,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a7,1x,i1,a6)')'(f12.6,',nch,'e15.7)'
      else
       write(6,*)'nch should be bigger than 2!'
      endif
      end
c+++++
      subroutine taper(x,n,dt)
      real x(n)
      data pai/3.141592/
      mwin=int(real(n)/20.+0.5)
c linear trend fitting
      b1=x(1)
      do i=2,n
       b1=b1+real(i)*x(i)
      enddo
      b2=x(1)
      do i=1,n
       b2=b2+x(i)
      enddo
      a0=real(n*(n+1)*(2*n+1))/6.*dt
      b0=real(n*(n+1))/2.
      c0=b0*dt
      d0=real(n)
      f0=a0*d0-b0*c0
      aa=( d0*b1-b0*b2)/f0
      bb=(-c0*b1+a0*b2)/f0
      do i=1,n
       x(i)=x(i)-aa*real(i)*dt-bb
      enddo
      return
      end
ccccc
	subroutine seg2read1(xx,nch,nn,nch0,nn0,filen,kbn,dt)
c xx(nn,nch): output array of data
c nch       : number of trace (output)
c nn        : number of samples per trace (output)
c nch0,nn0  : declared array size
c filen     : input file name (SEG2 format)
c kbn       : kiban(unit number) allocated to the input file
c
c l_kbn     : kiban(unit number) allocated to the log file (6 means console)
c
c Made by Toshiaki Yokoi (IISEE, BRI, Japan), APR. 19, 2011.
c Revised by             "                    APR. 11, 2017.
c Modified for GEOPSY export sg2 format       Aug. 13, 2017
      real*8  xx(nn0,nch0),fraction
      integer*8 ix(0:4095)
      integer*8 revnum,pointerbytecount,numtrace,
     *        stringtermcount,stringterm1,stringterm2,linetermcount,
     *        lineterm1,lineterm2,tracepointers(96),
     *        blockleng,datalength,numsamples,datatype,w_kbn,
     *        string_file_len,string_trace_len,n(0:49),nnn
      character filen*80,cx(0:4095)*1,string_file*1000,
     *          string_trace*1000,s(0:49)*30,cform*80 
      character cdate*11,ctime*8,camp_recovery*80,client*80,
     *          company*80,cinstrument*80,cline_id*80,cobserver*80,
     *          cpdate*11,cptime*8,crawrecord*80,creciever*80,
     *          creciever_specs*80,csource*80,ct_sort*80,cunits*10,
     *          cnote*200,cnote1*200,ct_type*80
c common blocks
c     COMMON /FACTOR/descale
      data w_kbn/6/ nnn/256_8/
      data l_kbn/6/
      data n/0,16,16,12,18,18,10,9,14,6,7,5,5,16,26,23,22,12,10,
     *       16,15,10,6,7,14,15,8,8,15,15,10,9,17,17,14,23,15,
     *        20,4,7,15,15,21,5,18,10,10,5,4,7/
      data s/'','ACQUISITION_DATE','ACQUISITION_TIME','ALIAS_FILTER',
     *       'AMPLITUDE_RECOVERY','BAND_REJECT_FILTER','CDP_NUMBER',
     *       'CDP_TRACE','CHANNEL_NUMBER','CLIENT',
     *       'COMPANY','DATUM','DELAY','DESCALING_FACTOR',
     *       'DIGITAL_BAND_REJECT_FILTER','DIGITAL_HIGH_CUT_FILTER',
     *       'DIGITAL_LOW_CUT_FILTER','END_OF_GROUP','FIXED_GAIN',
     *       'GENERAL_CONSTANT','HIGH_CUT_FILTER','INSTRUMENT',
     *       'JOB_ID','LINE_ID','LOW_CUT_FILTER',
     *       'NOTCH_FREQUENCY','OBSERVER','POLARITY',
     *       'PROCESSING_DATE','PROCESSING_TIME','RAW_RECORD',
     *       'RECEIVER ','RECEIVER_GEOMETRY','RECEIVER_LOCATION',
     *   'RECEIVER_SPECS','RECEIVER_STATION_NUMBER','SAMPLE_INTERVAL',
     *       'SHOT_SEQUENCE_NUMBER','SKEW','SOURCE ',
     *    'SOURCE_GEOMETRY','SOURCE_LOCATION','SOURCE_STATION_NUMBER',
     *       'STACK','STATIC_CORRECTIONS','TRACE_SORT',
     *       'TRACE_TYPE','UNITS','NOTE','       '/
      s(49)=char(78)//char(0)//char(79)//char(0)//char(84)
     *                                 //char(0)//char(69)
c     write(6,*)filen
      open(kbn,file=filen,access='direct',recl=4,form='unformatted')
c read File Descriptor Block
c     write(6,*)'read File Descriptor Block'
      do i=1,32,4
       i0=(i-1)/4+1
       read(kbn,rec=i0) (cx(i-1+ii),ii=0,3)
      enddo
      do ii=0,31
       ix(ii)=ichar(cx(ii))
      enddo
      if(ix(0).eq.58) then    ! 58=3ah
       write(w_kbn,*)'Byte reversed data not allowed.'	
       stop
      else if (ix(0).ne.85.or.ix(1).ne.58) then   ! 85=55h
       write(6,*)'File Descriptor Block'
       write(w_kbn,*)'Not SEG-2 data, can not continue',ix(0),ix(1)
       stop
      endif
c blockid=3a55h: PC==> 55h first (low byte first order) 
      revnum=ix(2)+ix(3)*256
c     write(l_kbn,'(a18,i3)')' revision number =',revnum
      pointerbytecount=ix(4)+ix(5)*256
c      write(l_kbn,'(a34,i3)')
c     *    ' Size of Trace Pointer Sub-block =',pointerbytecount
      numtrace=ix(6)+ix(7)*256
c      write(l_kbn,'(a32,i3)')' Number of traces in this file =',
c     *                                              numtrace
      stringtermcount=ix(8)
c     write(l_kbn,'(a28,i3)')
c    *              ' Size of String Terminator =',stringtermcount
      stringterm1=ix(9)
cyokoi      write(6,*)stringtermcount,stringterm1,ix(10)
      if(stringtermcount.eq.1) then
       if(stringterm1.eq.0) then  
c        write(l_kbn,'(a30,a3)')' String Terminator Character =','00h'
       else
c        write(l_kbn,'(a30,i3)')' String Terminator Character ='
c     *                                                   ,stringterm1
       endif
      else if(stringtermcount.eq.2) then
       stringterm2=ix(10)
c      write(l_kbn,'(a40,2i3)')
c	*   ' 1st & 2nd String Terminator Character ='
c    *                     ,stringterm1,stringterm2
      endif
      linetermcount=ix(11)
c     write(l_kbn,'(a26,i4)')' Size of Line Terminator =',linetermcount
      lineterm1=ix(12)
      if(linetermcount.eq.1) then
       if(lineterm1.eq.10) then			 ! 10=1Ah "Line Feed"
c       write(l_kbn,'(a28,a2)')' Line Terminator Character =','LF'
       else if(lineterm1.eq.13) then		 ! 13=1Dh "Caridge Return"
c       write(l_kbn,'(a28,a2)')' Line Terminator Character =','CR'
       else
c       write(l_kbn,'(a28,i3)')' Line Terminator Character =',lineterm1
       endif
      else if(linetermcount.eq.2) then
       lineterm2=ix(13)
c      write(l_kbn,'(a38,2i4)')' 1st & 2nd Line Terminator Character =',
c    *                    lineterm1,lineterm2
      endif
c Byte 14 - 31 are reserved and then skipped.
c read trace pointer sub-block
c     write(6,*)'read trace pointer sub-block'
      do i=33,36+(4*(numtrace-1)),4
       i0=(i-1)/4+1
       read(kbn,rec=i0) (cx(i-33+ii),ii=0,3)
	enddo
      do ii=0,numtrace*4-1   ! ch number * 4
       ix(ii)=ichar(cx(ii))
	enddo
      do i=33,36+(4*(numtrace-1)),4
	 i0=(i-1)/4+1
c       write(l_kbn,*)i0-8,(ix(i-33+ii),ii=0,3)
       j=i-33
       tracepointers(i0-8)=
     *          ix(j)+ix(j+1)*256+ix(j+2)*256**2+ix(j+3)*nnn**3
c      write(6,*)i0-8,tracepointers(i0-8)
      enddo
c read Strings. Length is (tracepointers(1)-pointerbytecount-32)/4 bytes
      do i=1,(tracepointers(1)-pointerbytecount-32)/4
	 i0=8+numtrace+i
       read(kbn,rec=i0) (cx(4*(i-1)+ii),ii=0,3)
	enddo
      do ii=0,tracepointers(1)-pointerbytecount-33
       ix(ii)=ichar(cx(ii))
      enddo
c										c	write(l_kbn,*)(ix(ii),ii=0,tracepointers(1)-pointerbytecount-33)
c	write(l_kbn,*)
c     *  (char(ix(ii)),ii=0,tracepointers(1)-pointerbytecount-33)
c It was detected that Geode files do not follow exactly SEG2 format 
c for Strings in File Descriptor Blcok. String is empty.
      do ii=0,tracepointers(1)-pointerbytecount-33
	 string_file(ii+1:ii+2)=char(ix(ii))
      enddo
      string_file_len=tracepointers(1)-pointerbytecount-32
c     write(l_kbn,*)string_file(1:string_file_len)
c read Trace Descriptor Block
c It was detected that the size of the trace descriptor bock of the seg2 
c files exported from GEOPSY is not always a multiples of 4 bytes
c      write(6,*)'read Trace Descriptor Block'
      do ich=1,numtrace
c       write(l_kbn,'(a16,i2,a3,i8)')
c     *       ' Trace pointers(',ich,') =',tracepointers(ich)
       i0=tracepointers(ich)/4
       i_rest=mod(tracepointers(ich),4)
caug   do i=1,8          ! 8 words * 4byte
       do i=1,9          ! 9 words * 4byte
        read(kbn,rec=i0+i)(cx(4*(i-1)+ii),ii=0,3)
       enddo
caug from here
       do ii=0,31
        cx(ii)=cx(ii+i_rest)
       enddo
caug to here
       do ii=0,31        ! 8byte
        ix(ii)=ichar(cx(ii))
       enddo
       if(ix(0).eq.68.and.ix(1).eq.34) then    ! 34=22h,68=44h
        write(w_kbn,*)'Byte reversed data not allowed.'	
        stop
       else if (ix(0).ne.34.or.ix(1).ne.68) then   ! 68=44h
        write(6,*)'Trace Descriptor Block'
        write(w_kbn,*)'Not SEG-2 data can not continue',ix(0),ix(1)
        stop
       endif
c      write(l_kbn,*)(ix(ii),ii=0,3)
       blockleng=ix(2)+ix(3)*256
c     write(l_kbn,'(a34,i2,a2,i4)')
c     write(6,'(a34,i2,a2,i4)')
c    *   ' Size of Trace Descriptor Block ( ',1,')=',blockleng
c      write(l_kbn,*)(ix(ii+4),ii=0,3)
       datalength=ix(4)+ix(5)*256+ix(6)*256**2+ix(7)*nnn**3
c     write(l_kbn,'(a35,i8)')
c     write(6,'(a35,i8)')
c    *              ' Size of Corresponding Data Block =',datalength
c      write(l_kbn,*)(ix(ii+8),ii=0,3)
       numsamples=ix(8)+ix(9)*256+ix(10)*256**2+ix(11)*nnn**3
c      write(l_kbn,'(a34,i8)')
c     write(6,'(a34,i8)')
c    *               ' Number of Samples in Data Block =',numsamples
       datatype=ix(12)
c      write(l_kbn,'(a19,i8)')' Data Format Code =',datatype
       if(datatype.eq.1) then
        if(ich.eq.1) write(l_kbn,'(19x,a22)')':16bit fixed point.   '
       else if(datatype.eq.2) then
        if(ich.eq.1) write(l_kbn,'(19x,a22)')':32bit fixed point.   '
       else if(datatype.eq.3) then
        if(ich.eq.1) write(l_kbn,'(19x,a22)')':20bit fixed point.   '
       else if(datatype.eq.4) then
        if(ich.eq.1) write(l_kbn,'(19x,a22)')':32bit floating point.'
       else if(datatype.eq.5) then
        if(ich.eq.1) write(l_kbn,'(19x,a22)')':64bit floating point.'
       else
        write(w_kbn,'(a10,i1,a18)')' Data Type', datatype,
     *                         ' is not available.' 
        stop
       endif 
c Byte 13-31 are reserved and then skipped.
c       write(l_kbn,'(i8)') blockleng,blockleng-32
       if(ich.eq.1) then    ! trace discriptor block for 1st channel
c read Strings. Length is blockleng-32 bytes
caug    do i=1,(blockleng-32)/4
        do i=1,(blockleng-32)/4+1
         read(kbn,rec=i0+8+i)(cx(4*(i-1)+ii),ii=0,3)
        enddo
caug from here
        do ii=0,blockleng-32
         cx(ii)=cx(ii+i_rest)
        enddo
caug to here
c       write(l_kbn,*)(cx(ii),ii=0,blockleng-33)
        do ii=0,blockleng-33
         ix(ii)=ichar(cx(ii))	
        enddo
c	write(l_kbn,*)(char(ix(ii)),ii=0,blockleng-33)
        do ii=0,blockleng-33
	 string_trace(ii+1:ii+2)=char(ix(ii))
        enddo
        string_trace_len=blockleng-32
c       write(l_kbn,*)string_trace(1:string_trace_len)
c       write(6,*)'string_trace_len=',string_trace_len
       endif
c read data block
c      write(6,*)'read data block'
       if(datatype.eq.1)      then  ! 16bit fixed point
        write(w_kbn,*)' This data type is not available yet.',datatype
        stop
       else if(datatype.eq.2) then  ! 32bit fixed point
caug from here
        i_rest=mod(tracepointers(ich),4)+mod(blockleng,4)
caug to here
        do i=1,numsamples 
caug from here
         read(kbn,rec=i0+blockleng/4+i)  (cx(ii),ii=0,3)
         if(i_rest.ne.0) then
          read(kbn,rec=i0+blockleng/4+i+1)(cx(ii),ii=4,7)
          do ii=0,3
           cx(ii)=cx(ii+i_rest)
          enddo
         endif
caug to here
         do ii=0,3
          ix(ii)=ichar(cx(ii))
         enddo
c        write(l_kbn,*)i,ix(3)/128,(ix(ii),ii=3,0,-1)
         if(ix(3).lt.128) then	  ! Positive value
          xx(i,ich)
     *    =dble( mod(ix(3),128)*256**3+ix(2)*256**2+ix(1)*256+ix(0) )
         else if(ix(3).ge.128) then ! Negative value
          xx(i,ich)
     *	=dble(-nnn**4+ix(3)*256**3+ix(2)*256**2+ix(1)*256+ix(0))
         endif
        enddo
       else if(datatype.eq.3) then  ! 20bit floating point
        write(w_kbn,*)' This data type is not available yet.',datatype
        stop
       else if(datatype.eq.4) then  ! 32bit floating point
caug from here
        i_rest=mod(tracepointers(ich),4)+mod(blockleng,4)
caug to here
        do i=1,numsamples 
caug from here
         read(kbn,rec=i0+blockleng/4+i)  (cx(ii),ii=0,3)
         if(i_rest.ne.0) then
          read(kbn,rec=i0+blockleng/4+i+1)(cx(ii),ii=4,7)
          do ii=0,3
           cx(ii)=cx(ii+i_rest)
          enddo
         endif
caug to here
         do ii=0,3
          ix(ii)=ichar(cx(ii))
         enddo
         if(ix(3).lt.128) then
          n_sign=0
         else if(ix(3).ge.128) then
          n_sign=1
         endif
c       write(l_kbn,*)i,ix(3)/128,(ix(ii),ii=3,0,-1)
         n_exponent=mod(ix(3),128)*2+ix(2)/128
         n_fraction=mod(ix(2),128)*256**2+ix(1)*256+ix(0)
         fraction=1.D0+dble(n_fraction)/dble(256**3)
         xx(i,ich)
     *   =dble((-1)**n_sign)*fraction*2.**dble(n_exponent-127)
c       write(6,*)ich,i,xx(i,ich)
        enddo
       else if(datatype.eq.5) then  !  64 bit floating point
        write(w_kbn,*)' This data type is not available yet.',datatype
        stop
       endif
      enddo
c======S
c
c     write(6,*)'Interpretation of File Discriptor Block'
c
c======E
	nch=numtrace
	nn =numsamples
c Interpretation of strings. 
c Note that Geode files do not follow exactly 
c SEG2 format for strings. Strings do not start with the offset to the 
c next string. They start with two continuous "00h" and end with the string
c terminator that is "00h".
c The string 'NOTE' included in the file descriptor block starts without 
c '00h'.Moreover the strings that should be included in the file descriptor 
c block are stored in the trace descriptor block, e. g., ACQUISITION_DATE etc.
c
c strings of file desriptor blocks
c      write(6,*)' strings of file desriptor blocks'
c
      ist=0
      kkn=0
      kks=1
   90 if(kks.ge.49) goto 190
      do kk=kks,49
       do ii=1,string_file_len-n(kk)+1
        if(string_file(ii:ii+n(kk)-1).eq.s(kk)(1:n(kk))) then
         ist=ii
         kkn=kk
         goto 94
        endif
       enddo
c      write(6,*)s(kk)(1:n(kk)),' is not found'
       kks=kks+1
       go to 90
   94  continue
       do ii=ist+1,string_file_len
        if(   ichar(string_file(ii:ii)).eq.stringterm1.
     *     or.ichar(string_file(ii:ii)).eq.stringterm2) then
         ied=ii-1
         goto 100
        endif
       enddo
      enddo
  100 n_rest=ied-ist-n(kkn)
c
      write(cform,'(a2,i3,a1)')'(a',n_rest,')'
c     write(l_kbn,*)
c     write(6,*)
c    * kkn,n(kkn),ist,ied,string_file(ist:ied),n_rest  ! ,cform
      if(kkn.lt.10) then
       if(kkn.eq.1) then                     ! 1 'ACQUISITION_DATE', cdate*11
	  read(string_file(ied-n_rest+1:ied),cform) cdate
c       write(l_kbn,*)string_file(ist:ied),' ',cdate
       else if(kkn.eq.2) then                ! 2 'ACQUISITION_TIME', ctime*8
	  read(string_file(ied-n_rest+1:ied),cform) ctime
c	  write(l_kbn,*)string_file(ist:ied),' ',ctime
       else if(kkn.eq.9) then                ! 9 'CLIENT'	,client*80
	  read(string_file(ied-n_rest+1:ied),cform) client
c       write(l_kbn,*)string_file(ist:ied),' ',client 
       endif
      else if(kkn.lt.20) then
       if(kkn.eq.10) then                     ! 10 'COMPANY',company*80
	  read(string_file(ied-n_rest+1:ied),cform) company
c       write(l_kbn,*)string_file(ist:ied),' ',company 
       else if(kkn.eq.19) then                ! 19 'GENERAL_CONSTANT'
	  read(string_file(ied-n_rest+1:ied),*) g_const
c       write(l_kbn,*)string_file(ist:ied),' ',g_const      
       endif
      else if(kkn.lt.30) then
       if(kkn.eq.21) then                     ! 21 'INSTRUMENT',cinstrument*80
	  read(string_file(ied-n_rest+1:ied),cform) cinstrument
c       write(l_kbn,*)string_file(ist:ied),' ',cinstrument 
       else if(kkn.eq.22) then                ! 22 'JOB_ID'
 	  read(string_file(ied-n_rest+1:ied),cform) filen
        read(filen,*) job_id
c       write(l_kbn,*)string_file(ist:ied),' ',job_id 
       else if(kkn.eq.26) then                ! 26 'OBSERVER',cobserver*80
	  read(string_file(ied-n_rest+1:ied),cform) cobserver
c       write(l_kbn,*)string_file(ist:ied),' ',cobserver 
       else if(kkn.eq.28) then                ! 28 'PROCESSING_DATE',cpdate*11
	  read(string_file(ied-n_rest+1:ied),cform) cpdate
c	  write(l_kbn,*)string_file(ist:ied),' ',cpdate
       else if(kkn.eq.29) then                ! 29 'PROCESSING_TIME',cptime*8
	  read(string_file(ied-n_rest+1:ied),cform) cptime
c	  write(l_kbn,*)string_file(ist:ied),' ',cptime
       endif
      else if(kkn.lt.50) then
       if(kkn.eq.45) then                      ! 45 'TRACE_SORT',ct_sort*80
	  read(string_file(ied-n_rest+1:ied),cform) ct_sort
c	  write(l_kbn,*)string_file(ist:ied),' ',ct_sort
       else if(kkn.eq.47) then                ! 47 'UNITS',cunits*10
	  read(string_file(ied-n_rest+1:ied),cform) cunits
c	  write(l_kbn,*)string_file(ist:ied),' ',cunits
       else if(kkn.eq.48) then                ! 48 'NOTE',cnote*200
        if(n_rest.le.0) then
         cnote='                                    '
        else
	   read(string_file(ied-n_rest+1:ied),cform) cnote
        endif
c        write(l_kbn,*)string_file(ist:ied),' ',cnote
       else if(kkn.eq.49) then                ! 49 'N O T E',cnote1*200
        if(n_rest.le.0) then
         cnote1='                                    '
        else
        read(string_file(ied-n_rest+1:ied),cform) cnote1
        endif
c        write(l_kbn,*)string_file(ist:ied),' ',cnote1
       endif
      else
       stop
      endif
      kks=kks+1
      goto 90
  190 continue
c strings of the trace descriptor blocks
c     write(6,*)'Interpretation of Trace Discriptor Block'
c     write(6,*)'Only the 1st trace'
c
      ist=0
      kkn=0
      kks=1
  194 if(kks.ge.49) goto 290
      do kk=kks,49
       do ii=1,string_trace_len-n(kk)+1
        if(string_trace(ii:ii+n(kk)-1).eq.s(kk)(1:n(kk))) then
         ist=ii
         kkn=kk
         goto 196
        endif
       enddo
c      write(6,*)s(kk)(1:n(kk)),' is not found'
       kks=kks+1
       go to 194
  196  continue
       do ii=ist+1,string_trace_len
        if(   ichar(string_trace(ii:ii)).eq.stringterm1.
     *     or.ichar(string_trace(ii:ii)).eq.stringterm2) then
         ied=ii-1
         goto 200
        endif
       enddo
      enddo
  200 n_rest=ied-ist-n(kkn)
c
      write(cform,'(a2,i3,a1)')'(a',n_rest,')'
c     write(l_kbn,*)
c     write(6,*)
c    *          kkn,n(kkn),ist,ied,string_trace(ist:ied),n_rest ! ,cform
      if(kkn.lt.10) then
       if(kkn.eq.1) then                     ! 1 'ACQUISITION_DATE', cdate*11
	  read(string_trace(ied-n_rest+1:ied),cform) cdate
c	  write(l_kbn,*)string_trace(ist:ied),' ',cdate
       else if(kkn.eq.2) then                ! 2 'ACQUISITION_TIME', ctime*8
	  read(string_trace(ied-n_rest+1:ied),cform) ctime
c       write(l_kbn,*)string_trace(ist:ied),' ',ctime 
       else if(kkn.eq.3) then                ! 3 'ALIAS_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) alf_freq,alf_slope
c       write(l_kbn,*)string_trace(ist:ied),' ',alf_freq,alf_slope
       else if(kkn.eq.4) then                ! 4 'AMPLITUDE_RECOVERY',camp_recovery*80
	  read(string_trace(ied-n_rest+1:ied),cform) camp_recovery
c         write(6,*)cform,camp_recovery
c       write(l_kbn,*)string_trace(ist:ied),' ',camp_recovery
       else if(kkn.eq.5) then                ! 5 'BAND_REJECT_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) 
     *                              br_lp_fr,br_lp_sl,br_hp_fr,br_hp_sl
c       write(l_kbn,*)string_trace(ist:ied),' ',
c    *                              br_lp_fr,br_lp_sl,br_hp_fr,br_hp_sl
       else if(kkn.eq.6) then                ! 6 'CDP_NUMBER'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
	  read(filen,*) n_cdp
c       write(l_kbn,*)string_trace(ist:ied),' ',n_cdp
       else if(kkn.eq.7) then                ! 7 'CDP_TRACE'
	  read(string_trace(ied-n_rest+1:ied),cform)filen
	  read(filen,*) n_cdp_trace
c       write(l_kbn,*)string_trace(ist:ied),' ',n_cdp_trace
       else if(kkn.eq.8) then                ! 8 'CHANNEL_NUMBER'
        read(string_trace(ied-n_rest+1:ied),cform)filen
        read(filen,*) n_channel
c       write(l_kbn,*)string_trace(ist:ied),' ',n_channel
       else if(kkn.eq.9) then                ! 9 'CLIENT'	,client*80
	  read(string_trace(ied-n_rest+1:ied),cform) client
c        write(l_kbn,*)string_trace(ist:ied),' ',client 
       endif
      else if(kkn.lt.20) then
       if(kkn.eq.10) then                     ! 10 'COMPANY',company*80
	  read(string_trace(ied-n_rest+1:ied),cform) company
c       write(l_kbn,*)string_trace(ist:ied),' ',company 
       else if(kkn.eq.11) then                ! 11 'DATUM'
	  read(string_trace(ied-n_rest+1:ied),cform)filen
	  read(filen,*) datum
c       write(l_kbn,*)string_trace(ist:ied),' ',datum
       else if(kkn.eq.12) then                ! 12 'DELAY'
	  read(string_trace(ied-n_rest+1:ied),*) delay
c       write(l_kbn,*)string_trace(ist:ied),' ',delay
       else if(kkn.eq.13) then                ! 13 'DESCALING_FACTOR'
	  read(string_trace(ied-n_rest+1:ied),*) descale
c       write(l_kbn,*)string_trace(ist:ied),' ',descale
       else if(kkn.eq.14) then                ! 14 'DIGITAL_BAND_REJECT_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) 
     *                          dbr_lp_fr,dbr_lp_sl,dbr_hp_fr,dbr_hp_sl
c       write(l_kbn,*)string_trace(ist:ied),' ',
c    *                          dbr_lp_fr,dbr_lp_sl,dbr_hp_fr,dbr_hp_sl
       else if(kkn.eq.15) then                ! 15 'DIGITAL_HIGH_CUT_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) dhc_freq,dhc_slope
c       write(l_kbn,*)string_trace(ist:ied),' ',dhc_freq,dhc_slope
       else if(kkn.eq.16) then                ! 16 'DIGITAL_LOW_CUT_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) dlc_freq,dlc_slope
c       write(l_kbn,*)string_trace(ist:ied),' ',dlc_freq,dlc_slope
       else if(kkn.eq.17) then                ! 17 'END_OF_GROUP'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*)nd_of_group
c       write(l_kbn,*)string_trace(ist:ied),' ',nd_of_group
       else if(kkn.eq.18) then                ! 18 'FIXED_GAIN'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*)nfgain
c       write(l_kbn,*)string_trace(ist:ied),' ',nfgain
       else if(kkn.eq.19) then                ! 19 'GENERAL_CONSTANT'
	  read(string_trace(ied-n_rest+1:ied),*) g_const
c       write(l_kbn,*)string_trace(ist:ied),' ',g_const      
       endif
      else if(kkn.lt.30) then
	 if(kkn.eq.20) then                     ! 20 'HIGH_CUT_FILTER'
c       write(6,*)string_trace(ist:ied),ist,ied
	  read(string_trace(ied-n_rest+1:ied),*) hc_freq,hc_slope
c       write(l_kbn,*)string_trace(ist:ied),' ',hc_freq,hc_slope
       else if(kkn.eq.21) then                ! 21 'INSTRUMENT',cinstrument*80
	  read(string_trace(ied-n_rest+1:ied),cform) cinstrument
c       write(l_kbn,*)string_trace(ist:ied),' ',cinstrument 
       else if(kkn.eq.22) then                ! 22 'JOB_ID'
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) job_id
c       write(l_kbn,*)string_trace(ist:ied),' ',job_id      
	 else if(kkn.eq.23) then                ! 23 'LINE_ID',cline_id*80
	  read(string_trace(ied-n_rest+1:ied),cform) cline_id
c       write(l_kbn,*)string_trace(ist:ied),' ',cline_id 
       else if(kkn.eq.24) then                ! 24 'LOW_CUT_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) lc_freq,lc_slope
c       write(l_kbn,*)string_trace(ist:ied),' ',lc_freq,lc_slope
       else if(kkn.eq.25) then                ! 25 'NOTCH_FREQUENCY'
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) an_fr
c       write(l_kbn,*)string_trace(ist:ied),' ',an_fr      
       else if(kkn.eq.26) then                ! 26 'OBSERVER',cobserver*80
	  read(string_trace(ied-n_rest+1:ied),cform) cobserver
c       write(l_kbn,*)string_trace(ist:ied),' ',cobserver 
       else if(kkn.eq.27) then                ! 27 'POLARITY'
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) n_polarity
c       write(l_kbn,*)string_trace(ist:ied),' ',n_polarity      
       else if(kkn.eq.28) then                ! 28 'PROCESSING_DATE',cpdate*11
	  read(string_trace(ied-n_rest+1:ied),cform) cpdate
c	  write(l_kbn,*)string_trace(ist:ied),' ',cpdate
       else if(kkn.eq.29) then                ! 29 'PROCESSING_TIME',cptime*8
	  read(string_trace(ied-n_rest+1:ied),cform) cptime
c	  write(l_kbn,*)string_trace(ist:ied),' ',cptime
       endif
      else if(kkn.lt.40) then
	 if(kkn.eq.30) then                     ! 30 'RAW_RECORD',crawrecord*80
	  read(string_trace(ied-n_rest+1:ied),cform) crawrecord
c	  write(l_kbn,*)string_trace(ist:ied),' ',crawrecord
       else if(kkn.eq.31) then                ! 31 'RECEIVER ',creciever*80
	  read(string_trace(ied-n_rest+1:ied),cform) creciever
c	  write(l_kbn,*)string_trace(ist:ied),' ',creciever
       else if(kkn.eq.32) then                ! 32 'RECEIVER_GEOMETRY'
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) r_geometry
c       write(l_kbn,*)string_trace(ist:ied),' ',r_geometry      
       else if(kkn.eq.33) then                ! 33 'RECEIVER_LOCATION'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
	  read(filen,*)r_location
c        write(l_kbn,*)string_trace(ist:ied),' ',r_location      
       else if(kkn.eq.34) then                ! 34 'RECEIVER_SPECS',creciever_specs*80
	  read(string_trace(ied-n_rest+1:ied),cform) creciever_specs
c	  write(l_kbn,*)string_trace(ist:ied),' ',creciever_specs
       else if(kkn.eq.35) then                ! 35 'RECEIVER_STATION_NUMBER'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) n_rstn
c       write(l_kbn,*)string_trace(ist:ied),' ',n_rstn      
       else if(kkn.eq.36) then                ! 36 'SAMPLE_INTERVAL'
	  read(string_trace(ied-n_rest+1:ied),*) dt
c       write(l_kbn,*)string_trace(ist:ied),' ',dt      
c       write(6,*)string_trace(ist:ied),' ',dt      
       else if(kkn.eq.37) then                ! 37 'SHOT_SEQUENCE_NUMBER'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) n_ssn
c       write(l_kbn,*)string_trace(ist:ied),' ',n_ssn      
       else if(kkn.eq.38) then                ! 38 'SKEW'
	  read(string_trace(ied-n_rest+1:ied),*) skew
c       write(l_kbn,*)string_trace(ist:ied),' ',skew      
       else if(kkn.eq.39) then                ! 39 'SOURCE ',csource*80
	  read(string_trace(ied-n_rest+1:ied),cform) csource
c       write(l_kbn,*)string_trace(ist:ied),' ',csource      
       endif
      else if(kkn.lt.50) then
	 if(kkn.eq.40) then                     ! 40 'SOURCE_GEOMETRY'
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) s_geometry
c       write(l_kbn,*)string_trace(ist:ied),' ',s_geometry      
       else if(kkn.eq.41) then                ! 41 'SOURCE_LOCATION'
	  read(string_trace(ied-n_rest+1:ied),*) s_location
c       write(l_kbn,*)string_trace(ist:ied),' ',s_location
       else if(kkn.eq.42) then                ! 42 'SOURCE_STATION_NUMBER'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) n_sstn
c       write(l_kbn,*)string_trace(ist:ied),' ',n_sstn      
       else if(kkn.eq.43) then                ! 43 'STACK'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) n_stack
c       write(l_kbn,*)string_trace(ist:ied),' ',n_stack      
       else if(kkn.eq.44) then                ! 44 'STATIC_CORRECTIONS'
	  read(string_trace(ied-n_rest+1:ied),*) 
     *                              s_st_correct,r_st_correct,st_correct
c       write(l_kbn,*)string_trace(ist:ied),' ',
c    *                              s_st_correct,r_st_correct,st_correct
       else if(kkn.eq.45) then                ! 45 'TRACE_SORT',ct_sort*80
	  read(string_trace(ied-n_rest+1:ied),cform) ct_sort
c	  write(l_kbn,*)string_trace(ist:ied),' ',ct_sort
       else if(kkn.eq.46) then                ! 46 'TRACE_TYPE',ct_type
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
	  read(filen,*)ct_type
c       write(l_kbn,*)string_trace(ist:ied),' ',ct_type      
       else if(kkn.eq.47) then                ! 47 'UNITS',cunits*10
	  read(string_trace(ied-n_rest+1:ied),cform) cunits
c	  write(l_kbn,*)string_trace(ist:ied),' ',cunits
       else if(kkn.eq.48) then                ! 48 'NOTE',cnote*200
        if(n_rest.le.0) then
         cnote='                                    '
        else
	   read(string_trace(ied-n_rest+1:ied),cform) cnote
        endif
c       write(l_kbn,*)string_trace(ist:ied),' ',cnote
       else if(kkn.eq.49) then                ! 49 'N O T E',cnote1*200
        if(n_rest.le.0) then
         cnote1='                                    '
        else
	   read(string_trace(ied-n_rest+1:ied),cform) cnote1
        endif
c       write(l_kbn,*)string_trace(ist:ied),' ',cnote1
       endif
      else
       stop
      endif
      kks=kkn+1
      goto 194
  290 continue
cccc
c     write(6,*)'After #290'
c     stop
cccc
c
  999 continue
c
	close(kbn)
	if(w_kbn.ne.6) close(w_kbn)
      return
	end
ccccc
